#Download base image ubuntu
FROM ubuntu:latest

# LABEL about the custom image
LABEL maintainer="alarmiator-server dev-team"
LABEL version="0.1"
LABEL description="This is custom Docker Image \
to execute the ALARMiator-Server based on Ubuntu."

# Disable Prompt During Packages Installation
ARG DEBIAN_FRONTEND=noninteractive

# set WORKDIR
WORKDIR /alarmiatorserver

# Update Ubuntu Software repository and install node.js, npm, python2, ghostscript, libgs-dev
RUN apt-get update -y && apt-get upgrade -y 
RUN apt-get install -y apt-utils python2 curl libcups2-dev git gcc g++ make
RUN curl -sL https://deb.nodesource.com/setup_12.x | sudo bash -
RUN apt-get install -y nodejs
RUN apt-get autoremove -y

# prepare Environment
RUN update-alternatives --install /usr/bin/python python /usr/bin/python2 1
RUN PATH=”$PATH:/usr/bin/python2”
RUN PATH=”$PATH:/usr/bin/python”

# copy content alarmiatorserver-repo to image
COPY / /alarmiatorserver/

# install pm2 global
RUN npm install sqlite3
RUN npm install pm2 -g

# install needed packages
RUN npm install

# used ports
EXPOSE 5000
EXPOSE 5010
EXPOSE 5020
EXPOSE 5443
EXPOSE 40510

# start alarmiator-server
CMD ["pm2-runtime", "alarmiator_pm2.yml"]
