import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatIconModule } from '@angular/material/icon';
import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { SocketIoModule, SocketIoConfig } from 'ngx-socket-io';
import { OperationKeywordComponent } from './operation-keyword/operation-keyword.component';
import { OperationStopwatchComponent } from './operation-stopwatch/operation-stopwatch.component';
import { OperationLocationInfoComponent } from './operation-location-info/operation-location-info.component';
import { OperationMapComponent } from './operation-map/operation-map.component';
import { DashboardComponent } from './dashboard/dashboard.component';
import { WidgetsComponent } from './widgets/widgets.component'
import { GridsterModule } from 'angular-gridster2';
import { TestComponent } from './test/test.component';
import { LeafletModule } from '@asymmetrik/ngx-leaflet';
import { OperationGearComponent } from './operation-gear/operation-gear.component';
import { MatListModule } from '@angular/material/list';
import { FeedbackOverviewComponent } from './feedback-overview/feedback-overview.component';
import { IdleScreenComponent } from './idle-screen/idle-screen.component';
import { SocketIOService } from './services/socket-io.service';
import { GearStatesComponent } from './gear-states/gear-states.component';
import { AuthNeededComponent } from './auth-needed/auth-needed.component';
import { ErrorComponent } from './error/error.component';
import { OperationMessageComponent } from './operation-message/operation-message.component';
import { ClockWidgetComponent } from './clock-widget/clock-widget.component';
import { AssetsMaintenanceComponent } from './assets-maintenance/assets-maintenance.component';
import { MatTableModule } from '@angular/material/table';



@NgModule({
  declarations: [
    AppComponent,
    OperationKeywordComponent,
    OperationStopwatchComponent,
    OperationLocationInfoComponent,
    OperationMapComponent,
    DashboardComponent,
    WidgetsComponent,
    TestComponent,
    OperationGearComponent,
    FeedbackOverviewComponent,
    IdleScreenComponent,
    GearStatesComponent,
    AuthNeededComponent,
    ErrorComponent,
    OperationMessageComponent,
    ClockWidgetComponent,
    AssetsMaintenanceComponent 
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    FormsModule,
    MatGridListModule,
    MatIconModule,
    SocketIoModule,
    GridsterModule,
    LeafletModule,
    MatListModule,
    MatTableModule
  ],
  exports: [
    MatGridListModule
  ],
  providers: [SocketIOService],
  bootstrap: [AppComponent]
})
export class AppModule { }
