import { ChangeDetectionStrategy, Component, OnInit } from '@angular/core';
import { Observable, interval} from 'rxjs';
import { map, distinctUntilChanged } from "rxjs/operators";
import * as moment from "moment"; // using @types/moment


@Component({
  selector: 'app-clock-widget',
  templateUrl: './clock-widget.component.html',
  styleUrls: ['./clock-widget.component.css']
})
export class ClockWidgetComponent implements OnInit {

  time: Observable<string>;
  pageLoaded: any;

  constructor() { }

  ngOnInit(): void {
    this.time = interval(500).pipe( 
      map(() => {
        this.pageLoaded = moment(new Date()); 
        return this.pageLoaded.format("HH:mm:ss");
      })
    );
  }

}
