import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';

@Component({
  selector: 'app-feedback-overview',
  templateUrl: './feedback-overview.component.html',
  styleUrls: ['./feedback-overview.component.css'],
 // encapsulation: ViewEncapsulation.None
})
export class FeedbackOverviewComponent implements OnInit {

  private readonly defaultFeedbackStates: Array<string> = ["keine Rückmeldung", "komme", "komme nicht"];
  feedbackOverview: JSON;
  feedbackStates: Array<String> = this.defaultFeedbackStates;

  constructor(
    private alarmiatorService: ALARMiatorService,
    ) {
      this.alarmiatorService.getFeedbackOverview().subscribe( (feedbackOverview) => { 
        if (feedbackOverview != null) {
          console.log('Feedback Overview received: ' + JSON.stringify(feedbackOverview));
          this.feedbackStates = Object.keys(feedbackOverview);
          this.feedbackOverview = feedbackOverview;

        } else {
          // Feedback reset
          this.feedbackStates = this.defaultFeedbackStates;
          this.feedbackOverview = null;
        }

      })
      
     }

  ngOnInit(): void {
  }

  getQualificationsArrayForObject(qual){
    if (qual != undefined && qual != null) {
      return Object.keys(qual);
    }
    else {
      return [];
    }
  }
}
