import { Component, OnInit } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';

@Component({
  selector: 'app-gear-states',
  templateUrl: './gear-states.component.html',
  styleUrls: ['./gear-states.component.css']
})
export class GearStatesComponent implements OnInit {

  public gearStates: any;
  constructor(
    private alarmiatorService: ALARMiatorService,
    ) {
        this.alarmiatorService.getGearStates().subscribe( (gearStates) => { 
          if (gearStates != null) {
            this.gearStates = gearStates;

          } else {
            this.gearStates = null;
          }

        })
  }

  private _colors = {
    "0": "gray",
    "1": "limegreen",
    "2": "green",
    "3": "orange",
    "4": "red",
    "5": "gray",
    "6": "darkgray",
    "7": "gray",
    "8": "gray",
    "9": "gray",
  };

  ngOnInit(): void {
  }


  getColorForStatusShort(statusShort): string {
      if (statusShort != undefined && statusShort != null) {
        if (this._colors[statusShort] != undefined) {
          return this._colors[statusShort];
        }
        return "transparent";
      }
    }
}
