import { Component, OnInit, ViewEncapsulation } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';

@Component({
  selector: 'app-operation-gear',
  templateUrl: './operation-gear.component.html',
  styleUrls: ['./operation-gear.component.css'],
  encapsulation: ViewEncapsulation.Emulated
})
export class OperationGearComponent implements OnInit {

  public gear: [];
  public operation: {};

  constructor(private alarmiatorService: ALARMiatorService) {

    this.alarmiatorService.getOperations().subscribe( (operation) => { 
      this.operation = operation;
      console.log('Operation recieved: ' + JSON.stringify(this.operation));
      if (operation.gear != null && operation.gear != undefined) {
        this.gear = operation.gear.replace(/-/g, '\u2011').split('\n');
      }
    })
    
  }

  ngOnInit(): void {
  }

}
