import { Component, OnInit } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';
import { MatGridListModule } from '@angular/material/grid-list';
 
export interface Tile {
  color: string;
  cols: number;
  rows: number;
  text: string;
}

@Component({
  selector: 'app-operation-keyword',
  templateUrl: './operation-keyword.component.html',
  styleUrls: ['./operation-keyword.component.css']
})

export class OperationKeywordComponent implements OnInit {

  public keywordCategory: string;
  public keywordRaw: string;
  public keywordName: string;
  public subject: string;
  public operation: {};

  

  constructor(private alarmiatorService: ALARMiatorService) {

    this.alarmiatorService.getOperations().subscribe( (operation) => { 
      this.operation = operation;
      console.log('Operation recieved: ' + JSON.stringify(this.operation));
      var operationObject = JSON.parse(JSON.stringify(this.operation));
      this.keywordCategory = operationObject.keywordCategory;
      this.keywordRaw = operationObject.keywordRaw;
      this.keywordName = operationObject.keywordName;
      this.subject = operationObject.subject;
    })
    
  }

  ngOnInit(): void {
  }

}
