import { Component, OnInit } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';

@Component({
  selector: 'app-operation-location-info',
  templateUrl: './operation-location-info.component.html',
  styleUrls: ['./operation-location-info.component.css']
})
export class OperationLocationInfoComponent implements OnInit {

  public location: string;
  public community: string;
  public street: string;
  public section: string;
  public object: string;
  public operation: object;
  public locationHTML: string;

  constructor(private alarmiatorService: ALARMiatorService) {
    alarmiatorService.getOperations().subscribe( (operation) => { 
      this.operation = operation;
      console.log('Operation recieved: ' + JSON.stringify(this.operation));
      var operationObject = JSON.parse(JSON.stringify(this.operation));
      this.location = operationObject.location;
      this.community = operationObject.community;
      this.street = operationObject.street;
      this.section = operationObject.section;
      this.object = operationObject.object;
      this.locationHTML = this.street + '</br>' + this.location;
    })
    this.locationHTML = '';
    
  }

  ngOnInit(): void {
  }

}
