import { Component, OnInit } from '@angular/core';
import { ALARMiatorService } from '../services/alarmiator.service';
import * as moment from 'moment'; 

@Component({
  selector: 'app-operation-stopwatch',
  templateUrl: './operation-stopwatch.component.html',
  styleUrls: ['./operation-stopwatch.component.css']
})
export class OperationStopwatchComponent implements OnInit {

  public time: string;
  public startDate; // start Date to calculate time from 
  public operation: {};

  public alarmtime;
  public alarmdate;

  private timer; 
  constructor(
    private alarmiatorService: ALARMiatorService,
    ) {
  }

  ngOnInit(): void {
    this.alarmiatorService.getOperations().subscribe( (operation) => { 
      clearInterval(this.timer);
      this.operation = operation;
      console.log('Operation recieved: ' + JSON.stringify(this.operation));
      var operationObject = JSON.parse(JSON.stringify(this.operation));
      this.alarmdate = operationObject.alarmdate;
      this.alarmtime = operationObject.alarmtime;
      
      this.setStartDate();

      this.timer = setInterval(() => {
        this.calculateTimeDifference();
      }, 1000);
    })
  }

  setStartDate() {
    this.startDate = moment(this.alarmtime,"HH:mm").toDate().getTime();
  }

  calculateTimeDifference() {
    
    var date_now = new Date().getTime();

    var seconds = Math.floor((date_now - (this.startDate)) / 1000);
    var minutes = Math.floor(seconds / 60);
    var hours = Math.floor(minutes / 60);
    var days = Math.floor(hours / 24);


    hours = hours - (days * 24);
    minutes = minutes - (days * 24 * 60) - (hours * 60);
    seconds = seconds - (days * 24 * 60 * 60) - (hours * 60 * 60) - (minutes * 60);

    var strHours   = hours.toString();
    var strMinutes = minutes.toString();
    var strSeconds = seconds.toString();
    if (hours < 10) { strHours = '0' + strHours }
    if (minutes < 10) { strMinutes = '0' + strMinutes; }
    if (seconds < 10) { strSeconds = '0' + strSeconds; }

    if (hours > 0) {
      this.time = strHours + ':' + strMinutes + ':' + strSeconds;
    } else {
      this.time = strMinutes + ':' + strSeconds;
    }
    
  }

}
