var fs = require('fs')
var resolve = require('path').resolve
var join = require('path').join
var cp = require('child_process')
var os = require('os')

// get library path
var lib = resolve(__dirname, '../wallboard_app')

console.log('-------------------------------------------');
console.log('----- Wallboard NPM Installer Script ------');
console.log('-------------------------------------------');

fs.readdirSync(lib)
    .forEach(function (mod) {
        
        var modPath = join(lib, mod)
        // ensure path has package.json
        console.log('Checking directory ' + modPath + ' for npm packages to be installed');
        if (!fs.existsSync(join(modPath, 'package.json'))) {
            console.log('no packages to be installed');
            return
        }
        console.log('Packages awaiting install ... --> Starting installer');
        // npm binary based on OS
        var npmCmd = os.platform().startsWith('win') ? 'npm.cmd' : 'npm'

        // install folder
        cp.spawn(npmCmd, ['i'], { env: process.env, cwd: modPath, stdio: 'inherit' })
    })