const express = require('express')
const app = express();

const http = require('http');
const { send } = require('process');
const server = http.Server(app);

const socketIO = require('socket.io');
const io = socketIO(server);

const port = process.env.PORT || 5020;

io.on('connection', (socket) => {
    console.log('Benutzer nun verbunden');
    socket.emit('updateData', '-');
    sendOperation(socket);
    sendFeedback(socket);

    socket.on('disconnect', () => {
        console.log('Benutzerverbindung abgebaut');
    });
    socket.on('message', (msg) => {
        console.log('message: ' + msg);
        socket.emit('updateData', msg);
    });
});

function sendOperation(aSocket) {
    var operation = {
        keyword: 'THL 3 - VU',
        location: 'Weigendorf',
        street: 'Am Hohenschlag 25',
        community: 'Weigendorf',
        object: 'Haus Bauer',
        section: 'Kreuzung',
        lat: 49.49728414267963,
        lon: 11.57058049065144,
        gear: 'FF Hartmannshof\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01\nFL Hartmannshof 55-42-01',
        zveis: '24423, 24133, 24427, 24435, 24005F, 24706F, 24401, 24402'
    }
    aSocket.emit('operation', operation);
}


function sendFeedback(aSocket) {
    var feedback = {
        "success": 1,
        "feedbackStates": [
            {
                "id": 0,
                "stateLabel": "keine Rückmeldung",
                "state": 1,
                "stateColor": "#bababa",
                "order": null
            },
            {
                "id": 1,
                "stateLabel": "komme",
                "state": 1,
                "stateColor": "#00ff00",
                "order": null
            },
            {
                "id": 2,
                "stateLabel": "komme nicht",
                "state": 1,
                "stateColor": "#ff0000",
                "order": null
            }
        ],
        "feedback": [
            {
                "keine Rückmeldung": [

                ]
            },
            {
                "komme": [
                    {
                        "basedataId": 2,
                        "firstname": "Jens",
                        "lastname": "Mustermann",
                        "basedataUUID": "0b1140d0-fe6a-11ea-ae35-0d6d2d2b06b1",
                        "stateId": 1,
                        "feedbackState": 1,
                        "feedbackStateColor": "#00ff00",
                        "feedbackStateLabel": "komme",
                        "feedbackStateSet": "2020-09-24T14:55:55.091Z",
                        "qualificationsList": "AGT,DLK"
                    }
                ]
            },
            {
                "komme nicht": [
                    {
                        "basedataId": 3,
                        "firstname": "Alexander",
                        "lastname": "Hausmann",
                        "basedataUUID": "0b1140d1-fe6a-11ea-ae35-0d6d2d2b06b1",
                        "stateId": 2,
                        "feedbackState": 1,
                        "feedbackStateColor": "#ff0000",
                        "feedbackStateLabel": "komme nicht",
                        "feedbackStateSet": "2020-09-24T14:55:55.091Z",
                        "qualificationsList": ""
                    }
                ]
            }
        ],
        "qualifications": [
            "AGT",
            "GF",
            "DLK"
        ]
    }

    aSocket.emit('feedback', feedback);
}

server.listen(port, () => {
    console.log(`ALARMiator Server Messenger gestartet auf Port: ${port}`);
});

