'use strict'

const fs = require('fs');
const path = require('path');

const data = require('./form.json');
const http = require('http');
const https = require('https');
const WebSocket = require('ws');

const certfile = path.join(__dirname, 'cert', 'cert.pem')
const keyfile = path.join(__dirname, 'cert', 'key.key')
var verbindung

const bodyParser = require('body-parser');
const express = require('express');
const app = express();

const server = http.createServer(app);
app.set('view engine', 'ejs');

/* data.configstore.fields.forEach((entry)=>{
    console.log(entry.fieldname);
    });
 */

const einsatzdaten =
{
    "type":"data",
    "msg":"Alarmierungsdaten erhalten.",
    "statusCode":"alarm_data",
    "statusClass":"success",
    "data":
        {
        "textElements":
        {
            "sds_abschnitt":"",
            "sds_alarmdatum":"27.12.2020",
            "sds_alarmuhrzeit":"19:50:05",
            "sds_einsatzmittel":"KBI Info\nFF Altdorf\nFL Altdorf 120-40-02",
            "sds_einsatznummer":"T 5.2 201226 12865",
            "sds_einsatzort":"Altdorf b.Nürnberg - Altdorf b. Nürnberg",
            "sds_etage":"",
            "sds_freitext":"Probealarm, kein Einsatz",
            "sds_gemeinde":"Altdorf ",
            "sds_ils":"ILS Nürnberg",
            "sds_objekt":"",
            "sds_ortsteil":"Altdorf ",
            "sds_schlagwort_id":"T2723",
            "sds_schlagwort_kategorie":"RD",
            "sds_schlagwort_komplett":"#T2723#RD#Unterstützung",
            "sds_schlagwort_name":"Probealarm",
            "sds_schleifen":"24133, 24435, 24402",
            "sds_stichwort":"THL 1",
            "sds_strasse":"Feuerweg 2",
            "sds_x":"4453560.02",
            "sds_y":"5470946.5"
        }
    }
}

app.use(bodyParser.urlencoded());

app.get('/', (req, res)=>{
    var fields = data.configstore.fields;
    res.render('index.ejs', {fields: fields});
    //res.sendFile(__dirname + '/index.html')
});


app.post('/formresp', function(req, res, next){
    // req.body object has your form values
        for (var prop in req.body){
            if (prop in einsatzdaten.data.textElements){
                einsatzdaten.data.textElements[prop] = req.body[prop];
            };
            //console.log(prop + ' : ' + req.body[prop]);

        };
        console.log(einsatzdaten.data.textElements);
        verbindung.send(JSON.stringify(einsatzdaten));
        res.redirect('/');

 });

server.listen(80, ()=>{
    console.log('Webinterface listening on Port 80')
});

// ------------------------------------ WSS Https Section -------------------------------------------
// heartbeat callback
function heartbeat() {
    this.isAlive = true;
  }

  //Https Server
  const WsApp = https.createServer(
    {
    key: fs.readFileSync(keyfile),
    cert: fs.readFileSync(certfile),
   }).listen(8081);

  // WebSocket Server;
  const wss = new WebSocket.Server({server: WsApp});
  console.log('WSS Server startet, wait for connecton on Port 8081')
  wss.on('connection', function connection(ws, request) {
    console.log('new Data');
    ws.master_token = request.headers.master_token
    ws.sub_token = request.headers.sub_token
    verbindung = ws;

    ws.on('pong', heartbeat);

    ws.on('message', function incoming(message) {
      console.log('received: %s', message);
    });

   ws.on('close', function close(code, reson){
    console.log('socket closed');
    console.log(code);
    console.log(reson);
    });
  });

  wss.on('headers', function incominghead(header, req) {

    //console.log(header);
    //console.log(req.headers);
    console.log(req.headers.master_token);
    console.log(req.headers.sub_token);
  });


  // Timer for ping
  const interval = setInterval(function ping() {
    wss.clients.forEach(function each(ws) {
      if (ws.isAlive === false){
        console.log('Connection Terminated');
        return ws.terminate();
      }
      ws.isAlive = false;
      console.log("Send Ping");
      ws.ping();
    });
  }, 5000);

  wss.on('close', function close() {
    clearInterval(interval);
  });
