var moment = require('moment');
var FCM = require('fcm-node');
const admin = require("firebase-admin");
let serviceAccount = require("./alarmiator-21451d4118e2.json");

admin.initializeApp(
    {credential: admin.credential.cert(serviceAccount)}

)


/* --------------------------------------------------------------------------------------------------------------------- */
/* Setup fAlarm (Android)*/
/* --------------------------------------------------------------------------------------------------------------------- */

var fAlarmServerKey = "AIzaSyB4CKxUDeYC7lU-p0pLsJSJ1kcVRv6AHWk";
var fAlarm = new FCM(fAlarmServerKey);
var fcmKeysAndroid = [
  //  'd1kJKhJR2vI:APA91bF0o11QvZEQaneqRZ7-MvPswrwG_JcF-dHzLbmSqFNnilva8togr8eCPyCp5RKCPpLME3OEETxKqoN9voPKQZ17p6I6t7ba-UGzK3C91DKR023dNszhruW6nocZ6qYDnAcjDykH',
  //  'fRNKUemsdLc:APA91bFCvz_gLM9I-0SHqaHES27SN7HOQtTqNsOiz-Vr2CKNRM_LISjdafStG2CUdCMWf2t9fg9bj5uPLUYXtLS1xqOPciRPVAa6_pw9sSfHbdII3x2-aSbVi4szTcvNCPnNXRtRNhGe'
]

/* --------------------------------------------------------------------------------------------------------------------- */
/* Setup ALARMiator (iOS) */
/* --------------------------------------------------------------------------------------------------------------------- */

var alarmiatorIOSServerKey = "AIzaSyD3AhR0yQSSGWou8SlKryaFm3pZikeo6r4"
var alarmiatorIOS = new FCM(alarmiatorIOSServerKey);

var fcmKeysIOS = [
  //'dKKwhXMPYxw:APA91bGgUQMDwkB87OcZakLKv1paZ9O9EwmIOy06lVkUxIvJptoY-PMNLD-XCN_DiTJLEIM-SznIpMPuBie9PG3Bb-2OYVl6vVk-S-jgTVvXaRqPLGe5LXFTn7B11EgCVVWl4sUQJBiI'
  //'ceJzYUSdcEgetqCpKtnBUH:APA91bF6Ws511sT-7kTAcEAZ_hEz_6MJYND3kfB8uPyiFnqqFeWKP_SW0ZfnVCaIJ2MSy69QGHvrP1u0YHjeIFEmlnj_IsT02l_I1nJbFTjikuwCOG7fCDfZHEdU0D6pTc7bsjDVcAq-'
]

/* --------------------------------------------------------------------------------------------------------------------- */
/* Setup ALARMiator (new App) */
/* --------------------------------------------------------------------------------------------------------------------- */

var alarmiatorNewServerKey = "AAAAqZ9oVaQ:APA91bH8HcwDW5a3_S8QbANFH028dELMHBeA7_eXk8prCDdkxW9iTxynw-krOzGNqhOP_lybZm39TU0yGC8h99uROfmh6cqFGm7B43U1qjNxT8Fg0TBEtmQ7Qu9ISWexCspxt0fNj852"
var alarmiatorNew = new FCM(alarmiatorNewServerKey);

var fcmKeysNew = [
  'df8Zs5eSExY:APA91bGNYu2qrci1l8aOCiQy5NjKhT06TQLHN9m3roTQqeFOKQNZ5U2jz3USKI4IXtMzYvYmI9aPUDVxr-62s4Sy9VfTJ70YpQTXqxup51Dl3GACfJLqasjdnHESu-qjwY06RfgxQ95D'
]

/* --------------------------------------------------------------------------------------------------------------------- */
/* Initalize variables*/
/* --------------------------------------------------------------------------------------------------------------------- */

var organization = "Reichenschwand";
var notificationTitle = "Einsatz für Feuerwehr " + organization;
var title = "Probealarm - THL 1 - Straße reinigen"
var messageBody = "Ort: Am Saueracker 36 - Reichenschwand\n\nEinsatzmittel: \nKBI Info\nFF Reichenschwand\nFL Reichenschwand 60-40-01";
var opKeyword = "THL 1";
var lat = "49.497290";
var lng = "11.570610";
var location = "Reichenschwand"

var date = moment().format('YYYY-MM-DDTHH:mm:ss'); // Current date
var operationId = "" + Math.random().toString(36).substr(2, 9); // Random OperationId for testing


/* --------------------------------------------------------------------------------------------------------------------- */
/* TestOperation */
/* --------------------------------------------------------------------------------------------------------------------- */

const Operation = require('../../models/core/core_operation');

  let operation = new Operation();
  operation.setUUID();
  operation.operationnumber = 'Einsatznummer';
  operation.subject = 'PROBEALARM';
  operation.message = 'Probealarm ausgelöst durch Admin in ALARMiator';
  operation.object = '-';
  operation.operationSourceConnector = 'core';
  operation.operationState = 1;
  operation.section = '-';
  operation.street = 'Grünsberger Straße 2';
  operation.community = 'Altdorf';
  operation.district = 'Grünsberg';
  operation.gear = 'FF Reichenschwand\nFL Reichenschwand 60-40-01';
  operation.keywordCategory = 'PA';
  operation.keywordId = 'T2911';
  operation.keywordName = 'Probealarm';
  operation.keywordRaw = '#T2911#PA#Probealarm';
  operation.location = 'Reichenschwand (location)';
  operation.zveis = '24423, 24133, 24427, 24435, 24005F, 24706F, 24401, 24402';
  operation.alarmdate = '24.07.2020';
  operation.alarmtime = '15:38:39';
  operation.gkx = '4451038.87';
  operation.gky = '5471198.2';
  operation.lat = '49.375792685925724';
  operation.lon = '11.324317673609638';

/* --------------------------------------------------------------------------------------------------------------------- */
/* Building fAlarm payload + sending message */
/* --------------------------------------------------------------------------------------------------------------------- */

fcmKeysAndroid.forEach(currentKey => {
  var fAlarmMessage = { //this may vary according to the message type (single recipient, multicast, topic, et cetera)
    to: currentKey,
    priority: 'high',

    data: {
      awf_key: operationId,
      awf_title: title,
      awf_message: messageBody,
      awf_location: location,
      awf_latlng: lat + ";" + lng,
      awf_timestamp: date
    }
  };

  fAlarm.send(fAlarmMessage, function (err, response) {
    if (err) {
      console.log("Something has gone wrong!");
    } else {
      console.log("Successfully sent with response: ", response);
    }
  });
})

/* --------------------------------------------------------------------------------------------------------------------- */
/* Building Alarmiator (iOS) payload + sending message */
/* --------------------------------------------------------------------------------------------------------------------- */

fcmKeysIOS.forEach(currentKey => {
  var alarmiatorIOSMessage = {
    to: currentKey,
    collapse_key: 'ALARMiator',
    priority: 'high',
    alert: notificationTitle,
    body: location,
    contentAvailable: true,
    critical: true,
    notification: {
      alert: "EINSATZ " + organization,
      title: "EINSATZ " + organization,
      body: title + "\nEinsatzort: " + location,
      sound: "Alarm.mp3",

    },

    data: {  //you can send only notification or only data(or include both)
      opid: operationId,
      opkeyword: opKeyword,
      opdesc: messageBody,
      oplat: lat,
      oplon: lng,
      optimestamp: date,
      optimestampIncoming: date,
      content_available: "1"
    }
  };

  /*alarmiatorIOS.send(alarmiatorIOSMessage, function (err, response) {
    if (err) {
      console.log("Something has gone wrong!");
      console.log(err);
    } else {
      console.log("Successfully sent with response: ", response);
    }
  });*/
})

/* --------------------------------------------------------------------------------------------------------------------- */
/* Building Alarmiator (new) payload + sending message */
/* --------------------------------------------------------------------------------------------------------------------- */
// First version
var payload = {
  /* LEGACY */
  keyword: title,
  date: date,
  message: messageBody,
  location: location,
  /* NEW */
  operation: operation
};

// REFERENCE: https://firebase.google.com/docs/reference/fcm/rest/v1/projects.messages#top_of_page
var message = {
  data: {
    payload: JSON.stringify(payload),
    messageType: "alarm",
    content_available: "1"
  },
  android: {

  },
  apns: {
    payload: {
      aps: {
        alert : {
          title : "EINSATZ " + organization,
          subtitle : "CRITICAL ALERT TEST",
          body: title + "\nEinsatzort: " + location,
        },
        sound: {
          critical: true,
          name: "default",
          volume: 1.0
        },
        "content-available": 1
      }
    }
  },
  tokens: fcmKeysNew
};

// Send a messages to the device corresponding to the provided
// registration tokens.
admin.messaging().sendMulticast(message)
  .then((response) => {
    // Response is a message ID string.
    console.log('Successfully sent message:', response);
    admin.app().delete();
  })
  .catch((error) => {
    console.log('Error sending message:', error);
    admin.app().delete();
  });




/*
fcmKeysNew.forEach(currentKey => {
  var alarmiatorNewMessage = {
    to: currentKey,
    collapse_key: 'ALARMiator',
    priority: 'high',
    contentAvailable: true,
    critical: true,
    data: {
      payload: JSON.stringify(payload),
      messageType: "alarm",
      content_available: "1"
    },

  };

  alarmiatorNew.send(alarmiatorNewMessage, function (err, response) {
    if (err) {
      console.log("Something has gone wrong!");
    } else {
      console.log("Successfully sent with response: ", response);
    }
  });
})
*/
