var moment = require('moment');
const admin = require("firebase-admin");
let serviceAccount = require("./alarmiator-21451d4118e2.json");

admin.initializeApp(
    {credential: admin.credential.cert(serviceAccount)}

)


var fcmKeysNew = [
  'TOKEN_HERE'
]

/* --------------------------------------------------------------------------------------------------------------------- */
/* Initalize variables*/
/* --------------------------------------------------------------------------------------------------------------------- */

var organization = "Reichenschwand";
var notificationTitle = "Einsatz für Feuerwehr " + organization;
var title = "Probealarm - THL 1 - Straße reinigen"
var messageBody = "Ort: Am Saueracker 36 - Reichenschwand\n\nEinsatzmittel: \nKBI Info\nFF Reichenschwand\nFL Reichenschwand 60-40-01";
var opKeyword = "THL 1";
var lat = "49.497290";
var lng = "11.570610";
var location = "Reichenschwand"

var date = moment().format('YYYY-MM-DDTHH:mm:ss'); // Current date
var operationId = "" + Math.random().toString(36).substr(2, 9); // Random OperationId for testing


/* --------------------------------------------------------------------------------------------------------------------- */
/* TestOperation */
/* --------------------------------------------------------------------------------------------------------------------- */

const Operation = require('../../models/core/core_operation');
const operations = require('../../routes/operations');

  let operation = new Operation();
  operation.setUUID(); // Generate UUID
  operation.operationnumber = 'Einsatznummer';
  operation.subject = 'PROBEALARM';
  operation.message = '';
  operation.object = '';
  operation.operationSourceConnector = 'core';
  operation.operationState = 1;
  operation.section = '';
  operation.street = 'Grünsberger Straße 2';
  operation.community = 'Altdorf';
  operation.district = 'Grünsberg';
  operation.gear = 'FF Reichenschwand\nFL Reichenschwand 60-40-01';
  operation.keywordCategory = 'PA';
  operation.keywordId = 'T2911';
  operation.keywordName = 'Probealarm';
  operation.keywordRaw = '#T2911#PA#Probealarm';
  operation.location = 'Reichenschwand (location)';
  operation.zveis = '24423, 24133, 24427, 24435, 24005F, 24706F, 24401, 24402';
  operation.alarmdate = moment().format('DD.MM.YYYY');
  operation.alarmtime = moment().format('HH:mm:ss');
  operation.gkx = '4451038.87';
  operation.gky = '5471198.2';
  operation.lat = '49.375792685925724';
  operation.lon = '11.324317673609638';


/* --------------------------------------------------------------------------------------------------------------------- */
/* Building Alarmiator (new) payload + sending message */
/* --------------------------------------------------------------------------------------------------------------------- */
// First version
var payload = {
  /* NEW */
  operation: operation.getReduced(),
  notification_payload: {
    title:"EINSATZ " + organization,
    subtitle : "NOTIFICATION SUBTITLE",
    body: title + "\nEinsatzort: " + location,
  }
};

// REFERENCE: https://firebase.google.com/docs/reference/fcm/rest/v1/projects.messages#top_of_page
var message = {
  data: {
    payload: JSON.stringify(payload),
    messageType: "alarm",
    feedback: "true",
    serverUUID: "TEST_UUID",
    content_available: "1"
  },
  fcmOptions: {
    analyticsLabel: "alarmiator-tool"
  },
  android: {
    priority: "high",
  },
  apns: {
    payload: {
      aps: {
        alert : {
          title : "EINSATZ " + organization,
          subtitle : "CRITICAL ALERT TEST",
          body: title + "\nEinsatzort: " + location,
        },
        category: "alarm",
        sound: {
          critical: true,
          name: "default",
          volume: 1.0
        },
        "mutable-content": 1,
        "content-available": 1
      }
    }
  },
  tokens: fcmKeysNew
};


var payloadNotification = {  
    message: "",
    timeStamp: moment().format("DD.MM.YYYY, HH:mm:ss"),
    messageUUID: Math.random().toString(),
    subtype: "admin",
    title:"Test title",
    notification_payload: {
      title:"Testnachricht vom DevTool",
      subtitle : "NOTIFICATION SUBTITLE",
      body: "Body",
    }
  };
var notificationMessage = {
  data: {
    payload: JSON.stringify(payloadNotification),
    messageType: "message",
    serverUUID: "TEST_UUID",
    content_available: "1"
  },
  fcmOptions: {
    analyticsLabel: "alarmiator-tool"
  },
  android: {
    priority: "high",
  },
  apns: {
    payload: {
      aps: {
        alert : {
          title : "Testnachricht vom DevTool",
          subtitle : "NOTIFICATION SUBTITLE",
          body: "Body",
        },
        category: "notification",
        sound: {
          critical: false,
          name: "default",
          volume: 1.0
        },
        "mutable-content": 1,
        "content-available": 1
      }
    }
  },
  tokens: fcmKeysNew
};

var payloadNotification = {  
  subtype: "adress_changed",
  serveradress:"http://alarmiatorpro5.ddns.net:5000",
  notification_payload: {
    title:"Testnachricht vom DevTool",
    subtitle : "NOTIFICATION SUBTITLE",
    body: "Body",
  }
};
var payloadConfig = {
  data: {
    payload: JSON.stringify(payloadNotification),
    messageType: "config",
    serverUUID: "5c127730-eea5-11ea-8345-25294550397e",
    content_available: "1"
  },
  fcmOptions: {
    analyticsLabel: "alarmiator-tool"
  },
  android: {
    priority: "high",
  },
  apns: {
    payload: {
      aps: {
        alert : {
          title : "Testnachricht vom DevTool",
          subtitle : "NOTIFICATION SUBTITLE",
          body: "Body",
        },
        category: "notification",
        sound: {
          critical: false,
          name: "default",
          volume: 1.0
        },
        "mutable-content": 1,
        "content-available": 1
      }
    }
  },
  tokens: fcmKeysNew
};

// Another example
/*
var messageTest = {
    "data":{
        "payload":"{\"keyword\":\"LKR N-LAND: THL ERKUNDUNG - Erkundung\",\"date\":\"\",\"message\":\"\",\"location\":\"Einsatzort: Schwarzenbach - Burgthann\",\"operation\":{\"_alarmdate\":{\"value\":\"12.08.2020\",\"label\":\"Alarmierungsdatum\"},\"_alarmtime\":{\"value\":\"10:37:55\",\"label\":\"Alarmierungszeit\"},\"_alarmtimeCalc\":{\"value\":\"12.08.2020 10:37:55\",\"label\":\"Alarmierungszeitpunkt\"},\"_community\":{\"value\":\"Burgthann\",\"label\":\"Gemeinde\"},\"_district\":{\"value\":\"Schwarzenbach\",\"label\":\"Ortsteil\"},\"_gear\":{\"value\":\"KBI Info\\nFF Schwarzenbach-Dörlbach\\nFL Schwarzenbach-Dörlbach 137-44-01\",\"label\":\"Einsatzmittel\"},\"_gearCalc\":{\"value\":[\"KBI Info\",\"FF Schwarzenbach-Dörlbach\",\"FL Schwarzenbach-Dörlbach 137-44-01\"],\"label\":\"Liste Einsatzmittel\"},\"_gkx\":{\"value\":\"4452504.35\",\"label\":\"GK-Koordinate X\"},\"_gky\":{\"value\":\"5468310.38\",\"label\":\"GK-Koordinate Y\"},\"_keywordCategory\":{\"value\":\"klein\",\"label\":\"Stichwort Kategorie\"},\"_keywordId\":{\"value\":\"T1410\",\"label\":\"Stichwort ID\"},\"_keywordName\":{\"value\":\"Erkundung\",\"label\":\"Stichwort Name\"},\"_keywordRaw\":{\"value\":\"#T1410#klein#Erkundung\",\"label\":\"Stichwort ABEK\"},\"_lat\":{\"value\":49.349944789820675,\"label\":\"WGS84 Koordinate Latitude\"},\"_location\":{\"value\":\"Schwarzenbach - Burgthann\",\"label\":\"Ort\"},\"_lon\":{\"value\":11.344841235218665,\"label\":\"WGS84 Koordinate Longitude\"},\"_message\":{\"value\":\"Lt. POL ist ein Fhzg mit der Schnauze im Kanal, keine Person in Gefahr, POL bitte um Erkundung ob Betriebsstoffe auslaufen. Schlepper ist bereits informiert. N-YK 738. Steife vor Ort.\",\"label\":\"Mitteilung\"},\"_object\":{\"value\":\"\",\"label\":\"Objekt\"},\"_operationSourceConnector\":{\"value\":null,\"label\":\"Quelle Alarmierung\"},\"_operationState\":1,\"_operationnumber\":{\"value\":\"T 5.2 200812 8601\",\"label\":\"Einsatznummer\"},\"_rawdata\":{\"value\":\"Haspelwiesen 2;$A$ESchwarzenbach - Burgthann$O $D12.08.2020 10:37:55$NT 5.2 200812 8601$X4452504.35$Y5468310.38$C#T1410#klein#Erkundung $WTHL ERKUNDUNG$P24133, 24435, 24732F$MKBI Info||FF Schwarzenbach-Dörlbach||FL Schwarzenbach-Dörlbach 137-44-01$FLt. POL ist ein Fhzg mit der Schnauze im Kanal, keine Person in Gefahr, POL bitte um Erkundung ob Betriebsstoffe auslaufen. Schlepper ist bereits informiert. N-YK 738. Steife vor Ort.\",\"label\":\"Alarmierung Rohdaten\"},\"_section\":{\"value\":\"\",\"label\":\"Kreuzung\"},\"_street\":{\"value\":\"Haspelwiesen 2\",\"label\":\"Straße\"},\"_subject\":{\"value\":\"THL ERKUNDUNG\",\"label\":\"Stichwort\"},\"_zveis\":{\"value\":\"24133, 24435, 24732F\",\"label\":\"Schleifen\"},\"_zveisCalc\":{\"value\":[\"24133\",\" 24435\",\" 24732F\"],\"label\":\"Schleife Liste\"}}}",
        "messageType":"alarm"
    },
    "android":{

    },
    "apns":{  
        "headers":{
            "apns-priority":"10"
        },
        "payload":{
            "aps":{
                "alert":{
                    "title":"EINSATZ LKR N-Land",
                    "subtitle":"THL ERKUNDUNG - Erkundung",
                    "body":"Einsatzort: Schwarzenbach - Burgthann"
                },
                "sound":{
                    "critical":true,
                    "name":"default",
                    "volume":1
                },
                "content-available":1
            }
        }
    },
    "tokens":[
  //      "cl6ATtklHkE:APA91bGp9nqSn5DLSJYLioStw4RVsxshFLyhA4vPBMm7i8R9abz76P0ByMFIROjkTeHNz3uVsUk1x02cTCTbIwHI63h2QNgzdTFsbqjyGI8GqMU0y1JpC7Gix0P9v0BG6gmqtn5oghEr",
  //      "fbzr5j59eEPnkRyCaQ4W-y:APA91bE8p95u3N0TvpDDZrmgmJGpVQjh1BnVVgJzOqD8zrYlKNE2j0Jbu6CFPU3Wtedfe08sR_KRmad3fl6-zyGbBwhZ2Jv6j7NuVl1_xhtpqVW6FvWqAZF4UGU5r-RpGDZNKViy9M6n",
  //     "duuTBwer-vI:APA91bFQlDWVp5y6SRzz770DEoujamm06OksBtfhds996fJWgnwZkKI6x4TDpRaVitx6STrExfDx8Gn3XnuehwlRd8IgKXMTMs0GmiGMKwc5zqA8gqkIOF41m2Uv1q1P5eqX_7oZ20x8"
    ]
  }
*/
// TOKEN JENS: fbzr5j59eEPnkRyCaQ4W-y:APA91bE8p95u3N0TvpDDZrmgmJGpVQjh1BnVVgJzOqD8zrYlKNE2j0Jbu6CFPU3Wtedfe08sR_KRmad3fl6-zyGbBwhZ2Jv6j7NuVl1_xhtpqVW6FvWqAZF4UGU5r-RpGDZNKViy9M6n
// TOKEN STEFAN: cl6ATtklHkE:APA91bGp9nqSn5DLSJYLioStw4RVsxshFLyhA4vPBMm7i8R9abz76P0ByMFIROjkTeHNz3uVsUk1x02cTCTbIwHI63h2QNgzdTFsbqjyGI8GqMU0y1JpC7Gix0P9v0BG6gmqtn5oghEr
// TOKEN PATRICK: duuTBwer-vI:APA91bFQlDWVp5y6SRzz770DEoujamm06OksBtfhds996fJWgnwZkKI6x4TDpRaVitx6STrExfDx8Gn3XnuehwlRd8IgKXMTMs0GmiGMKwc5zqA8gqkIOF41m2Uv1q1P5eqX_7oZ20x8

// Send a messages to the device corresponding to the provided
// registration tokens.
admin.messaging().sendMulticast(message)
  .then((response) => {
    // Response is a message ID string.
    console.log('Successfully sent message:', response);
    response.responses.forEach(element => {
        if (element.error != undefined) {
            console.log(element.error);
        }
    });
    admin.app().delete();
  })
  .catch((error) => {
    console.log('Error sending message:', error);
    admin.app().delete();
  });





