
var express = require('express');
var router = express.Router();

const SerialPort = require('serialport');

router.get('/', function(req, res, next) {
  var portList = [];
  var selectedPort = global.selectedPort;
  SerialPort.list().then(ports => {
    ports.forEach((port) => {
      portList.push(port);
    });
    global.portList = portList;
    res.render('tetra', { 
      area: 'tetra',
      title: 'tetra',
      portList: portList,
      selectedPort: selectedPort
    });
  });
});

router.get('/concenatedSDS', function(req, res, next) {
  res.render('tetra_concenated', { 
    area: 'tetra_concenated',
    title: 'tetra_concenated' 
  });
});

router.get('/statusSDS', function(req, res, next) {
  res.render('tetra_status', { 
    area: 'tetra_status',
    title: 'tetra_status' 
  });
});

const { concenatedSDS } = require ('./tetra/sds');
const { controlSDSSettings } = require ('./tetra/sds');
const { statusSDS } = require ('./tetra/sds');
router.post('/concenatedSDS', concenatedSDS);
router.post('/', controlSDSSettings);
router.post('/statusSDS', statusSDS);

module.exports = router;