const vPEI = require('../../vpei');

module.exports = {
    concenatedSDS: (req, res) => {
        var payload = req.body.payload.trim();
        var globalMessageCounter = parseInt(req.body.globalMessageCounter);
        var constantMessageCounter = parseInt(req.body.constantMessageCounter);
        var timestampEnabled;

        switch (req.body.timestampEnabled.toUpperCase()) {
            case "TRUE": {
                timestampEnabled = true;
                break;
            }
            case "FALSE": {
                timestampEnabled = false;
                break;
            }
            default: {
                timestampEnabled = true;
                break;
            }
        }
        var encoding = parseInt(req.body.encoding);

        if (global.pei.enableMessageWithUserDataHeader){
            if (payload != undefined && payload != null && payload != ''){
                var result = global.pei.sendCallout(payload, globalMessageCounter, timestampEnabled, encoding, constantMessageCounter);
                res.render('tetra_concenated',
                {
                    area: 'tetra_concenated',
                    title: 'tetra',
                    initialPayload: payload,
                    result: result
                })
            }
        }
        else {
            var result = [];
            result.push("ERROR!");
            result.push("Message with user data header not enabled"); 
            res.render('tetra_concenated',
            {
                area: 'tetra_concenated',
                title: 'tetra',
                initialPayload: payload,
                result: result
            })
        }
    },
    controlSDSSettings: (req, res) => {
        var serialPort = req.body.serialPort;
        var connect = req.body.connectButton;
        var disconnect = req.body.disconnectButton;
        if (connect != undefined) {
            if (serialPort != undefined) {
                global.selectedPort = serialPort;
    
                const pei = new vPEI();
                global.pei = pei;
        
                res.render('tetra', { 
                    area: 'tetra',
                    title: 'tetra',
                    portList: global.portList,
                    selectedPort: serialPort
                  });
            }
        }
        else {
            if (global.pei != undefined) {
                global.selectedPort = undefined;
                global.pei.destroyvPEI();
                global.pei = undefined;
                res.render('tetra', { 
                    area: 'tetra',
                    title: 'tetra',
                    portList: global.portList
                  });
            }  
        }      
    },
    statusSDS: (req, res) => {
        var status = parseInt(req.body.status);

        if (global.pei.enableStatus){
            if (status != undefined && status != null && status != ''){
                var result = global.pei.sendStatus(status);
                res.render('tetra_status',
                {
                    area: 'tetra_status',
                    title: 'tetra_status',
                    result: result
                })
            }
        }
        else {
            res.render('tetra_status',
            {
                area: 'tetra_status',
                title: 'tetra_status',
                result: "ERROR! Status not enabled"
            })
        }
    }
};