---
id: admin_installation
title: Installation
sidebar_label: Installation
---

im folgenden Artikel zeigen wir Ihnen, wie die Installation des ALARMiator Servers erfolgt. Für weitere Module, wie z.b. die Wallboards oder auch Erweiterungen (Plugins) wird auf zusätzliche Artikel verwiesen.

> Geschätzte Zeit zur Durchfühung: 20 Minuten.

## Vorbereitung

ALARMiator kann in unterschiedlichen Einsatzszenarien genutzt werden, die auch Einfluss auf die zu verwendende Hardware haben. Wir beschreiben folgend unterschiedliche Szenarien um Ihnen eine Einschätzung für Ihr Einsatzgebiet an die Hand geben zu können. Bei den folgenden technischen Anforderungen finden Sie dann zu den jeweiligen Szenarien passende technische Anforderungen.

## Bezug der nötigen Software

Kleininstallationen werden häufig von kleineren Rettungsorganisationen mit geringem Einsatzaufkommen über ein Kalenderjahr betrieben. Hier wird ALARMiator meist auch hauptsächlich zur Zusatzalarmierung verwendet. Die Verwaltung einer Wehr mit vielen Aktiven (> 50), einem großen Inventar (>100 Inventargegenstände) sind hier nicht der Hauptanwendungsfall. 


## Vorbereitung Hardware

In diesem Szenario wird ALARMiator intensiv auch für die Wehrverwaltungt (> 50 Aktive), der Inventarisierung (>100 Inventargegenstände) sowie Trainingsverwaltung usw. genutzt. Es werden neben der Zusatzalarmierung auch weitere Funktionen genutzt.


## Installation Raspberry Pi

ALARMiator wird bei Ihnen in der eigenen Organisation installiert. Für die Installation ist ein eigener Computer nötig. 

## Installation PC


| Szenario             | Hardwareanforderung      | Bezugsquelle     |
| -------------------- | ------------------------ | ---------------- |
| _Kleininstallation_  | Raspberry Pi 4, 4 GB     | [Amazon.de](https://www.amazon.de/InnoConnect-Raspberry-Bundle-32GB-schwarz/dp/B081D3B7ZT/ref=sr_1_8?__mk_de_DE=%C3%85M%C3%85%C5%BD%C3%95%C3%91&crid=2ZVH9TBAOYXPB&dchild=1&keywords=raspberry+4+bundle&qid=1594889767&sprefix=Raspberry+4%2Caps%2C174&sr=8-8/)      |
| _Vollinstallation_   | PC, Intel i3             | [Amazon.de](https://www.amazon.de/Intel-Komplett-Aufloesung-Herstellergarantie-Windows/dp/B07W72ZDXZ/ref=sr_1_1_sspa?__mk_de_DE=%C3%85M%C3%85%C5%BD%C3%95%C3%91&dchild=1&keywords=intel+nuc+i3&qid=1594889807&sr=8-1-spons&psc=1&spLa=ZW5jcnlwdGVkUXVhbGlmaWVyPUE1VDlRRDVWTzkzQUMmZW5jcnlwdGVkSWQ9QTAxMzYyNjMzMENFVVlMMDFLUzE2JmVuY3J5cHRlZEFkSWQ9QTAyMDkyNzczNExHSzVNMTVXTTZGJndpZGdldE5hbWU9c3BfYXRmJmFjdGlvbj1jbGlja1JlZGlyZWN0JmRvTm90TG9nQ2xpY2s9dHJ1ZQ==)                |


## Test Ihrer neuen Installation

ALARMiator kann innerhalb einer Rettungsorganisation theoretisch auch ohne eine bestehende Internetverbindung genutzt werden. Allerdings ist die Nutzung dann rein auf die Organisationsverwaltung beschränkt (Mitglieder, Inventar, Trainings, etc.). Möchten Sie auch die Zusatzalarmierung nutzen, muss zwingend dauerhaft eine Internetverbindung gewährleistet sein. ALARMiator kann hinter einer Firewall betrieben werden. Ggf. müssen Portweiterleitungen eingerichtet werden. Nötige Portweiterleitungen sind im Einzelnen bei der Beschreibung der Funkionen beschrieben. 
Der Internetanschluss muss keine feste externe IP-Adresse haben, ALARMiator aktualisiert automatisch alle 2 Minuten die externe IP-Adresse des Internetanschlusses und sorgt für die nötige Konnektivität.

## Wallboard / Alarmmonitor

Wenn Sie in Ihrer Organisation auch das sog. Wallboard (Alarmmonitor) zur Anzeige von Statusinformationen und Alarmmeldungen nutzen möchten, gelten folgende zusätzliche Anforderungen:

- Netzwerkverbindung zwischen Monitor(en) und ALARMiator Server (WLAN oder LAN)
- Ggf. Portfreigabe in einer eventuell dazwischen vorhandenen Firewall.

## Hardware Wallboard / Alarmmonitor

Wallboards können durch einen Raspberry Pi (2,3 oder 4) betrieben werden. Eine Anleitung zur Konfiguration finden sie __hier__.
Der Raspberry wird über HDMI mit einem Monitor oder Fernseher verbunden. Über Netzwerkkabel oder WLAN stellt der Raspberry nach dem Start automatisch eine Verbindung zum ALARMiator Server her und stellt das von Ihnen konfigurierte Wallboard dar. Für die Anzahl an Displays/Wallboards gibt es keine Beschränkung.
