/**
 * Migration Coredatabase
 * 
 * @autor Stefan Bauer
 * @description adds a new column alarmingByUser to table pluginStore
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

  queryInterface.describeTable("pluginstore")
  .then(tableDefinition => {

    if (tableDefinition.alarmingByUser) return Promise.resolve();
      return queryInterface.addColumn("pluginstore","alarmingByUser",{
        type: Sequelize.INTEGER,
        allowNull: false,
        defaultValue: 0,
        })
    });

  },

  down: async (queryInterface, Sequelize) => {
    await queryInterface.removeColumn("pluginstore","alarmingByUser")
  }
};
