/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "state" to users table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("users")
      .then(tableDefinition => {

        if (tableDefinition.state) return Promise.resolve();
        return queryInterface.addColumn("users", "state", {
          type: Sequelize.INTEGER,
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("users", "state");
  }
};