/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table alertdevices to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'alertdevices',
      {
        id: {
          type: Sequelize.BIGINT,
          primaryKey: true,
          autoIncrement: true,
          unique: true,
          allowNull: false
        },
        basedataId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'basedata',
            key: 'id'
          },
          allowNull: true
        },
        assetsId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'assets',
            key: 'id'
          },
          allowNull: true
        },
        name: {
          type: Sequelize.STRING,
          allowNull: true
        },
        model: {
          type: Sequelize.STRING,
          allowNull: true
        },
        platform: {
          type: Sequelize.STRING,
          allowNull: true
        },
        osVersion: {
          type: Sequelize.STRING,
          allowNull: true
        },
        uuid: {
          type: Sequelize.STRING,
          allowNull: true
        },
        state: {
          type: Sequelize.INTEGER,
          defaultValue: 1,
          allowNull: false
        },
        lastseen: {
          type: Sequelize.REAL,
          defaultValue: 'CURRENT_TIMESTAMP'
        },
        registeredAt: {
          type: Sequelize.REAL,
          defaultValue: 'CURRENT_TIMESTAMP'
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("alertdevices");
  }
};
