/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table fcmtokenStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'fcmtokenStore',
      {
        id: {
          type: Sequelize.BIGINT,
          primaryKey: true,
          autoIncrement: true,
          unique: true,
          allowNull: false
        },
        deviceId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'alertdevices',
            key: 'id'
          },
          allowNull: true
        },
        state: {
          type: Sequelize.INTEGER,
          defaultValue: 1,
          allowNull: false
        },
        pluginNamespace: {
          type: Sequelize.STRING,
        },
        predecessorTokenId: {
          type: Sequelize.BIGINT,
          defaultValue: 0,
          allowNull: false
        },
        fcmToken: {
          type: Sequelize.STRING,
          allowNull: false
        },
        lastReportedTimestamp: {
          type: Sequelize.REAL,
          allowNull: true
        },
        failCount: {
          type: Sequelize.INTEGER,
          defaultValue: 0
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("fcmtokenStore");
  }
};
