/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "fcmtokenconsumer" to pluginstore table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("pluginstore")
      .then(tableDefinition => {

        if (tableDefinition.fcmtokenconsumer) return Promise.resolve();
        return queryInterface.addColumn("pluginstore", "fcmtokenconsumer", {
          type: Sequelize.INTEGER,
          defaultValue: 0
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("pluginstore", "fcmtokenconsumer");
  }
};