/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "uuid" to organizations table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("organizations")
      .then(tableDefinition => {
        if (tableDefinition.uuid) return Promise.resolve();
        return queryInterface.addColumn("organizations", "uuid", {
          type: Sequelize.STRING,
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("organizations", "uuid");
  }
};