/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "isGearGroup" to table assetsGroups
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets_groups")
  .then(tableDefinition => {

    if (tableDefinition.isGearGroup) return Promise.resolve();
      return queryInterface.addColumn("assets_groups","isGearGroup",{
        type: Sequelize.INTEGER,
        defaultValue: 0
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets_groups","isGearGroup");
  }
};
