/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "isGear" to table assets
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets")
  .then(tableDefinition => {

    if (tableDefinition.isGear) return Promise.resolve();
      return queryInterface.addColumn("assets","isGear",{
        type: Sequelize.INTEGER,
        defaultValue: 0
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets","isGear");
  }
};
