/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "gearname" to table assets
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets")
  .then(tableDefinition => {

    if (tableDefinition.gearname) return Promise.resolve();
      return queryInterface.addColumn("assets","gearname",{
        type: Sequelize.STRING,
        defaultValue: ''
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets","gearname");
  }
};
