/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table users_groups to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'users_groups',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        title: {
          type: Sequelize.STRING,
          allowNull: false,
          unique: true
        },
        isSystemGroup: {
          type: Sequelize.INTEGER,
          defaultValue: 0,
          allowNull: false
        },
        description: {
          type: Sequelize.STRING,
          allowNull: false,
          defaultValue: '',
        },
        grantnamespace: {
          type: Sequelize.STRING,
          allowNull: false,
          unique: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("users_groups");
  }
};