/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_users_users_groups to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_users_users_groups',
      {
        userId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'users',
            key: 'id'
          }
        },
        groupId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'users_groups',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_users_users_groups");
  }
};