/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description prefills table users_groups in coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.bulkInsert('users_groups', 
      [
        {
          id: 1,
          title: 'Administratoren',
          isSystemGroup: 1,
          description: 'Administration aller ALARMiator Funktionen und Servereinstellungen.',
          grantnamespace: 'administration'
        },
        {
          id: 2, 
          title: 'Inventarverwaltung', 
          isSystemGroup: 1, 
          description: 'Zugriff auf das Modul Inventar und Wartung des ALARMiator Servers', 
          grantnamespace: 'inventory'
        },
        {
          id: 3, 
          title: 'Stammdatenverwaltung', 
          isSystemGroup: 1, 
          description: 'Zugriff auf die Stammdatenverwaltung des ALARMiator Servers', 
          grantnamespace: 'basedata'
        },
        {
          id: 4, 
          title: 'Einsatzverwaltung', 
          isSystemGroup: 1, 
          description: 'Zugriff auf die Einsatzverwaltung des ALARMiator Servers', 
          grantnamespace: 'operations'
        },
        {
          id: 5, 
          title: 'Alarmierung', 
          isSystemGroup: 1, 
          description: 'User die Alarmierungen erhalten dürfen', 
          grantnamespace: 'alarmings'
        }

      ]
    );
  }

};