/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds new column "ils" and "floor" to table operations
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("operationsStore")
      .then(tableDefinition => {

        if (tableDefinition.floor) return Promise.resolve();
        return [
          queryInterface.addColumn('operationsStore', 'floor', {
            type: Sequelize.STRING,
            defaultValue: null
          }),
          queryInterface.addColumn('operationsStore', 'ils', {
            type: Sequelize.STRING,
            defaultValue: null
          })
        ];
      });
  },

  down: async (queryInterface) => {
    return [
      queryInterface.removeColumn('operationsStore', 'floor'),
      queryInterface.removeColumn('operationsStore', 'ils')
    ];
  }
};
