/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table gearDirectory to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'gearDirectory',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        gearType: {
          type: Sequelize.INTEGER,
          allowNull: false,
        },
        gearDescription: {
          type: Sequelize.STRING,
          allowNull: false
        },
        area: {
          type: Sequelize.STRING,
          allowNull: false,
          defaultValue: 'bavaria',
        },
        gearShort: {
          type: Sequelize.STRING,
          allowNull: false,
          defaultValue: ''
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("gearDirectory");
  }
};