/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description prefills table users_groups in coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.bulkInsert('gearDirectory', 
      [
        {
          gearType: 10,
          gearDescription: 'Kommandowagen',
          gearShort: 'KDOW'
        },
        {
          gearType: 11,
          gearDescription: 'Mehrzweckfahrzeug',
          gearShort: 'MZF'
        },
        {
          gearType: 12,
          gearDescription: 'Einsatzleitwagen',
          gearShort: 'ELW'
        },
        {
          gearType: 13,
          gearDescription: 'Einsatzleitwagen 2',
          gearShort: 'KDOW'
        },
        {
          gearType: 14,
          gearDescription: 'Mannschaftstransportwagen',
          gearShort: 'MTW'
        },
        {
          gearType: 15,
          gearDescription: 'Luftbeobachter',
          gearShort: ''
        }, 
        {
          gearType: 16,
          gearDescription: 'Funkkraftwagen',
          gearShort: 'FUKW'
        },
        {
          gearType: 17,
          gearDescription: 'Fernsprechkraftwagen',
          gearShort: 'FSKW'
        },
        {
          gearType: 18,
          gearDescription: 'Sonstige Funkanlagen',
          gearShort: ''
        },
        {
          gearType: 19,
          gearDescription: 'Örtliche Einsatzleitung',
          gearShort: 'ÖEL'
        },
        {
          gearType: 14,
          gearDescription: 'Mannschaftstransportwagen',
          gearShort: 'MTW'
        },
        {
          gearType: 20,
          gearDescription: 'Trockentanklöschfahrzeug',
          gearShort: 'TRTLF'
        },
        {
          gearType: 21,
          gearDescription: 'Tanklöschfahrzeug 16, TLF 16/25',
          gearShort: 'TLF'
        },
        {
          gearType: 22,
          gearDescription: 'Tanklöschfahrzeug 8, TLF 8/18, TLF 24/50',
          gearShort: 'TLF'
        },
        {
          gearType: 23,
          gearDescription: 'Tanklöschfahrzeug 24/28, TLF 24/50',
          gearShort: 'TLF'
        },
        {
          gearType: 24,
          gearDescription: 'Flugfeldlöschfahrzeug',
          gearShort: 'FLF'
        },
        {
          gearType: 25,
          gearDescription: 'Trockenlöschfahrzeug 500, TroLF 750, TroLF 1500, TroLF 200',
          gearShort: 'FLF'
        },
        {
          gearType: 26,
          gearDescription: 'Zumischerlöschfahrzeug',
          gearShort: 'ZLF'
        },
        {
          gearType: 27,
          gearDescription: 'Sonderlöschmittelfahrzeug',
          gearShort: 'SLF'
        },
        {
          gearType: 28,
          gearDescription: 'Löschwasseraußenlastbehälter',
          gearShort: ''
        },
        {
          gearType: 29,
          gearDescription: 'sonstige Tanklöschfahrzeuge',
          gearShort: ''
        },
        {
          gearType: 30,
          gearDescription: 'Drehleiter 23/12, DL 30',
          gearShort: 'DLK'
        },
        {
          gearType: 31,
          gearDescription: 'Drehleiter 18/12, DL 22, DL 25',
          gearShort: 'DLK'
        },
        {
          gearType: 32,
          gearDescription: 'Drehleiter 16/4, DL 18, DL 12/9',
          gearShort: 'DLK'
        },
        {
          gearType: 33,
          gearDescription: 'Sonderleitern (z.B. DL 37, GDL)',
          gearShort: 'DLK'
        },
        {
          gearType: 34,
          gearDescription: 'Leiterbühne LB (z.B. LB 30)',
          gearShort: 'LB'
        },
        {
          gearType: 35,
          gearDescription: 'Teleskop-Gelenkmast',
          gearShort: ''
        },
        {
          gearType: 39,
          gearDescription: 'Sonstige Hubrettungsfahrzeuge',
          gearShort: ''
        },
        {
          gearType: 40,
          gearDescription: 'Löschgruppenfahrzeug 16, LF 16/12, LF 20/16, HLF 20/16',
          gearShort: 'LF16/HLF20'
        },
        {
          gearType: 41,
          gearDescription: 'Löschgruppenfahrzeug 16-TS',
          gearShort: 'LF16-TS'
        },
        {
          gearType: 42,
          gearDescription: 'Löschgruppenfahrzeug 8 (> 6 t zGG, mit Zusatzbeladung THL)',
          gearShort: 'LF8'
        },
        {
          gearType: 43,
          gearDescription: 'Löschgruppenfahrzeug LF 8 (< 6 t zGG, ohne Zusatzbeladung THL)',
          gearShort: 'LF8'
        },
        {
          gearType: 44,
          gearDescription: 'Tragkraftspritzenfahrzeug TSF',
          gearShort: 'TSF'
        },
        {
          gearType: 45,
          gearDescription: 'Tragkraftspritzenfahrzeug-Trupp TSF-Tr; MW-TS',
          gearShort: 'TSF-TR'
        },
        {
          gearType: 46,
          gearDescription: 'Tragkraftspritzenfahrzeug mit Wasser TSF-W',
          gearShort: 'TSF-W'
        },
        {
          gearType: 47,
          gearDescription: 'Löschgruppenfahrzeug 8/6, LF 10/6 (ohne Zusatzbeladung THL, ggf. mit TS)',
          gearShort: 'LF8/LF10'
        },
        {
          gearType: 49,
          gearDescription: 'sonstige Lösch- und Hilfeleistungslöschfahrzeuge',
          gearShort: ''
        },
        {
          gearType: 50,
          gearDescription: 'Gerätewagen',
          gearShort: 'GW'
        },
        {
          gearType: 51,
          gearDescription: 'Gerätewagen Öl',
          gearShort: 'GW-ÖL'
        },
        {
          gearType: 52,
          gearDescription: 'Gerätewagen Gefahrgut',
          gearShort: 'GW-G'
        },
        {
          gearType: 53,
          gearDescription: 'Gerätewagen Atemschutz/Strahlenschutz,Strahlenschutzmessfahrzeug',
          gearShort: 'GW-A/S'
        },
        {
          gearType: 54,
          gearDescription: 'Gerätewagen Atemschutz GW-A',
          gearShort: 'GW-A'
        },
        {
          gearType: 58,
          gearDescription: 'Gerätewagen Sanität',
          gearShort: 'GW-SAN'
        },
        {
          gearType: 59,
          gearDescription: 'sonstige Gerätewagen',
          gearShort: 'GW'
        },
        {
          gearType: 60,
          gearDescription: 'Rüstwagen 3',
          gearShort: 'RW-3'
        },
        {
          gearType: 61,
          gearDescription: 'Rüstwagen 2',
          gearShort: 'RW-2'
        },
        {
          gearType: 62,
          gearDescription: 'Rüstwagen 1, Hilfsrüstwagen',
          gearShort: 'RW/HRW'
        },
        {
          gearType: 64,
          gearDescription: 'Kranwagen',
          gearShort: 'KRAN'
        },
        {
          gearType: 65,
          gearDescription: 'Kleinalarmfahrzeug',
          gearShort: 'KLAF'
        },
        {
          gearType: 69,
          gearDescription: 'Sonstige Rüstwagen',
          gearShort: 'RW'
        },
        {
          gearType: 70,
          gearDescription: 'Notarztwagen',
          gearShort: 'NAW'
        },
        {
          gearType: 71,
          gearDescription: 'Rettungswagen',
          gearShort: 'RTW'
        },
        {
          gearType: 72,
          gearDescription: 'Krankentransportwagen, eine Trage KTW',
          gearShort: 'KTW'
        },
        {
          gearType: 73,
          gearDescription: 'Krankentransportwagen, zwei Tragen KTW',
          gearShort: 'KTW'
        },
        {
          gearType: 74,
          gearDescription: 'Krankentransportwagen, drei bis vier Tragen KTW',
          gearShort: 'KTW'
        },
        {
          gearType: 75,
          gearDescription: 'Großraumrettungswagen GRTW, Großraumkrankentransportwagen GKTW',
          gearShort: 'GKTW'
        },
        {
          gearType: 76,
          gearDescription: 'Notarzteinsatzfahrzeug',
          gearShort: 'NEF'
        },
        {
          gearType: 77,
          gearDescription: 'Arzttruppkraftwagen',
          gearShort: ''
        },
        {
          gearType: 78,
          gearDescription: 'Private Luftfahrzeuge des Rettungsdienstes',
          gearShort: ''
        },
        {
          gearType: 79,
          gearDescription: 'Sonstige Rettungsdienstfahrzeuge (z.B. First Responder, Helfer vor Ort)',
          gearShort: 'FIRST RESPONDER'
        },
        {
          gearType: 80,
          gearDescription: 'Kombi',
          gearShort: ''
        },
        {
          gearType: 81,
          gearDescription: 'Lastkraftwagen LKW',
          gearShort: 'LKW'
        },
        {
          gearType: 82,
          gearDescription: 'Wechselladerfahrzeug',
          gearShort: 'WLF'
        },
        {
          gearType: 83,
          gearDescription: 'Kipper',
          gearShort: ''
        },
        {
          gearType: 85,
          gearDescription: 'Küchenwagen',
          gearShort: ''
        },
        {
          gearType: 86,
          gearDescription: 'Verpflegungstransportfahrzeug',
          gearShort: ''
        },
        {
          gearType: 87,
          gearDescription: 'Schlauchwagen 1000',
          gearShort: 'SKW'
        },
        {
          gearType: 88,
          gearDescription: 'Schlauchwagen SW 2000, SW 2000-Tr, Gerätewagen Logistik GW-L2',
          gearShort: 'SW'
        },
        {
          gearType: 89,
          gearDescription: 'sonstige Versorgungsfahrzeuge',
          gearShort: ''
        },
        {
          gearType: 90,
          gearDescription: 'Kraftrad',
          gearShort: ''
        },
        {
          gearType: 91,
          gearDescription: 'Wasserrettungswagen',
          gearShort: ''
        },
        {
          gearType: 92,
          gearDescription: 'Tierrettungsfahrzeug',
          gearShort: ''
        },
        {
          gearType: 93,
          gearDescription: 'Beleuchtungsfahrzeug',
          gearShort: 'GW-Licht'
        },
        {
          gearType: 94,
          gearDescription: 'Bagger / Schaufelradlader',
          gearShort: ''
        },
        {
          gearType: 95,
          gearDescription: 'Motorschlitten / Raupe',
          gearShort: ''
        },
        {
          gearType: 96,
          gearDescription: 'ABC Erkundungs- und Messfahrzeug',
          gearShort: 'ABC'
        },
        {
          gearType: 97,
          gearDescription: 'Dekontaminationsmehrzweckfahrzeug DMF, Dekontaminationslastkraftwagen Personen',
          gearShort: 'DMF'
        },
        {
          gearType: 98,
          gearDescription: 'Sonderfahrzeug',
          gearShort: ''
        },
        {
          gearType: 99,
          gearDescription: 'Boot',
          gearShort: 'BOOT'
        }
      ]
    );
  }

};