/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table respiratoryStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'respiratoryStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        basedataId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'basedata',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        capable: {
          type: Sequelize.INTEGER,
          defaultValue: 0
        },
        capableFrom: {
          type: Sequelize.DATE,
          allowNull: true
        },
        capableTill: {
          type: Sequelize.DATE,
          allowNull: true
        },
        doctorName: {
          type: Sequelize.STRING,
          allowNull: true,
          defaultValue: ''
        },
        restrictions: {
          type: Sequelize.TEXT,
          defaultValue: ''
        },
        predecessor: {
          type: Sequelize.BIGINT,
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("respiratoryStore");
  }
};