/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table feedbackStates to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'feedbackStates',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        stateLabel: {
          type: Sequelize.STRING,
          allowNull: false,
          unique: true
        },
        state: {
          type: Sequelize.INTEGER,
          defaultValue: 0,
          allowNull: false
        },
        stateColor: {
          type: Sequelize.STRING,
          allowNull: false,
          defaultValue: '#00ff00',
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("feedbackStates");
  }
};