/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "uuid" to table basedata
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("basedata")
      .then(tableDefinition => {
        if (tableDefinition.uuid) return Promise.resolve();
        return queryInterface.addColumn("basedata", "uuid", {
          type: Sequelize.STRING,
          allowNull: true
        }).then(async function () {
          console.log('MIGRATION-TASK | --> completed creation of database table. Now filling UUIDs');
          await queryInterface.sequelize.query('SELECT * FROM basedata')
            .then(function (rows) {
              var basedatacount = rows[0].length;
              //console.log('found existing Basedata Entries: ' + rows[0].length);
              if (rows[0].length > 0) {
                var i;
                for (i = 0; i < rows[0].length; i++) {
                  var uuidNew = uuidv1();
                  queryInterface.sequelize.query(`UPDATE basedata SET uuid = '${uuidNew}' where id = ${rows[0][i].id};`)
                }
              }
            });
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("basedata", "uuid");
  }
};
