/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "startPasswordHash" to table users
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("users")
  .then(tableDefinition => {

    if (tableDefinition.startPasswordHash) return Promise.resolve();
      return queryInterface.addColumn("users","startPasswordHash",{
        type: Sequelize.STRING,
        defaultValue: ''
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("users","startPasswordHash");
  }
};
