/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table feedbackStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'feedbackStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        operationId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'operationsStore',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        basedataUUID: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'basedata',
            key: 'uuid',
            onDelete: 'CASCADE'
          }
        },
        stateId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'feedbackStates',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        stateSet: {
          type: Sequelize.DATE,
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("feedbackStore");
  }
};