/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "uuid" to table basedata
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("basedata")
      .then(async function () {
        console.log('MIGRATION-TASK | --> filling UUIDs in basedata if empty');
        await queryInterface.sequelize.query('SELECT * FROM basedata')
          .then(function (rows) {
            if (rows[0] !== null) {
              var basedatacount = rows[0].length;
              //console.log('found existing Basedata Entries: ' + rows[0].length);
              if (rows[0].length > 0) {
                var i;
                for (i = 0; i < rows[0].length; i++) {
                  if (typeof rows[0][i].uuid != 'undefined') {
                    if (rows[0][i].uuid != null) {
                      console.log('MIGRATION-TASK | found basedata with set uuid value. ignoring row.');
                    } else {
                      var uuidNew = uuidv1();
                      //console.log(`MIGRATION-TASK | --> generating and adding uuid for basedata id ${rows[0][0].id} ${uuidNew}`);
                      queryInterface.sequelize.query(`UPDATE basedata SET uuid = '${uuidNew}' where id = ${rows[0][i].id};`);
                    }
                  } else {
                    console.log('MIGRATION TASK | ERROR | column uuid not existing in basedata table!');
                  }
                }
              }
            } else {
              console.log('MIGRATION-TASK | no basedata entries in table');
            }
          });
      });
  },
};
