/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table suppliers to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'suppliers',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        companyname: {
          type: Sequelize.STRING(255),
          allowNull: false,
          unique: true
        },
        department: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        street: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        zip: {
          type: Sequelize.STRING(8),
          allowNull: true
        },
        city: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        federalstate: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        country: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        email: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        phone: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        faximile: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        cellphone: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        supportPhone: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        supportEmail: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        website: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        supportWebsite: {
          type: Sequelize.STRING(128),
          allowNull: true
        },
        supportWebsiteCredentialsUsername: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        supportWebsiteCredentialsPassword: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        contactName: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        customerNumber: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        state: {
          type: Sequelize.INTEGER,
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("suppliers");
  }
};