/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "uuid" to table basedata
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets")
      .then(tableDefinition => {
        if (tableDefinition.uuid) return Promise.resolve();
        return queryInterface.addColumn("assets", "supplierId", {
          type: Sequelize.BIGINT,
          allowNull: true
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets", "supplierId");
  }
};
