/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "theme" to table users
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');



module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("users")
      .then(tableDefinition => {
        if (tableDefinition.theme) return Promise.resolve();
        return queryInterface.addColumn("users", "theme", {
          type: Sequelize.STRING(50),
          allowNull: true,
          defaultValue: 'light'
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("users", "theme");
  }
};
