/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table eventsStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'eventsStore',
      {
        eventname: {
          type: Sequelize.STRING(128),
          unique: true,
          allowNull: false,
          primaryKey: true
        },
        ownermodule: {
          type: Sequelize.STRING(128),
          allowNull: false,
        },
        payloadType: {
          type: Sequelize.STRING(128),
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("eventsStore");
  }
};