/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "dateNextMaintenance" to table assets
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');



module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets")
      .then(tableDefinition => {
        if (tableDefinition.dateNextMaintenance) return Promise.resolve();
        return queryInterface.addColumn("assets", "dateNextMaintenance", {
          type: Sequelize.DATE,
          allowNull: true
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets", "dateNextMaintenance");
  }
};
