/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "alarmable" to table groups
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("groups")
      .then(tableDefinition => {
        if (tableDefinition.alarmable) return Promise.resolve();
        return queryInterface.addColumn("groups", "alarmable", {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 0
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("groups", "alarmable");
  }
};
