/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table altertrulesStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'alertrulesStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        title: {
          type: Sequelize.STRING(256),
          unique: true,
          allowNull: false
        },
        state: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 1
        },
        order: {
          type: Sequelize.INTEGER(3),
          allowNull: false,
          defaultValue: 1
        },
        lastChange: {
          type: Sequelize.DATE,
          defaultValue: Sequelize.literal('CURRENT_TIMESTAMP')
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("alertrulesStore");
  }
};