/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table altertrulesStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'alertrulesFiltersStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        filterType: {
          type: Sequelize.STRING(128),
          allowNull: false
        },
        filterParameters: {
          type: Sequelize.TEXT,
          allowNull: false
        },
        order: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 1
        },
        alertRuleId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'alertrulesStore',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        lastChange: {
          type: Sequelize.DATE,
          defaultValue: Sequelize.literal('CURRENT_TIMESTAMP')
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("alertrulesFiltersStore");
  }
};