/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table altertrulesGroupsStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'alertrulesGroupsStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        groupId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'groups',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        alertRuleId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'alertrulesStore',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        lastChange: {
          type: Sequelize.DATE,
          defaultValue: Sequelize.literal('CURRENT_TIMESTAMP')
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("alertrulesGroupsStore");
  }
};