/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "shortName" to groups table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("groups")
      .then(tableDefinition => {
        if (tableDefinition.shortName) return Promise.resolve();
        return queryInterface.addColumn("groups", "shortName", {
          type: Sequelize.STRING,
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("groups", "shortName");
  }
};