/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table qualifications to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'qualifications',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        name: {
          type: Sequelize.STRING(255),
          allowNull: false
        },
        shortName: {
          type: Sequelize.STRING(10),
          allowNull: false
        },
        timeLimited: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 0
        },
        state: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 1
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("qualifications");
  }
};