/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table qualifications to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'wallboardsStore',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        name: {
          type: Sequelize.STRING(255),
          allowNull: false
        },
        organizationId: {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'organizations',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        namesShownAs: {
          type: Sequelize.STRING(128),
          allowNull: false,
          defaultValue: 'lastname_firstname'
        },
        type: {
          type: Sequelize.STRING(64),
          allowNull: false,
          defaultValue: 'both'
        },
        isDefault: {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 0
        },
        state: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 1
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("wallboardsStore");
  }
};