/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_wallboards_qualifications to coredatabase
 * 
 */

'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_wallboards_qualifications',
      {
        wallboardId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'wallboardsStore',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        qualificationId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'qualifications',
            key: 'id',
            onDelete: 'CASCADE'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_wallboards_qualifications");
  }
};