/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_basedata_qualifications to coredatabase
 * 
 */

'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_basedata_qualifications',
      {
        basedataId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'basedata',
            key: 'id',
            onDelete: 'CASCADE'
          }
        },
        qualificationId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'qualifications',
            key: 'id',
            onDelete: 'CASCADE'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_basedata_qualifications");
  }
};