/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table assets_orders_states to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'assets_orders_states',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        label: {
          type: Sequelize.STRING(255),
          allowNull: false
        },
        identifier: {
          type: Sequelize.STRING(128),
          allowNull: false
        },
        isFinalState: {
          type: Sequelize.INTEGER(1),
          allowNull: true
        },
        colorCode: {
          type: Sequelize.STRING(7),
          allowNull: true
        },
        description: {
          type: Sequelize.TEXT,
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable('assets_orders_states');
  }
};