/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table assets_orders to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'assets_orders',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        supplierId: {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'suppliers',
            key: 'id'
          },
        },
        orderNumber: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        orderDate: {
          type: Sequelize.DATE,
          allowNull: false
        },
        orderedByBasedataId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'basedata',
            key: 'id'
          },
          allowNull: true
        },
        orderStateId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'assets_orders_states',
            key: 'id'
          },
          allowNull: true
        },
        notes: {
          type: Sequelize.TEXT,
          allowNull: true,
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable('assets_orders');
  }
};