/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table assets_goods_receipts to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'assets_goods_receipts',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        orderId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'assets_orders',
            key: 'id'
          },
          allowNull: true
        },
        deliveryNotesNumber: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        deliveryDate: {
          type: Sequelize.DATE,
          allowNull: false
        },
        productionUnit: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        productionUnitCheckDone: {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 0
        },
        quantitiy: {
          type: Sequelize.BIGINT,
          allowNull: true,
          defaultValue: 1
        },
        deliveryIsComplete: {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 1
        },
        deliveryIsPartial: {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 0
        },
        inspectedByBasedataId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'basedata',
            key: 'id'
          },
          allowNull: true
        },
        notes: {
          type: Sequelize.TEXT,
          allowNull: true,
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable('assets_goods_receipts');
  }
};