/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description prefills table wallboardsStore in coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.bulkInsert('assets_orders_states', 
      [
        { 
          label: 'in Erfassung', 
          identifier: 'registration',
          isFinalState: 0, 
          description: 'Bestellung wird erfasst und ist noch nicht an Lieferanten übermittelt.',
          colorCode: '#ff0000'
        },
        { 
          label: 'bestellt', 
          identifier: 'sentToSupplier',
          isFinalState: 0, 
          description: 'Bestellung wurde an den Lieferanten übermittelt',
          colorCode: '#90ff6e'
        },
        { 
          label: 'erwarte Lieferung',
          identifier: 'awaitDelivery', 
          isFinalState: 0, 
          description: 'Bestellung wurde von Lieferant bestätigt, warten auf Lieferung',
          colorCode: '#feff89'
        },
        { 
          label: 'Teillieferung erfolgt', 
          identifier: 'partlyDelivered',
          isFinalState: 0, 
          description: 'es erfolgte bereits eine Teillieferung, warten auf Lieferung der ausstehenden Positionen',
          colorCode: '#00ffd2'
        },
        { 
          label: 'Lieferung vollständig', 
          identifier: 'fulfilled',
          isFinalState: 1, 
          description: 'Bestellung wurde vollständig geliefert',
          colorCode: '#2ed8ba'
        },
        { 
          label: 'storniert', 
          identifier: 'cancelled',
          isFinalState: 1, 
          description: 'Bestellung wurde storniert',
          colorCode: '#c4cebc'
        }
      ]
    );
  }
};