/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table assets_orders_positions to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'assets_orders_positions',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        orderId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'assets_orders',
            key: 'id'
          },
          allowNull: true
        },
        position: {
          type: Sequelize.INTEGER,
          allowNull: false
        },
        creationDate: {
          type: Sequelize.DATE,
          defaultValue: Sequelize.literal('CURRENT_TIMESTAMP')
        },
        title: {
          type: Sequelize.TEXT,
          allowNull: true
        },
        count: {
          type: Sequelize.BIGINT,
          allowNull: true,
          defaultValue: 1
        },
        sum: {
          type: Sequelize.REAL,
          allowNull: true,
          defaultValue: 0
        },
        state: {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 1
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable('assets_orders_positions');
  }
};