/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new columns to feedbackStates table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("feedbackStates")
      .then(tableDefinition => {
        if (tableDefinition.order) return Promise.resolve();
        return queryInterface.addColumn("feedbackStates", "order", {
          type: Sequelize.INTEGER
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("feedbackStates", "order");
  }
};