/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new columns to feedbackStates table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("feedbackStates")
      .then(tableDefinition => {
        if (tableDefinition.stateTextColor) return Promise.resolve();
        return queryInterface.addColumn("feedbackStates", "stateTextColor", {
          type: Sequelize.STRING(6)
        })
      }).then(async function () {
        await queryInterface.sequelize.query(`UPDATE feedbackStates SET 'stateTextColor' = '#000000' WHERE id = 1`);
        await queryInterface.sequelize.query(`UPDATE feedbackStates SET 'stateTextColor' = '#FFFFFF' WHERE id = 2`);
        await queryInterface.sequelize.query(`UPDATE feedbackStates SET 'stateTextColor' = '#000000' WHERE id = 0`);
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("feedbackStates", "stateTextColor");
  }
};