/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column to assets_goods_receipts table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    queryInterface.describeTable("assets_goods_receipts")
      .then(tableDefinition => {
        if (tableDefinition.order) return Promise.resolve();
        return queryInterface.addColumn("assets_goods_receipts", "receiptNumber", {
          type: Sequelize.STRING(255)
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets_goods_receipts", "receiptNumber");
  }
};