/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "section" to operationsStore table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("operationsStore")
      .then(tableDefinition => {
        if (tableDefinition.section) return Promise.resolve();
        return queryInterface.addColumn("operationsStore", "section", {
          type: Sequelize.STRING,
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("operationsStore", "section");
  }
};