/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table gearGroups to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'gearGroups',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        groupname: {
          type: Sequelize.TEXT,
          allowNull: true
        },
        organizationId: {
          type: Sequelize.BIGINT,
          references: {
            model: 'organizations',
            key: 'id'
          },
          allowNull: false
        },
        shortName: {
          type: Sequelize.TEXT,
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable('gearGroups');
  }
};