/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_gear_gearGroups to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_gear_gearGroups',
      {
        assetId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'assets',
            key: 'id'
          }
        },
        groupId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'gearGroups',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_gear_gearGroups");
  }
};