/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column assetId to table users at coredatabase and changes basedataId
 * 
 */





'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    // Switch off constraints check for database
    var [results, metadata] = await queryInterface.sequelize.query("PRAGMA foreign_keys = OFF;");

    // now change the users table
    await queryInterface.describeTable("users")
      .then(tableDefinition => {
        return queryInterface.changeColumn("users", "basedataid", {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'basedata',
            key: 'id',
            onDelete: 'CASCADE'
          }
        })
      });

      await queryInterface.describeTable("users")
      .then(tableDefinition => {
        return queryInterface.addColumn("users", "assetId", {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'assets',
            key: 'id',
            onDelete: 'CASCADE'
          }
        })
      });

    await queryInterface.describeTable("users")
      .then(tableDefinition => {
        return queryInterface.changeColumn("users", "id", {
          type: Sequelize.BIGINT,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true,
        })
      });

    

    // Reenable constraint checks for database
    var [results, metadata] = await queryInterface.sequelize.query("PRAGMA foreign_keys = ON;");
  }
};