/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table eventsStore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'cron_tasks',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        name: {
          type: Sequelize.STRING(255),
          allowNull: false,
          unique: true
        },
        type: {
          type: Sequelize.STRING(255),
          allowNull: true
        },
        running: {
          type: Sequelize.BOOLEAN,
          allowNull: false,
          default: false
        },
        cronDefinition: {
          type: Sequelize.STRING(255),
          allowNull: false
        },
        data:{
          type: Sequelize.STRING(4096),
          allowNull: true
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("cron_tasks");
  }
};