/**
 * Migration Coredatabase
 * 
 * @autor Stefan Bauer
 * @description Adds a new column "isTest" to table operationsStore
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("operationsStore")
  .then(tableDefinition => {

    if (tableDefinition.isTest) return Promise.resolve();
      return queryInterface.addColumn("operationsStore","isTest",{
        type: Sequelize.BOOLEAN,
        defaultValue: 0
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("operationsStore","isTest");
  }
};
