/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "gearStateAllowed" to table groups
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("groups")
      .then(tableDefinition => {
        if (tableDefinition.gearStateAllowed) return Promise.resolve();
        return queryInterface.addColumn("groups", "gearStateAllowed", {
          type: Sequelize.INTEGER(1),
          allowNull: true,
          defaultValue: 0
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("groups", "gearStateAllowed");
  }
};
