/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "token" to table wallboardsStore
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("wallboardsStore")
  .then(tableDefinition => {

    if (tableDefinition.token) return Promise.resolve();
      return queryInterface.addColumn("wallboardsStore","token",{
        type: Sequelize.STRING,
        defaultValue: ''
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("wallboardsStore","token");
  }
};
