/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table organizationsTypes to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'organizationsTypes',
       {
         id: {
           type: Sequelize.BIGINT,
           unique: true,
           allowNull: false,
           primaryKey: true,
           autoIncrement: true
         },
         title: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         description: {
           type: Sequelize.STRING(256),
           unique: false,
           allowNull: true
         },
         state: {
           type: Sequelize.INTEGER(1),
           allowNull: false,
           defaultValue: 1
         },
         unique: {
           type: Sequelize.INTEGER(1),
           allowNull: false,
           defaultValue: 0
         },
         icon: {
           type: Sequelize.STRING,
           allowNull: true
         },
         colors: {
           type: Sequelize.TEXT,
           allowNull: true
         }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("organizationsTypes");
   }
 };