/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description prefills table organizationsTypes in coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.bulkInsert('organizationsTypes', 
      [
        { 
          title: 'Träger / Gemeinde', 
          description: 'Organisation der Träger-/Gemeindeebene. Es kann nur eine Organisation diese Typs angelegt werden.',
          state: 1, 
          unique: 1,
          icon: 'mdi-city',
          colors: '[{background:"#00ff00", text:"#000000"}]'
        },
        { 
          title: 'Rettungsorganisation', 
          description: 'Ebene der Rettungsorganisation. Kann auch verschachtelt werden',
          state: 1, 
          unique: 0,
          icon: 'mdi-bullhorn',
          colors: '[{background:"#ff0000", text:"#ffffff"}]'
        },
        { 
          title: 'Vereinsebene', 
          description: 'Verein, der einer Rettungsorganisation zugehörig ist.',
          state: 1, 
          unique: 0,
          icon: 'mdi-music-box',
          colors: '[{background:"#0000FF", text:"#ffffff"}]'
        },
        { 
          title: 'Jugendfeuerwehr', 
          description: 'Besonderer Bereich der Jugendorganisation innerhalb einer Rettungsorganisation.',
          state: 1, 
          unique: 1,
          icon: 'mdi-odnoklassniki',
          colors: '[{background:"#ff0000", text:"#ffffff"}]'
        }
      ]
    );
  }
};