/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "organizationsType" to organizations table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("organizations")
      .then(tableDefinition => {
        if (tableDefinition.organizationsType) return Promise.resolve();
        return queryInterface.addColumn("organizations", "organizationsType", {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'organizationsTypes',
            key: 'id'
          },
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("organizations", "organizationsType");
  }
};