/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "configAlarm" to wallboardsStore table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("wallboardsStore")
      .then(tableDefinition => {
        if (tableDefinition.configAlarm) return Promise.resolve();
        return queryInterface.addColumn("wallboardsStore", "configAlarm", {
          type: Sequelize.TEXT,
          allowNull: true,
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("wallboardsStore", "configAlarm");
  }
};