/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "basedataId" to table assets
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets")
  .then(tableDefinition => {

    if (tableDefinition.basedataId) return Promise.resolve();
      return queryInterface.addColumn("assets","basedataId",{
        type: Sequelize.BIGINT,
        allowNull: true,
        references: {
          model: 'basedata',
          key: 'id'
        }
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets","basedataId");
  }
};
