/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "locationId" to table wallboardsStore
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("wallboardsStore")
  .then(tableDefinition => {

    if (tableDefinition.locationId) return Promise.resolve();
      return queryInterface.addColumn("wallboardsStore","locationId",{
        type: Sequelize.BIGINT,
        allowNull: true,
        references: {
          model: 'locations',
          key: 'id'
        }
        })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("wallboardsStore","locationId");
  }
};
