/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table uploads to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'uploads',
      {
        id: {
          type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
        },
        title: {
          type: Sequelize.STRING(256),
          unique: false,
          allowNull: false
        },
        filepath: {
          type: Sequelize.STRING(256),
          unique: false,
          allowNull: false
        },
        filename: {
          type: Sequelize.STRING(256),
          unique: false,
          allowNull: false
        },
        mimetype: {
          type: Sequelize.STRING(256),
          allowNull: false
        },
        module: {
          type: Sequelize.STRING(256),
          unique: false,
          allowNull: false
        },
        state: {
          type: Sequelize.INTEGER(1),
          allowNull: false,
          defaultValue: 1
        },
        createdAt: {
          type: Sequelize.DATE(3),
          defaultValue: Sequelize.literal('CURRENT_TIMESTAMP'),
        },
        createdBy: {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'basedata',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("uploads");
  }
};