/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_operations_organizations to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_operations_organizations',
      {
        operationsId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'operationsStore',
            key: 'id'
          }
        },
        organizationsId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'organizations',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_operations_organizations");
  }
};