/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "section" to operationsStore table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    // Switch off constraints check for database
    var [results, metadata] = await queryInterface.sequelize.query("PRAGMA foreign_keys = OFF;");

    await queryInterface.describeTable("operationsStore")
    .then(tableDefinition => {
      return queryInterface.changeColumn("operationsStore", "id", {
        type: Sequelize.BIGINT,
          unique: true,
          allowNull: false,
          primaryKey: true,
          autoIncrement: true
      })
    });

    // Switch off constraints check for database
    var [results, metadata] = await queryInterface.sequelize.query("PRAGMA foreign_keys = ON;");
    
  }
  
};