/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "objectTable" to table uploads
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("uploads")
    .then(tableDefinition => {
      if (tableDefinition.objectTable) return Promise.resolve();
        return queryInterface.addColumn("uploads","objectTable",{
          type: Sequelize.STRING,
          allowNull: true
          })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("uploads","objectTable");
  }
};
