/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "createdAt" to table operationsStore
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');
 
module.exports = {
  up: async (queryInterface) => {
 
    queryInterface.describeTable("operationsStore")
    .then(tableDefinition => {
      if (tableDefinition.createdAt) return Promise.resolve();
      
      return queryInterface.addColumn("operationsStore","createdAt",{
        type: Sequelize.DATE,
        allowNull: true
      })
    });
  },
 
  down: async (queryInterface) => {
     await queryInterface.removeColumn("operationsStore","createdAt");
  }
};
 