/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table accessGroupsStore to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'accessGroupsStore',
       {
         id: {
           type: Sequelize.BIGINT,
           unique: true,
           allowNull: false,
           primaryKey: true,
           autoIncrement: true
         },
         alias: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         title: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         description: {
           type: Sequelize.STRING(256),
           unique: false,
           allowNull: true
         },
         parentGroup: {
           type: Sequelize.BIGINT,
           allowNull: true,
           references: {
             model: 'accessGroupsStore',
             key: 'id'
           }
         }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("accessGroupsStore");
   }
 };
