/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table accessEndpointsStore to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'accessEndpointsStore',
       {
         id: {
           type: Sequelize.BIGINT,
           unique: true,
           allowNull: false,
           primaryKey: true,
           autoIncrement: true
         },
         accessGroup: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'accessGroupsStore',
            key: 'id'
          }
        },
         alias: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         title: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         description: {
           type: Sequelize.STRING(256),
           unique: false,
           allowNull: true
         },
         grantType: {
           type: Sequelize.STRING(64),
           unique: false,
           allowNull: false
         }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("accessEndpointsStore");
   }
 };
