/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_roles_accessEndpoints to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_roles_accessEndpoints',
      {
        roleId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'roles',
            key: 'id'
          }
        },
        accessEndpointAlias: {
          type: Sequelize.TEXT,
          allowNull: false,
          references: {
            model: 'accessEndpointsStore',
            key: 'alias'
          }
        },
        granted: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantCreate: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantRead: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantModify: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantRemove: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantNotification: {
          type: Sequelize.INTEGER(1),
          defaultValue: 0
        },
        grantLimit: {
          type: Sequelize.BIGINT,
          defaultValue: 0
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_roles_accessEndpoints");
  }
};
