/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description prefills table accessEndpointsStore in coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.bulkInsert('accessEndpointsStore',
      [
        // General
        {
          id: 3,
          accessGroup: 2,
          alias: 'accessAreaAdmin',
          title: 'Zugriff auf Administrationsbereich',
          description: 'Benutzer dieser Rolle haben Zugriff auf den Administrationsbereich',
          grantType: 'GRANT'
        },
        {
          id: 4,
          accessGroup: 3,
          alias: 'serversettings',
          title: 'Zugriff auf Servereinstellungen',
          description: 'Servergrundeinstellungen einsehen und verändern',
          grantType: 'GRANT'
        },
        {
          id: 5,
          accessGroup: 4,
          alias: 'plugins',
          title: 'Zugriff auf Plugins-Bereich',
          description: 'Benutzer dieser Rolle haben Zugriff auf Plugins',
          grantType: 'CRUD'
        },
        {
          id: 6,
          accessGroup: 4,
          alias: 'pluginsUseEvents',
          title: 'Auslösen von Plugin-Events',
          description: 'Benutzer dieser Rolle können Events für Plugins auslösen',
          grantType: 'GRANT'
        },
        {
          id: 7,
          accessGroup: 5,
          alias: 'accessmanagement',
          title: 'Zugriff auf Berechtigungsgruppen und Berechtigungsvergabe',
          description: 'Benutzer dieser Rolle können Berechtigungen einsehen und bearbeiten',
          grantType: 'GRANT'
        },
        {
          id: 8,
          accessGroup: 5,
          alias: 'accessmanagementListGroups',
          title: 'Berechtigungsgruppen lesen',
          description: 'Benutzer dieser Rolle können Berechtigungsgruppen einsehen',
          grantType: 'GRANT'
        },
        {
          id: 9,
          accessGroup: 5,
          alias: 'accessmanagementGrants',
          title: 'Zugriff Berechtigungsvergabe',
          description: 'Detaillierte Berechtigungsvergabe',
          grantType: 'CRUD'
        },
        {
          id: 10,
          accessGroup: 6,
          alias: 'logfiles',
          title: 'Zugriff auf Logfiles des ALARMiator Servers',
          description: 'Benutzer dieser Rolle haben Zugriff auf die Logfiles des ALARMiator Servers',
          grantType: 'CRUD'
        },
        {
          id: 11,
          accessGroup: 7,
          alias: 'backupmanagement',
          title: 'Zugriff auf Backupsteuerung',
          description: 'Benutzer dieser Rolle können Backups erstellen und wiederherstellen',
          grantType: 'GRANT'
        },
        {
          id: 12,
          accessGroup: 8,
          alias: 'cronmanager',
          title: 'Zugriff auf Aufgabenverwaltung',
          description: 'Benutzer dieser Rolle können die Aufgabenplanung einsehen und geplante Aufgaben bearbeiten',
          grantType: 'GRANT'
        },
        {
          id: 13,
          accessGroup: 9,
          alias: 'systemadmin',
          title: 'Zugriff auf Systembereich',
          description: 'Benutzer dieser Rolle können den Server neu starten oder herunterfahren',
          grantType: 'GRANT'
        },
      ]
    );
  }
};