/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "appVersion" to table alertdevices
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("alertdevices")
  .then(tableDefinition => {

    if (tableDefinition.appversion) return Promise.resolve();
      return queryInterface.addColumn("alertdevices","appversion",{
        type: Sequelize.TEXT,
        defaultValue: null,
        allowNull: true
      })
    });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("alertdevices","appversion");
  }
};
