/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "emailOffice" to table basedata
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("basedata")
      .then(tableDefinition => {
        if (tableDefinition.emailOffice) return Promise.resolve();
        return queryInterface.addColumn("basedata", "emailOffice", {
          type: Sequelize.STRING,
          allowNull: true
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("basedata", "emailOffice");
  }
};
