/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table assets_parameters_options to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'assets_parameters_options',
       {
         id: {
           type: Sequelize.BIGINT,
           unique: true,
           allowNull: false,
           primaryKey: true,
           autoIncrement: true
         },
         parameterId: {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'assets_parameters',
            key: 'id'
          }
         },
         label: {
           type: Sequelize.STRING(256),
           unique: false,
           allowNull: false
         },
         alias: {
           type: Sequelize.STRING(256),
           unique: true,
           allowNull: false
         },
         legacyAlias: {
          type: Sequelize.BIGINT,
          allowNull: true
         },
         sortorder: {
           type: Sequelize.INTEGER,
           allowNull: false,
           defaultValue: 0
         },
         state: {
           type: Sequelize.BIGINT,
           allowNull: false,
           defaultValue: 1
         }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("assets_parameters_options");
   }
 };
