/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "parentGroupId" to assets_groups table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets_groups")
      .then(tableDefinition => {
        if (tableDefinition.uuid) return Promise.resolve();
        return queryInterface.addColumn("assets_groups", "parentGroupId", {
          type: Sequelize.BIGINT,
          allowNull: true,
          references: {
            model: 'assets_groups',
            key: 'id'
          }
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets_groups", "parentGroupId");
  }
};