/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "colorBg" to assets_states table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets_states")
      .then(tableDefinition => {
        if (tableDefinition.colorBg) return Promise.resolve();
        return queryInterface.addColumn("assets_states", "colorBg", {
          type: Sequelize.STRING,
          allowNull: true
        })
      })
      .then(tableDefinition => {
        if (tableDefinition.colorFg) return Promise.resolve();
        return queryInterface.addColumn("assets_states", "colorFg", {
          type: Sequelize.STRING,
          allowNull: true
        })
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets_groups", "colorBg");
    await queryInterface.removeColumn("assets_groups", "colorFg");
  }
};