/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds color definition to table assets_states at coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("assets_states")
      .then(async function () {
        console.log('MIGRATION-TASK | --> migrating assets states definitions at database by enriching with state colors');
        await queryInterface.sequelize.query('SELECT * FROM assets_states')
          .then(function (rows) {
            if (rows[0] !== null) {
              console.log('MIGRATION-TASK | --> found ' + rows.length + ' entries to migrate' );
              if (rows[0].length > 0) {
                var i;
                for (i = 0; i < rows[0].length; i++) {
                  let stateId = rows[0][i].id;
                  console.log('MIGRATION-TASK | Processing assets_state with id ' + stateId);
                  var colorFg = '#000000';
                  var colorBg = '#ffffff';
                  switch (stateId) {
                    case 1: 
                      colorBg = '#005c2f';
                      colorFg = '#ffffff';
                      break;
                    case 2: 
                      colorBg = '#c48600';
                      colorFg = '#ffffff';
                      break;
                    case 3: 
                      colorBg = '#ff0000';
                      colorFg = '#ffffff';
                      break;
                    case 4: 
                      colorBg = '#c4001d';
                      colorFg = '#ffffff';
                      break;
                    case 5:
                      colorBg = '#ff1744';
                      colorFg = '#ffffff';
                      break;
                    case 6:
                      colorBg = '#37474f';
                      colorFg = '#b0bec5';

                  }
                  let query = `UPDATE assets_states SET colorFg = '${colorFg}', colorBg = '${colorBg}' WHERE id = ${stateId}`;
                  queryInterface.sequelize.query(query);                  
                } 
              } else {
                // there are no values defined
                console.log('MIGRATION-TASK | No values found for assets_parameter with id ' + parameterId )
              }
            }
          });
    })
  }
}
