/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstuehler
 * @description Adds a new column "failState" to table fcmtokenStore
 * 
 */


'use strict';

const sequelize = require('sequelize');
const { Sequelize } = require('sequelize');
const uuidv1 = require('uuid').v1;


module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("fcmtokenStore")
      .then(tableDefinition => {
        if (tableDefinition.failState) return Promise.resolve();
        return queryInterface.addColumn("fcmtokenStore", "failState", {
          type: Sequelize.INTEGER,
          defaultValue: 0,
          allowNull: false
        });
      });
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("fcmtokenStore", "failState");
  }
};
