/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table accessTokensStore to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'accessTokensStore',
       {
          id: {
            type: Sequelize.BIGINT,
            unique: true,
            allowNull: false,
            primaryKey: true,
            autoIncrement: true
          },
          token: {
            type: Sequelize.STRING,
            unique: true,
            allowNull: false
          },
          description: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: true
          },
          type: {
            type: Sequelize.STRING(128),
            unique: false,
            allowNull: true
          },
          state: {
            type: Sequelize.INTEGER(1),
            allowNull: false,
            defaultValue: 1
          },
          lastseen: {
            type: Sequelize.REAL,
            defaultValue: 'CURRENT_TIMESTAMP'
          },
          registeredAt: {
            type: Sequelize.REAL,
            defaultValue: 'CURRENT_TIMESTAMP'
          }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("accessTokensStore");
   }
 };
