/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_roles_accesstokensstore to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_roles_accesstokensstore',
      {
        roleId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'roles',
            key: 'id'
          }
        },
        accesstokensstoreId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'accessTokensStore',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_roles_accesstokensstore");
  }
};
