/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "uuid" to uploads table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("uploads")
      .then(tableDefinition => {
        if (tableDefinition.uuid) return Promise.resolve();
        return queryInterface.addColumn("uploads", "uuid", {
          type: Sequelize.STRING,
          allowNull: true
        })
      })
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("assets", "uuid");
    await queryInterface.removeColumn("assets", "uuid");
  }
};