/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table xt_operations_usergroups to coredatabase
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {
    await queryInterface.createTable(
      'xt_operations_usergroups',
      {
        operationsId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'operations',
            key: 'id'
          }
        },
        usersgroupsId: {
          type: Sequelize.BIGINT,
          allowNull: false,
          references: {
            model: 'users_groups',
            key: 'id'
          }
        }
      });
  },

  down: async (queryInterface) => {
    await queryInterface.dropTable("xt_operations_usergroups");
  }
};
