/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table emailTemplatesStore to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'emailTemplatesStore',
       {
          id: {
            type: Sequelize.BIGINT,
            unique: true,
            allowNull: false,
            primaryKey: true,
            autoIncrement: true
          },
          namespace: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: false
          },
          alias: {
            type: Sequelize.STRING,
            unique: true,
            allowNull: false
          },
          html: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: true
          },
          plain: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: true
          }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("emailTemplatesStore");
   }
 };
