/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new table emailQueue to coredatabase
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
     await queryInterface.createTable(
       'emailQueue',
       {
          id: {
            type: Sequelize.BIGINT,
            unique: true,
            allowNull: false,
            primaryKey: true,
            autoIncrement: true
          },
          createdAt: {
            type: Sequelize.REAL,
            defaultValue: 'CURRENT_TIMESTAMP',
            allowNull: false
          },
          subject: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: false
          },
          html: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: true
          },
          plain: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: true
          },
          recipients: {
            type: Sequelize.STRING,
            unique: false,
            allowNull: false
          },
          sendState: {
            type: Sequelize.INTEGER,
            defaultValue: 0,
            allowNull: false
          }
       });
   },
 
   down: async (queryInterface) => {
     await queryInterface.dropTable("emailQueue");
   }
 };
