/**
 * Migration Coredatabase
 * 
 * @autor Jens Dinstühler
 * @description Adds a new column "paused" to respiratoryStore table
 * 
 */


'use strict';

const { Sequelize } = require('sequelize');

module.exports = {
  up: async (queryInterface) => {

    queryInterface.describeTable("respiratoryStore")
      .then(tableDefinition => {
        if (tableDefinition.paused) return Promise.resolve();
        return queryInterface.addColumn("respiratoryStore", "paused", {
          type: Sequelize.INTEGER,
          allowNull: false,
          defaultValue: 0
        })
      })
  },

  down: async (queryInterface) => {
    await queryInterface.removeColumn("respiratoryStore", "paused");
  }
};