/**
 * Migration Coredatabase
 * 
 * @autor Peter Ilfrich
 * @description Adds a new column "recoverytoken" to users table
 * 
 */


 'use strict';

 const { Sequelize } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
 
     queryInterface.describeTable("users")
       .then(tableDefinition => {
         if (tableDefinition.recoverytoken) return Promise.resolve();
         return queryInterface.addColumn("users", "recoverytoken", {
           type: Sequelize.STRING,
           allowNull: true,
           defaultValue: null,
         })
       })
   },
 
   down: async (queryInterface) => {
     await queryInterface.removeColumn("users", "recoverytoken");
   }
 };