/**
 * Migration Coredatabase
 * 
 * @autor Peter Ilfrich
 * @description Adds a new column "image_data" to basedata and organization table for base64 image data
 * 
 */


 'use strict';

 const { DataTypes } = require('sequelize');
 
 module.exports = {
   up: async (queryInterface) => {
    // add column to basedata table
    queryInterface.describeTable("basedata")
        .then(tableDefinition => {
            if (tableDefinition.image_data) return Promise.resolve();
            return queryInterface.addColumn("basedata", "image_data", {
                type: DataTypes.TEXT,
                allowNull: true,
                defaultValue: null,
            })
       })
   },
 
   down: async (queryInterface) => {
     await queryInterface.removeColumn("basedata", "image_data");
   }
 };