/**
 * Core Object for reports
 * @namespace core/reports
 * @class
 */
class reports {
    /**
     * Returns an empty reports object
     * @constructor
     */
    constructor(logger) {
        this.logger = logger;
    }

    /**
     * Returns list of reports from core database
     * @param {function} callback rows or null
     */
    getListOfReports(callback) {
        let query = "SELECT * FROM reportsStore";
        global.coreDb.all(query, [], (err, rows) => {
            if (err) {
              this._logger.error('MODELS-CORE-REPORTS | Error loading reports list from core data: ' + err.message);
              return callback(null);
            } else {
              return callback(rows);
            }
          });
    }

    
}

module.exports = reports;

