/**
 * 
 *  Handles maintenancen tasks for assets
 * 
 *  (c) Jens Dinstühler 2020
 * 
 *  Version 1.0.0
 * 
 * 
 */

const EventEmitter = require('events');
const Assets = require('../assets');

class CoreAssetsHandler extends EventEmitter {
    constructor() {
        super();
        global.cron.on('event_cron_every_5_minutes', (title) => {
            console.log('CORE | HANDLER | ASSETS | event catched: event_cron_every_5_minutes from job ' + title);
            this.doMaintenance();
        })
    }

    /**
     * central method called if cron fires maintenance event
     */
    doMaintenance() {
        console.log('CORE | HANDLER | ASSETS | starting maintenance for Assets / Inventory now');
        var assets = new Assets(global.logger);
        assets.getAssetsEnteringMaintenanceInDays(14, (rowsAssetsGoToMaintenance) => {
            console.log(rowsAssetsGoToMaintenance);
            if (rowsAssetsGoToMaintenance !== null) {
                console.log('CORE | HANDLER | ASSETS | found ' + rowsAssetsGoToMaintenance.length + ' assets entering maintenance within the next 14 days');
            } else {
                console.log('CORE | HANDLER | ASSETS | Error checking for Assets entering maintenancen within next 14 days');
            }
        })
    }




}

module.exports = CoreAssetsHandler;