/**
 * 
 *  Handles Maintenance Tasks
 * 
 *  (c) Jens Dinstühler 2021
 * 
 *  Version 1.0.0
 * 
 * 
 */

const EventEmitter = require('events');
const Operations = require('../operationshelper');
const Assets = require('../assets');
const Respiratory = require('../respiratory');
class CoreMaintenanceHandler extends EventEmitter {
    constructor() {
        super();
    }

    /**
     * Method for nightly maintenance tasks
     */
    doMaintenance() {
        var respiratory = new Respiratory(global.app.logger);
        respiratory.doMaintenance();
        var assets = new Assets(global.app.logger);
        assets.doMaintenance();
    }


    /**
     * Handler for maintenance tasks which has to be run every 2 minutes
     */
    do2MinMainenance() {
        var operations = new Operations(global.app.logger);
        operations.doMaintenance();
        var assets = new Assets(global.app.logger);
        assets.doMaintenance();
    }    
}

module.exports = CoreMaintenanceHandler;