/**
 * 
 *  Handles requested test alarms
 * 
 *  (c) Stefan Bauer 2021
 * 
 *  Version 1.0.0
 * 
 * 
 */

const EventEmitter = require('events');
const moment = require("moment");
class RequestedTestAlarmHandler extends EventEmitter {
    
    queuedTestAlarms = [];

    /**
     * @constructor
     */
    constructor() {
        super();
    }


    addTestalarmCronjob(basedataId, token, offset){

        // build data-object for cronjob
        var cronjob_dataobject = {};
        cronjob_dataobject.event_name = basedataId + '_' + token + '_' + moment().format('YYYYMMDDhhmmss');

        cronjob_dataobject.event_data = {
            token: token,
            basedataId: basedataId
        };

        // build cron-schedule based on offset in seconds
        var cronschedule = moment().add(offset, 'seconds');

        var created = global.cron.AddCronJob(cronjob_dataobject.event_name, 'app_testalarm', cronschedule, cronjob_dataobject, null);
        if(created){
            global.cron.on(cronjob_dataobject.event_name, (data) =>{
                //fire the alarm for the user with basedataid and token here!!!;
                console.log('the token to send the app-requested testalarm to: ' + data.event_data['token'])

                global.plgManager.event_new_token_test_alarm(data.event_data['basedataId'], 'alarmiatormobile', data.event_data['token']);

                //let the cronjob remove it self from cron-manager
                var deleted = global.cron.DeleteCronJob(data.event_name);

            });
            
            // start the cronjob
            var started = global.cron.StartCronJob(cronjob_dataobject.event_name);
        } else {
            console.log('adding app-requuested testalarm to cron_core failed!')
        }
    }

}

module.exports = RequestedTestAlarmHandler;