/*
//
//  Class offers helper functions for 
//  calculation of geocoordinates etc.
//
*/

var gk = require('gauss-krueger');

class geolocationhelper {

    constructor() {
      // always initialize all instance properties
    }

    gkToLatLon(gkKoordinatesString, callback) {
        
        // First get rid of "(G-K Zone 4) "
        var gkArray = gkKoordinatesString.split('(', 2)
        if (Array.isArray(gkArray)) {
            var gkValueStr = gkArray[0];
        } else {
            var gkValueStr = gkKoordinatesString;
        }

        // Remove all whitespace
        gkValueStr = gkValueStr.replace(/(^\s+|\s+$)/g, '');

        // Split GK coordinates (x / y)
        var gkArray = gkValueStr.split('/', 2);
        if (Array.isArray(gkArray)) {
            var gkValueStrX = gkArray[0];
            var gkValueStrY = gkArray[1];
        } else {
            var gkValueStrX = 0;
            var gkValueStrY = 0;
        }

        // console.debug('gkValueStrX: ' + gkValueStrX + ' | gkValueStrY: ' + gkValueStrY);

        // Calculate Latitude and Longitude
        
        let wgs84 = gk.toWGS(
                {
                    x: parseFloat(gkValueStrX), 
                    y: parseFloat(gkValueStrY)
                }
            );
        // let wgs84 = gk.toWGS({x: 4454138.78, y: 5486984.54});

        callback(wgs84);
        //return wgs84;
    }
}
  // export the class
  module.exports = geolocationhelper;
  