const openrouteservice = require("openrouteservice-js");
const Configuration = require("./configuration");

/**
 * Class represents Openrouteservice
 * @class
 * @author Stefan Bauer
 */
class openrouteservicehelper {

  /**
   * @constructor
   */
  constructor(logger) {
    // always initialize all instance properties
    this._logger = logger;
    this.configuation = new Configuration(this._logger);

  }

  calculateRouteGeoJSONWithAPI(startLat, startLon, destinationLat, destinationLon, callback) {
    // Returns a promise
    var start = [startLon, startLat];
    var destination = [destinationLon, destinationLat];
    console.log("Sending route Request to OpenRouteService");
    this.configuation.getValueForKeyword("wallboardORAPIKey",  (apiKey) => {
      // add your api_key here
      this.directions = new openrouteservice.Directions({
        api_key: apiKey
      });
      callback(() => {
        return this.directions.calculate({
          coordinates: [start, destination],
          profile: 'driving-car',
          extra_info: ['waytype', 'steepness'],
          //avoidables: ['tollways', 'ferries', 'fords'],
          format: 'geojson'
        })
      })
    })
  }
}

// export the class
module.exports = openrouteservicehelper;