

class organizationstypes {
    constructor(logger) {
        // always initialize all instance properties
        this._logger = logger;
    }

    /**
     * returns rows of all organizations types in core database
     * @param {*} req 
     * @param {*} res 
     * @param {*} callback 
     */
    getListOfOrganizationsTypes(callback) {
        let query = "SELECT * FROM `organizationstypes`";
        global.coreDb.all(query, [], (err, rows) => {
            if (err) {
                return callback(null);
            } else {
                return callback(rows);
            }
        });
    }


    /**
     * Returns database row for organizationtype with given typeId
     * @param {integer} typeId 
     * @param {rows} callback 
     */
    getOrganizationTypeWithId(typeId, callback) {
        let query = "SELECT * FROM `organizationsTypes` WHERE id = ?";
        global.coreDb.all(query, [
            typeId
        ], (err, rows) => {
            if (err) {
                return null;
            } else {
                return callback(rows);
            }
        });
    }

    

}

// export the class
module.exports = organizationstypes;
