
/**
 * ALARMiator Rule Component
 * 
 * @summary: Evaluates agains Gears listed in operation
 * @description:Checks if a operation gearlist containt the given gears
 * 
 * @author Jens Dinstühler
 * 
 */

const RuleEngineHelpers = require('../ruleEngineHelpers');

class ruleComponentGear {

    constructor() {
        this.helper = new RuleEngineHelpers();
    }

    /**
     * sets the parameters for this rule
     * @param {object} parameters 
     * @returns {object} success (true/false)
     */
    setRuleParameters(parameters) {
        if (this.helper.isDefined(parameters)) {
            this.gearList = parameters;
            return true;
        } else {
            return false;
        }
    }

    /**
     * Evaluates the rule against a given operation object
     * @param {operation} operation operation object
     * @returns {boolean} true / false
     */
    evaluate(operation) {
        if (typeof operation != 'undefined') {
            if (typeof operation.gearCalc != 'undefined') {
                if (typeof operation.gearCalc.value != 'undefined') {
                    // gearCalc seems to be defined
                    var gearlist = operation.gearCalc.value;
                    var gearFound = false;
                    gearlist.forEach(gearRequested => {
                        if (this.gearList.indexOf(gearRequested) > -1) {
                            gearFound = true;
                        } 
                    });
                    return gearFound;
                } else {
                    return null;
                }
            } else {
                return null;
            }
        } else {
            return null;
        }
    }

}

module.exports = ruleComponentGear;