/*
//
//  Class offers helper functions wallboard 
//
*/

class wallboardhelper {

    constructor() {
      // always initialize all instance properties
    }

    getBaseLatitudeLongitudeForOrganization(orgId, callback) {
        // Reads the geo coordinates set for an organization for routing information at the wallboard
        let query = "SELECT * FROM `organizations` WHERE id = ?";
        global.coreDb.all(query, [
            orgId
          ], (err, rows) => {
            if (err) {
              return callback(null);
            } else {
              return callback(rows[0]);
            }
          });
    }

    getOperationsList(callback) {
        var result = [], index = {};
        let query = "SELECT operations.*, operations_ressources.id AS ressoucreid, operations_ressources.nameraw AS ressourcenameraw, operations_ressources.namecustom AS ressourcenamecustom, organizations.latitude AS homelatitude, organizations.longitude AS homelongitude FROM `operations` LEFT JOIN operations_ressources ON operations.id = operations_ressources.operationid LEFT JOIN organizations ON operations.organizationId = organizations.id WHERE operations.acknowledged = 0 ORDER BY operations.timestampincome DESC";
        db.query(query, (err, rows) => {
            if (err) {
                console.error('Error in Reading active operations from database');
                //console.error('SQL-Query: ' + query);
                console.error('SQL-Error: ' + err);
            } else {
                if(rows.length > 0) {
                    // There is at least one not acknowledged operation
                    // Proceed with reading requsted ressources
                    rows.forEach(function (row) {
                        // Reads the geo coordinates set for an organization for routing information at the wallboard
                            
                            if ( !(row.id in index) ) {
                                index[row.id] = {
                                    id: row.id,
                                    acknowledged: row.acknowledged,
                                    operationguid: row.operationguid,
                                    operationnumber: row.operationnumber,
                                    timestampincome: row.timestampincome,
                                    timestampalarm: row.timestampalarm,
                                    messenger: row.messenger,
                                    comment: row.comment,
                                    plan: row.plan,
                                    priority: row.priority,
                                    einsatzortobject: row.einsatzortobject,
                                    einsatzortzipcode: row.einsatzortzipcode,
                                    einsatzortcity: row.einsatzortcity,
                                    einsatzortstreet: row.einsatzortstreet,
                                    einsatzortstreetnumber: row.einsatzortstreetnumber,
                                    einsatzortintersection: row.einsatzortintersection,
                                    einsatzortproperty: row.einsatzortproperty,
                                    einsatzortGKcoordinates: row.einsatzortGKcoordinates,
                                    einsatzortlat: row.einsatzortlat,
                                    einsatzortlon: row.einsatzortlon,
                                    zielortobject: row.zielortobject,
                                    zielortzipcode: row.zielortzipcode,
                                    zielortcity: row.zielortcity,
                                    zielortstreet: row.zielortstreet,
                                    zielortstreetnumber: row.zielortstreetnumber,
                                    zielortintersection: row.zielortintersection,
                                    zielortlat: row.zielortlat,
                                    zielortlon: row.zielortlon,
                                    keyword: row.keyword,
                                    keywordmisc: row.keywordmisc,
                                    rawjson: row.rawjson,
                                    srcservice: row.srcservice,
                                    homelatitude: row.homelatitude,
                                    homelongitude: row.homelongitude,
                                    ressources: []
                                };
                                result.push(index[row.id]);
                            }
                            index[row.id].ressources.push({
                                ressourceid: row.ressourceid,
                                ressourcenameraw: row.ressourcenameraw,
                                ressourcenamecustom: row.ressourcenamecustom
                            });

                        });
                } 
                callback(result);               
            }
        });
     }
}

    

  // export the class
  module.exports = wallboardhelper;
  