class Plugin {
    constructor() {
        this.name = '';             // Short Name for the plugin. Will be shown in UI
        this.namespace = '';        // technical Name without spaces used as a namespace for this plugin
        this.logidentifier = '';    // Name shown in front of log messages from this plugin
        this.version = '';          // Version of the plugin in scheme 1.0.0
        this.description = '';      // description, will be shown in UI
        this.main = '';             // main script called during plugin initialization
        this.author = '';           // author of the plugin, shown in UI
        this.plgtype = null;           // type of plugin ('inbound', 'outbound')
        this.isService = false;     // Does this plugin provide a forked service?
        this.state = 0;             // State of plugin  (1 = active, 0 = inactive)
        this.pluginpath = '';       // file path to plugin-directory
        this.setupMethod = null;    // method of plugin which is called during initial installation of plugin
        this.updateMethod = null;   // method of plugin which is called during update of plugin to new version
        this.configstore = '';      // Configuration Schema of plugin as JSON-String
        this.alarmingByUser = 0;    // Does the plugin offer alerting on a by user basis or alerting without context of users
        this.fcmtokenconsumer = 0;  // Does the plugin consume fcm tokens for alerting
    }
}

module.exports = Plugin;