const Operations = require('../../../../../models/operationshelper');
const Auth = require('../../../../../models/auth');
const Fcmtokens = require('../../../../../models/fctmtokens');
const Groups = require('../../../../../models/groups');
module.exports = {
    
    requestTestAlarm(request, response) {
        const username = request.swagger.params.username.value;
        const passwordMd5 = request.swagger.params.passwordhash.value;
        const token = request.swagger.params.token.value;
        var offset = 0;
        if (typeof request.swagger.params.offset.value != 'undefined') {
            offset = request.swagger.params.offset.value;
        }

        console.log('API | requestTestAlarm');

        if ((username.length > 0) && (passwordMd5.length > 0)) {
            var auth = new Auth(global.logger);
            auth.authenticateUserMD5(username, passwordMd5, (success, row) => {
                if (success) {
                    // HIER MUSS DIE LOGIK FÜR DEN TESTALARM REIN
                    var fcmtokens = new Fcmtokens(global.logger);
                    fcmtokens.getAllFCMTokensForBasedataAndNamespace('alarmiatormobile',row.basedataId, (fcmTokenRows) => {
                        if (fcmTokenRows != null){
                            if (fcmTokenRows.length > 0){
                                if (fcmTokenRows.find( x => x.fcmToken == token) !== undefined) {
                                    var requestTestAlarm = {
                                        basedataId: row.basedataId,
                                        token: token,
                                        offset: offset
                                    }
                                    var sendMessage = {
                                        requestTestAlarm : requestTestAlarm
                                    }
                                    process.send(JSON.stringify(sendMessage));
                                    if (offset == 0){
                                        // send alarm now!
                                        response.json(
                                            {
                                                success: 1,
                                                description: 'Test alarm successfully sent'
                                            }
                                        )
                                    }
                                    else {
                                        // send alarm with offset!
                                        response.json(
                                            {
                                                success: 1,
                                                description: 'Test alarm successfully aligned in queue'
                                            }
                                        )
                                    }

                                }
                                else {
                                    return response.status(401).json(
                                        {
                                            success: 0,
                                            description: 'Token does not belong to you'
                                        }
                                    );
                                }
                            }
                            else {
                                response.status(404).send('no tokens found');
                            }
                        }
                        else {
                            console.error("Error occoured!!");
                        }
                    })
                } else {
                    return response.status(401).json(
                        {
                            success: 0,
                            description: 'Invalid Authentication Credentials'
                        }
                    );
                }
            });
        } else {
            return response.status(401).json(
                {
                    success: 0,
                    description: 'Invalid Authentication Credentials'
                }
            );
        }
    },

    getMyAlarmableGroups(request, response){
        const username = request.swagger.params.username.value;
        const passwordMd5 = request.swagger.params.passwordhash.value;

        if ((username.length > 0) && (passwordMd5.length > 0)) {
            const auth = new Auth(global.logger);
            auth.authenticateUserMD5(username, passwordMd5, (success, user) => {
                if (success) {
                    if (user != null) {
                        auth.checkPermission(user.id, "alarmings")
                        .then(() => {
                            auth.getAccessibleOrganizations(user.organizationId, (err, accOrganizations) => {
                                const groups = new Groups(global.logger);
                                groups.getListOfAlarmableGroups((alarmableGroups) => {
                                    if (alarmableGroups != null ){
    
                                        const accOrganizationsIds = accOrganizations.map((orga) => orga.id);
                                        const myAlarmAbleGroups = user.superuser === 1 ? alarmableGroups : alarmableGroups.filter(group => accOrganizationsIds.includes(group.organizationid));
                                        return response.status(200).json(
                                            {
                                                success: 1,
                                                alarmableGroups: myAlarmAbleGroups
                                            }
                                        );
                                    }
                                    else {
                                        return response.status(401).json(
                                            {
                                                success: 0,
                                                description: 'Error fetching alarmable groups'
                                            }
                                        );
                                    }
                                })
                            })
                        })
                        .catch((err) => {
                            this.logger.error('ALARM | getMyAlarmableGroups | Missing permissions');
                            response.status(403).json(
                                {
                                    success: 0,
                                    description: 'Missing permissions',
                                }
                            );
                        })
                    }
                    else {
                        return response.status(401).json(
                            {
                                success: 0,
                                description: 'None or more users has been found'
                            }
                        );
                    }       
                   
                } else {
                    return response.status(401).json(
                        {
                            success: 0,
                            description: 'Invalid Authentication Credentials'
                        }
                    );
                }
            });
        } else {
            return response.status(401).json(
                {
                    success: 0,
                    description: 'Invalid Authentication Credentials'
                }
            );
        }
    }
}