const Auth = require('../../../../../models/auth');
const Basedata = require('../../../../../models/basedata');
const Users = require('../../../../../models/users');


module.exports = {

    getAvatarForId: (request, response) => {

        const username = request.swagger.params.username.value;
        const passwordMd5 = request.swagger.params.passwordhash.value;
        if ((username.length > 0) && (passwordMd5.length > 0)) {
            var auth = new Auth(global.logger);
            auth.authenticateUserMD5(username, passwordMd5, (success, row) => {
                if (success) {
                    var users = new Users(global.logger);
                    users.getBasedataIdForUserWithName(username, (basedataId) => {
                        if (basedataId != null) {
                            // Found a basedata entry for user
                            var basedata = new Basedata(global.logger);
                            basedata.getBaseDataForId(basedataId, (basedataRows) => {
                                if (basedataRows.length > 0) {
                                    // MARKER_IMAGE_BASE64_ISSUE #1
                                    var avatarImageName = basedataRows[0].image;
                                    var path = require('path');
                                    avatarImageName = __dirname + '/../../../../public/assets/img/' + avatarImageName;
                                    avatarImageName = path.resolve(avatarImageName);
                                    console.log('Found image: ' + avatarImageName);
                                    response.sendFile(avatarImageName);
                                }
                            });
                        } else {
                            // Could not find a basedata entry for user
                            response.status(400).send('could not find basedata for user.');
                        }
                    })
                } else {
                    response.status(401).send('not authenticated.');
                }
            });
        } else {
            response.status(401).send('not authenticated');
        }
    }
}


