globalThis.fetch = require('node-fetch').default;
const Sms77Client = require('sms77-client'); 

class sms77ioVoiceController {

    constructor(logger) {
        this._logger = logger;
        this._apikey = ''; // default value for api key
        this.debugmode = 1; // default value for debug mode
    }

    set apikey(key) {
        this._apikey = key;
    }

    get apikey() {
        return this._apikey;
    }

    checkSMS77Credits(callback) {
        new Sms77Client(this._apikey)
            .balance()
            .then(balance => {
                console.log(`PLUGIN | SMS77IOVOICE | aktuelles Guthaben: ${balance}`)
                callback(balance);
            })
            .catch(err => {
                console.log(err);
                callback(false);
            });
    }

    makeAlarmCall(text, senderNumber, recievers, callback) {
        
        let recieversArr = [];

        if (typeof recievers === 'object') {
            recievers.forEach(rec => {
                recieversArr.push(rec);
            })
        } else if (typeof recievers === 'string') {
            recieversArr = recievers.split(',').trim();
            if (Array.isArray(recieversArr)) {
            } else {
                // seems we have only one reciever
                recieversArr = [recievers];
            }
        }         
        
        console.log('PLUGIN | SMS77IOVOICE | inititating voice call now for ' + recieversArr.length + ' recipients');
        
        recieversArr.forEach(reciever => {
            var VoiceParams = {
                from: senderNumber,
                text: text,
                to: reciever,
                xml: false
            };

            console.log('----> Sending Voice Message to ' + reciever);
            
            
            new Sms77Client(this._apikey)
                .voice(VoiceParams)
                .then(VoiceResponse => {
                    console.log('  ----> Response for ' + reciever + ':');
                    console.log(VoiceResponse);
                })
                .catch(err => {
                    console.log('  ----> ERROR for ' + reciever + ':');
                    console.log(err);
                })
        })
        
    
        
    }
}

// export the class
module.exports = sms77ioVoiceController;




