var map = null;
var marker = null;

function initialize() {

    var latitude = 0;
    var longitude = 0;

    if ((document.getElementById('latitude').value.length > 0) && (document.getElementById('longitude').value.length > 0)) {
        latitude = document.getElementById('latitude').value;
        longitude = document.getElementById('longitude').value;
    }

    map = L.map('map').setView([latitude, longitude], 13);

    L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
        attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
    }).addTo(map);




    marker = L.marker([latitude, longitude]).addTo(map)
        .bindPopup('Organisation')
        .openPopup();

}


function codeAddress() {
    var address = document.getElementById('street').value + ', ' + document.getElementById('zip').value + ' ' + document.getElementById('city').value;
    
    $.get(location.protocol + '//nominatim.openstreetmap.org/search?format=json&q='+address, function(data){
        console.log(data);
        if (data.length > 0) {
            console.log('Found data')
            var newLat = data[0].lat;
            var newLon = data[0].lon;
            document.getElementById('latitude').value = newLat;
            document.getElementById('longitude').value = newLon;
            map.panTo(new L.LatLng(newLat, newLon));
            marker.setLatLng(new L.LatLng(newLat, newLon));
        } else {

        }
    });

    /*
    geocoder.geocode({ 'address': address }, function (results, status) {
        if (status == 'OK') {
            map.setCenter(results[0].geometry.location);
            var marker = new google.maps.Marker({
                map: map,
                position: results[0].geometry.location
            });
            document.getElementById('latitude').value = results[0].geometry.location.lat();
            document.getElementById('longitude').value = results[0].geometry.location.lng()


        } else {
            alert('Adressauflösung war nicht erfolgreich. Grund: ' + status);
        }
    });
    */
}

$(document).ready(initialize);