	var map;
	var ajaxRequest;
	var plotlist;
	var plotlayers=[];
	var hydrantIcon;
	var aMarker = {};
	var allMarkers = [];
	var allCircles = [];
	var OpenFireMap = [];
	var factor = 1;
	var iconInitWidth = 38;
	var iconInitHeight = 95;

	var startLat = 49.51512520356362;
	var startLon = 11.363341349047728;


	function addOpenFireMap() {
		OpenFireMap = L.tileLayer('http://openfiremap.org/hytiles/{z}/{x}/{y}.png', {
			maxZoom: 19,
			attribution: 'Map data: &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors | Map style: &copy; <a href="http://www.openfiremap.org">OpenFireMap</a> (<a href="https://creativecommons.org/licenses/by-sa/3.0/">CC-BY-SA</a>)'
		});
		map.addLayer(OpenFireMap);
	}

	function removeOpenFireMap() {
		map.removeLayer(OpenFireMap);
	}

	function getIconFactor() {
		var currentZoom = map.getZoom();
		var iconInitWidth = 38;
		var iconInitHeight = 95;

		if (currentZoom >= 15) { factor = 0.4};
		if (currentZoom > 17) { factor = 0.4};
		if (currentZoom <=14) { factor = 0.5};
		return factor;
	}

	function initmap(hydrantData) {
		// set up the map
		map = new L.Map('map');

		// create the tile layer with correct attribution
		//var osmUrl='https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
		//var osmAttrib='Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
		// var osm = new L.TileLayer(osmUrl, {minZoom: 8, maxZoom: 12, attribution: osmAttrib});		

		/*
		var Stamen_TonerLite = L.tileLayer('https://stamen-tiles-{s}.a.ssl.fastly.net/toner-lite/{z}/{x}/{y}{r}.{ext}', {
			attribution: 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
			subdomains: 'abcd',
			minZoom: 0,
			maxZoom: 20,
			ext: 'png'
		});
		*/
		/*
		var Hydda_Full = L.tileLayer('https://{s}.tile.openstreetmap.se/hydda/full/{z}/{x}/{y}.png', {
			maxZoom: 20,
			attribution: 'Tiles courtesy of <a href="http://openstreetmap.se/" target="_blank">OpenStreetMap Sweden</a> &mdash; Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
		});
		*/
		var CartoDB_Voyager = L.tileLayer('https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}{r}.png', {
			attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors &copy; <a href="https://carto.com/attributions">CARTO</a>',
			subdomains: 'abcd',
			maxZoom: 19
		});

		/*
		hydrantIcon = L.icon({
			iconUrl: '/assets/img/hydrants/fire-hydrant.svg',
			iconSize:     [38, 95], // size of the icon
			//iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
			popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
		});

		hydrantIconUnterflur = L.icon({
			iconUrl: '/assets/img/hydrants/fire-hydrant_unterflur.svg',
			iconSize:     [38, 95], // size of the icon
			//iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
			popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
		});
		*/
		addhydrantIcon = L.icon({
			iconUrl: '/assets/img/hydrants/fire-hydrant_gray.svg',
			iconSize:     [38, 95], // size of the icon
			//iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
			popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
		});

		//map.setView(new L.LatLng(startLat, startLon),20);
		map.addLayer(CartoDB_Voyager);

		//L.marker([49.51512520356362, 11.363341349047728], {icon: hydrantIcon}).addTo(map);
		
			addMarkers(hydrantData);
		
		

		// Set Crosshair Pointer
		L.DomUtil.addClass(map._container,'crosshair-cursor-enabled');

		// register Zoom Handler for Marker-Scaling
		map.on('zoomend', function() {
			
			var currentZoom = map.getZoom();
			
			const newX = Math.round(iconInitWidth * getIconFactor());
  			const newY = newX * iconInitHeight / iconInitWidth;

			allMarkers.forEach(aMarker => {
				console.log('Zoom Level: ' + currentZoom + ' | Set width: ' + newX + ' | Set height: ' + newY);
				
				aMarker.options.icon.options.iconSize[0] = newX;
				aMarker.options.icon.options.iconSize[1] = newY;
				aMarker.setIcon(aMarker.options.icon);
			});
		});
		// Init add Marker Functionality
		initAddMarkerFunction();

		// set center of map
		if((typeof addedLatitude !== 'undefined') && (typeof addedLongitude !== 'undefined')) {
			if ((addedLatitude.length > 0) && (addedLongitude.length > 0)) {
				startLat = addedLatitude;
				startLon = addedLongitude;
				map.setView(new L.LatLng(startLat, startLon),14);
			} else {
			// Center map to show all hydrants
			zoomToAllMarkers();
			}
		} else {
			zoomToAllMarkers();
		}
	}

	


	/**
	 * Function zooms map to show all existing Markers
	 */
	function zoomToAllMarkers() {
		console.log('Zooming to show all markers');
		// Center map to show all hydrants
		var group = new L.featureGroup(allMarkers);
		map.fitBounds(group.getBounds());
	}

	var hydrantDataAray;

	function addMarkers(hydrants) {
		console.log('---> addMarkers');
		factor = getIconFactor();
		const newX = Math.round(iconInitWidth * getIconFactor());
		const newY = newX * iconInitHeight / iconInitWidth;
		  
		hydrantDataAray = hydrants;
		if (hydrantDataAray.length > 0) {
			console.log('adding Markers');
			hydrantDataAray.forEach(hydrantData => {
				
				// Hydrant-Icon depending on type
				var iconSvg = hydrantData.iconsvg;
				if (hydrantData.usable === 0) { 
					iconSvg = hydrantData.iconsvgOutOfOrder; 
					console.log('defect: /assets/img/hydrants/' + iconSvg );
				}
				
				var markerIcon = L.icon({
					iconUrl: '/assets/img/hydrants/' + iconSvg,
					iconSize:     [newX, newY], // size of the icon
					//iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
					popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
				});
	
	
				var aMarker = L.marker([hydrantData.latitude, hydrantData.longitude], {title: hydrantData.title, alt: hydrantData.type, draggable: true, icon: markerIcon})
				.bindPopup('<p><img src="' + hydrantData.qrcodeurl + '" style="width:75px;float=right;margin-right:5px;"/>' +
						   hydrantData.streetname+' '+hydrantData.streetno+'<br/>Hydrantentyp: '+hydrantData.hydranttypename+'<br/>Status: <span class="hydrants-state-' + hydrantData.state +'">' + hydrantData.statename +'</span></p>', {
					closeButton: false
				})
				.on('mouseover', function (e) {
					aMarker.openPopup();
				})
				.on('mouseout', function (e) {
					aMarker.closePopup();
				})
				.on('click', function (e) {
					drawCircle(aMarker);
				})
				.on('dblclick', function(e) {
					window.location.href = '/assets/hydrants/edit/'+hydrantData.id;
				})
				.addTo(map);
				allMarkers.push(aMarker);
			});
		} else {
			console.log('füge leeren Marker hinzu');
			var aMarker = L.marker([49.51512520356362, 11.363341349047728], {title: 'noch keine Hydranten vorhanden', alt: '', draggable: false})
				.bindPopup('<p>Lege Deinen ersten Hydranten durch einen Mausklick auf der Karte an.</p>', {
					closeButton: false
				})
				.on('mouseover', function (e) {
					aMarker.openPopup();
				})
				.on('mouseout', function (e) {
					aMarker.closePopup();
				})
				.on('click', function (e) {
					drawCircle(aMarker);
				})
				.addTo(map);
			allMarkers.push(aMarker);
		}
	}

	function drawCircle(aMarker) {
		if (allCircles.length > 0) {
			allCircles.forEach(aCircle => {
				map.removeLayer(aCircle);
			})
			allCircles = [];
		} else {
			var aCircle = L.circle(aMarker.getLatLng(), 200, {color: 'red', opacity:.2}).bindTooltip("200 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
			aCircle = L.circle(aMarker.getLatLng(), 100, {color: 'yellow', opacity:.4}).bindTooltip("100 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
			aCircle = L.circle(aMarker.getLatLng(), 50, {color: 'green', opacity:.5}).bindTooltip("50 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
		}
	}

	function initAddMarkerFunction() {
		map.on('click', 
		function(e){
			// get coordinates for new added hydrant position
			var coord = e.latlng.toString().split(',');
			var lat = coord[0].split('(');
			var lng = coord[1].split(')');
			if (aMarker != undefined) {
				map.removeLayer(aMarker);
	    	};
  
			// create Marker at position
			aMarker = L.marker(e.latlng, {draggable: true, icon: addhydrantIcon}).addTo(map)
			.on('dragend', function() {
				var coord = String(aMarker.getLatLng()).split(',');
				console.log(coord);
				var lat = coord[0].split('(');
				console.log(lat);
				var lng = coord[1].split(')');
				console.log(lng);
				aMarker.bindPopup('<a class="btn btn-light" href="/assets/hydrants/add/' + lat[1] + '/' + lng[0] + '" role="button">hier hinzufügen</a></br><a class="btn btn-light" href="#" onclick="map.removeLayer(aMarker);" role="button">verwerfen</a>', {
					closeButton: false
				  });
				aMarker.openPopup();
			});
			// add PopUp for new Marker
			aMarker.bindPopup('<a class="btn btn-light" href="/assets/hydrants/add/' + lat[1] + '/' + lng[0] + '" role="button">hier hinzufügen</a></br><a class="btn btn-light" href="#" onclick="map.removeLayer(aMarker);" role="button">verwerfen</a>', {
				closeButton: false
			  });
			aMarker.openPopup();
		});
	}


