	var map;
	var ajaxRequest;
	var plotlist;
	var plotlayers=[];
	var hydrantIcon;
	var aMarker = {};
	var allMarkers = [];
	var allCircles = [];
	var OpenFireMap = [];
	var factor = 1;
	var iconInitWidth = 38;
	var iconInitHeight = 95;

	var startLat = 49.51512520356362;
	var startLon = 11.363341349047728;


	function addOpenFireMap() {
		OpenFireMap = L.tileLayer('http://openfiremap.org/hytiles/{z}/{x}/{y}.png', {
			maxZoom: 19,
			attribution: 'Map data: &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors | Map style: &copy; <a href="http://www.openfiremap.org">OpenFireMap</a> (<a href="https://creativecommons.org/licenses/by-sa/3.0/">CC-BY-SA</a>)'
		});
		map.addLayer(OpenFireMap);
	}

	function removeOpenFireMap() {
		map.removeLayer(OpenFireMap);
	}

	function getIconFactor() {
		var currentZoom = map.getZoom();
		var iconInitWidth = 38;
		var iconInitHeight = 95;

		if (currentZoom >= 15) { factor = 0.4};
		if (currentZoom > 17) { factor = 0.4};
		if (currentZoom <=14) { factor = 0.5};
		return factor;
	}

	function initmap(operationData, filterParam) {
		// set up the map
		map = new L.Map('map');

		var CartoDB_Voyager = L.tileLayer('https://{s}.basemaps.cartocdn.com/rastertiles/voyager/{z}/{x}/{y}{r}.png', {
			attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors &copy; <a href="https://carto.com/attributions">CARTO</a>',
			subdomains: 'abcd',
			maxZoom: 19
		});

		addhydrantIcon = L.icon({
			iconUrl: '/assets/img/hydrants/fire-hydrant_gray.svg',
			iconSize:     [38, 95], // size of the icon
			//iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
			popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
		});

		//map.setView(new L.LatLng(startLat, startLon),20);
		map.addLayer(CartoDB_Voyager);

		//L.marker([49.51512520356362, 11.363341349047728], {icon: hydrantIcon}).addTo(map);
		addMarkers(operationData, filterParam);

		// Set Crosshair Pointer
		L.DomUtil.addClass(map._container,'crosshair-cursor-enabled');

		// register Zoom Handler for Marker-Scaling
		map.on('zoomend', function() {
			
			var currentZoom = map.getZoom();
			
			const newX = Math.round(iconInitWidth * getIconFactor());
  			const newY = newX * iconInitHeight / iconInitWidth;

			allMarkers.forEach(aMarker => {
				console.log('Zoom Level: ' + currentZoom + ' | Set width: ' + newX + ' | Set height: ' + newY);
				
				aMarker.options.icon.options.iconSize[0] = newX;
				aMarker.options.icon.options.iconSize[1] = newY;
				aMarker.setIcon(aMarker.options.icon);
			});
		});
		// Init add Marker Functionality
		initAddMarkerFunction();

		// set center of map
		if((typeof addedLatitude !== 'undefined') && (typeof addedLongitude !== 'undefined')) {
			if ((addedLatitude.length > 0) && (addedLongitude.length > 0)) {
				startLat = addedLatitude;
				startLon = addedLongitude;
				map.setView(new L.LatLng(startLat, startLon),14);
			} else {
			// Center map to show all hydrants
			zoomToAllMarkers();
			}
		} else {
			zoomToAllMarkers();
		}
	}

	


	/**
	 * Function zooms map to show all existing Markers
	 */
	function zoomToAllMarkers() {
		console.log('Zooming to show all markers');
		// Center map to show all hydrants
		var group = new L.featureGroup(allMarkers);
		map.fitBounds(group.getBounds());
	}

	var operationsDataAray;

	function addMarkers(operations, filterParam) {
		factor = getIconFactor();
		const newX = Math.round(iconInitWidth * getIconFactor());
		const newY = newX * iconInitHeight / iconInitWidth;
		  
		if (filterParam === 'alle') {
			filterParam = '';
		}
		operationsDataAray = operations;
		operationsDataAray.forEach(operationData => {
			if (typeof filterParam === 'undefined') {
				filterParam = '';
			}
			console.log('filterParameter: ' + filterParam);
			if (
				(
					(
						(filterParam.length > 0) && (filterParam === operationData.subject)
					) || 
						(filterParam.length === 0)
					) && 
					(
						(typeof operationData.lat !== 'undefined') && 
						(typeof operationData.lon !== 'undefined')
					) && 
					(
						(operationData.lat !== null) && 
						(operationData.lon !== null)
					)
				)
			{
				var markerIcon = L.divIcon({
					html: '<i class="fa fa-' + getIconForOperation(operationData) + '" style="color: red"></i>',
					iconSize: [newX, newY],
					className: 'text-error',
					iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
					popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
				  })
	
				var aMarker = L.marker([operationData.lat, operationData.lon], {id: operationData.id, title: operationData.keywordId, alt: operationData.keywordRaw, draggable: false, icon: markerIcon})
				.bindPopup('<p><i class="fa fa-' + getIconForOperation(operationData) + '" style="color: red"></i><strong>&nbsp;<span class="text-danger">' + operationData.subject + '</span></strong></p><p>' + operationData.alarmdate + ' ' + operationData.alarmtime + '</p><p>' + operationData.location + ' ' + operationData.street + '<br/></p>', {
					closeButton: false
				})
				.on('mouseover', function (e) {
					aMarker.openPopup();
				})
				.on('mouseout', function (e) {
					aMarker.closePopup();
				})
				.on('click', function (e) {
					drawCircle(aMarker);
				})
				.on('dblclick', function (e) {
					loadDetailsPage(e.target.options.id);
				})
				.addTo(map);
				allMarkers.push(aMarker);
			}
		});
	}

	function getIconForOperation(operation) {
		var icon = '';

		switch (true) {
            case /Straße reinigen.*/.test(operation.keywordName):
                icon = 'broom'; // broom
                break;
            case /^Baum.*/.test(operation.keywordName):
                icon = 'tree'; // tree
                break;
            case /Tier.*/.test(operation.keywordCategory):
                icon = 'cat'; // cat
                break;
            case /VU.*/.test(operation.keywordCategory):
                icon = 'car-crash'; // car_crash
                break;
            case /^RD.*/.test(operation.keywordCategory):
            case /^RD.*/.test(operation.subject):
            case /FIRST RESPONDER.*/.test(operation.subject):
                icon = 'ambulance'; // ambulance
                break;
            case /HUBSCHRAUBERLANDUNG.*/.test(operation.subject):
                icon = 'helicopter'; // helicopter
                break;
            case /UNWETTER.*/.test(operation.subject):
                icon = 'cloud-showers-heavy'; // cloud-showers-heavy
                break;
            case /^ABC ÖL.*/.test(operation.subject):
            case /^ABC KRAFTSTOFF.*/.test(operation.subject):
                icon =  'oil-can'; // oil-can
                break;
            case /^THL P EINGESCHLOSSEN.*/.test(operation.subject):
                icon = 'key'; 
                break;
            case /^THL BELEUCHTUNG.*/.test(operation.subject):
                icon = 'lightbulb';
                break;
            case /^THL BOMBE.*/.test(operation.subject):
                icon = 'bomb';
                break;
            case /^THL ERKUNDUNG.*/.test(operation.subject):
                icon = 'binoculars';
                break;
            case /^PROBEALARM.*/.test(operation.subject):
            case /^INF.*/.test(operation.subject):
                icon = 'rss';
				break;
			case /B BMA.*/.test(operation.subject):
				icon = 'laptop-house'; 
				break;
            case /^B.*/.test(operation.subject):
                icon = 'fire';
				break;
			case /^THL.*/.test(operation.subject):
                icon = 'tools';
                break;
            case /^ABC.*/.test(operation.subject):
                icon = 'skull-crossbones';
                break;
            default:
                icon = 'bell';
                break;
          }
        return icon;
	}

	function drawCircle(aMarker) {
		if (allCircles.length > 0) {
			allCircles.forEach(aCircle => {
				map.removeLayer(aCircle);
			})
			allCircles = [];
		} else {
			var aCircle = L.circle(aMarker.getLatLng(), 200, {color: 'red', opacity:.2}).bindTooltip("200 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
			aCircle = L.circle(aMarker.getLatLng(), 100, {color: 'yellow', opacity:.4}).bindTooltip("100 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
			aCircle = L.circle(aMarker.getLatLng(), 50, {color: 'green', opacity:.5}).bindTooltip("50 Meter", {sticky: true}).addTo(map);
			allCircles.push(aCircle);
		}
	}

	function initAddMarkerFunction() {
		map.on('click', 
		function(e){
			// get coordinates for new added hydrant position
			var coord = e.latlng.toString().split(',');
			var lat = coord[0].split('(');
			var lng = coord[1].split(')');
			if (aMarker != undefined) {
				map.removeLayer(aMarker);
	    	};
  
			// create Marker at position
			aMarker = L.marker(e.latlng, {draggable: true, icon: addhydrantIcon}).addTo(map)
			.on('dragend', function() {
				var coord = String(aMarker.getLatLng()).split(',');
				console.log(coord);
				var lat = coord[0].split('(');
				console.log(lat);
				var lng = coord[1].split(')');
				console.log(lng);
				aMarker.bindPopup('<a class="btn btn-light" href="/assets/hydrants/add/' + lat[1] + '/' + lng[0] + '" role="button">hier hinzufügen</a></br><a class="btn btn-light" href="#" onclick="map.removeLayer(aMarker);" role="button">verwerfen</a>', {
					closeButton: false
				  });
				aMarker.openPopup();
			});
			// add PopUp for new Marker
			aMarker.bindPopup('<a class="btn btn-light" href="/assets/hydrants/add/' + lat[1] + '/' + lng[0] + '" role="button">hier hinzufügen</a></br><a class="btn btn-light" href="#" onclick="map.removeLayer(aMarker);" role="button">verwerfen</a>', {
				closeButton: false
			  });
			aMarker.openPopup();
		});
	}

	/** loads Detail-Page of operation */
	function loadDetailsPage(oId) {
		location.href = '/operations/details/' + oId;
	}


