	var map;
	var ajaxRequest;
	var plotlist;
	var plotlayers=[];
	var hydrantIcon;

	function initmap() {
		// set up the map
		map = new L.Map('map');

		// create the tile layer with correct attribution
		var osmUrl='https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
		var osmAttrib='Map data © <a href="https://openstreetmap.org">OpenStreetMap</a> contributors';
		var osm = new L.TileLayer(osmUrl, {minZoom: 8, maxZoom: 12, attribution: osmAttrib});		

		var Stamen_TonerLite = L.tileLayer('https://stamen-tiles-{s}.a.ssl.fastly.net/toner-lite/{z}/{x}/{y}{r}.{ext}', {
			attribution: 'Map tiles by <a href="http://stamen.com">Stamen Design</a>, <a href="http://creativecommons.org/licenses/by/3.0">CC BY 3.0</a> &mdash; Map data &copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors',
			subdomains: 'abcd',
			minZoom: 0,
			maxZoom: 20,
			ext: 'png'
		});

		hydrantIcon = L.icon({
			iconUrl: 'fire-hydrant.svg',
			iconSize:     [38, 95], // size of the icon
			iconAnchor:   [19, 47], // point of the icon which will correspond to marker's location
			popupAnchor:  [-3, -76] // point from which the popup should open relative to the iconAnchor
		});


		// start the map in South-East England
		map.setView(new L.LatLng(49.51512520356362, 11.363341349047728),20);
		//map.addLayer(osm);
		map.addLayer(Stamen_TonerLite);

		//L.marker([49.51512520356362, 11.363341349047728], {icon: hydrantIcon}).addTo(map);
		addMarkers();
		initAddMarkerFunction();
	}

	/*
	var hydrantDataAray = [
		{ lat: 49.51512520356362, lon: 11.363341349047728},
		{ lat: 49.51612520356362, lon: 11.363741349047728},
		{ lat: 49.51135252035636, lon: 11.363141319047728}
	]
	*/

	function addMarkers() {
		hydrantDataAray.forEach(hydrantData => {
			var aMarker = L.marker([hydrantData.lat, hydrantData.lon], {title: "Oberflurhydrant", alt: "Oberflur", draggable: true, icon: hydrantIcon})
			.addTo(map)
			.on('dragend', function() {
				var coord = String(aMarker.getLatLng()).split(',');
				console.log(coord);
				var lat = coord[0].split('(');
				console.log(lat);
				var lng = coord[1].split(')');
				console.log(lng);
				aMarker.bindPopup("Moved to: " + lat[1] + ", " + lng[0] + ".");
			});
		});
	}

	function initAddMarkerFunction() {
		map.on('click', 
		function(e){
			var coord = e.latlng.toString().split(',');
			var lat = coord[0].split('(');
			var lng = coord[1].split(')');
			alert("You clicked the map at LAT: " + lat[1] + " and LONG: " + lng[0]);
			var aMarker = L.marker(e.latlng, {title: "Oberflurhydrant", alt: "Oberflur", draggable: true, icon: hydrantIcon}).addTo(map)
			.on('dragend', function() {
				var coord = String(aMarker.getLatLng()).split(',');
				console.log(coord);
				var lat = coord[0].split('(');
				console.log(lat);
				var lng = coord[1].split(')');
				console.log(lng);
				aMarker.bindPopup("Moved to: " + lat[1] + ", " + lng[0] + ".");
			});
		});
	}

