var express = require('express');
// Router for ALARMiator user interface
var admin = express.Router();


// BASEDATA
// - Dashboard
const {getDashboard} = require('./admin/dashboard');
const {demoSendPushAlarm} = require('./admin/dashboard');
// - Services Inbound
const {getServicesInboundList} = require('./admin/services_inbound');
const {setServicesInboundState} = require('./admin/services_inbound');
const {getServicesInboundInstancesList} = require('./admin/services_inbound');
const {setServicesInboundInstanceState} = require('./admin/services_inbound');

// Serverconfig
const {serverConfigPage} = require('./admin/serverconfig');
const {upateServerConfig} = require('./admin/serverconfig');

// Devices
const {getDevicesList, getDevicesListData} = require('./admin/alertdevices');
const {addDevicePage} = require('./admin/alertdevices');
const {addDevice} = require('./admin/alertdevices');
const {editDevicePage} = require('./admin/alertdevices');
const {editDevice} = require('./admin/alertdevices');
const {deleteDevice} = require('./admin/alertdevices');

// Users Groups
const {getUsersGroups }  = require('./admin/usersgroups');
const {getAccessMatrix} = require('./admin/usersgroups');
const {getAccessMatrixDataForRole} = require('./admin/usersgroups');

// - Outbound Jobs
const {getOutboundConfigPage} = require('./admin/outbound/outbound_edit');
const {editOutboundConfig} = require('./admin/outbound/outbound_edit');
const {setActiveState} = require('./admin/outbound/outbound_edit');

// - Outbound Jobs - Helpers
const {checkSMS77credits} = require('./admin/outbound/outbound_edit');
const {telegramAPIGetMe} = require('./admin/outbound/outbound_edit');

// - Plugins
const {getPluginsList} = require('./admin/plugins');
const {getPluginConfigForPlugin} = require('./admin/plugins');
const {resetManifestForNamespace} = require('./admin/plugins');
const {setPluginConfigForPlugin} = require('./admin/plugins');
const {eventslist} = require('./admin/plugins');
const {fireTestEvent} = require('./admin/plugins');
const { eventsNewAlarm } = require('./admin/plugins');
const { eventsNewAlarmSend } = require('./admin/plugins');
const { eventsGeneric } = require('./admin/plugins');
const { eventsGenericSend } = require('./admin/plugins');


// - LogTail
const {logTailServer} = require('./admin/logtail');
const {logTailPLuginManager} = require('./admin/logtail');
const {logTailWallboard} = require('./admin/logtail');
const {logTailAPI} = require('./admin/logtail');
const {logViewer} = require('./admin/logtail');
const {logFilesDownloadPage} = require('./admin/logtail');
const {downloadLogfile} = require('./admin/logtail');
const {deleteLogFile} = require('./admin/logtail');

// - EMail Queue
const {getQueueList} = require('./admin/emailqueue');
const {getQueueListFiltered} = require('./admin/emailqueue');
const {getEMailById} = require('./admin/emailqueue');
const {truncateQueue} = require('./admin/emailqueue');

// - Maintenace
const {BackupPage} = require('./admin/maintenance');
const {createBackup} = require('./admin/maintenance')
const {restoreBackup} = require('./admin/maintenance')
const {deleteBackup} = require('./admin/maintenance')
const {downloadBackup} = require('./admin/maintenance');
const {uploadBackup} = require('./admin/maintenance');
const {RebootSytem} = require('./admin/maintenance');
const {ShutdownSytem} = require('./admin/maintenance');

// -Tasks
const {addCronJobPage} = require('./admin/cron_management');
const {addCronJob} = require('./admin/cron_management');
const {GetCronJobMainPage, GetCronJobMainPageData} = require('./admin/cron_management');
const {toggleCronState} = require('./admin/cron_management');
const {editCronJobPage} = require('./admin/cron_management');
const {editCronJob} = require('./admin/cron_management');

// - Database Maintenance
const {downloadDatabase} = require('./admin/databaseMaintenance');

// - Access Tokens
const {getAccessTokensList, getAccessTokensListData} = require('./admin/accesstokens');
const {addAccessTokenPage} = require('./admin/accesstokens');
const {addAccessToken} = require('./admin/accesstokens');
const {deleteAccessToken} = require('./admin/accesstokens');
const {setAccessTokenActiveState} = require('./admin/accesstokens');
const {recalculateToken} = require('./admin/accesstokens');

//Dashboard
// - Dashboard
admin.get('/dashboard',  getDashboard);
admin.get('/serverconfig', serverConfigPage);
admin.post('/serverconfig', upateServerConfig);

// - Devices
admin.get('/devices/list',  getDevicesList);
admin.get('/devices/list/data',  getDevicesListData);
admin.get('/devices/add',  addDevicePage);
admin.post('/devices/add',  addDevice);
admin.get('/devices/edit/:id',  editDevicePage);
admin.post('/devices/edit/:id',  editDevice);
admin.get('/devices/delete/:id',  deleteDevice);

// - Users Groups
admin.get('/users/groups/list', getUsersGroups);
admin.get('/users/access/matrix', getAccessMatrix);
admin.get('/users/access/getAccessMatrixDataForRole/:id', getAccessMatrixDataForRole);
// - Plugins
admin.get('/plugins/list', getPluginsList);
admin.get('/plugins/config/:namespace', getPluginConfigForPlugin);
admin.get('/plugins/resetManifestForNamespace/:namespace', resetManifestForNamespace);
admin.post('/plugins/setPluginConfig/:namespace', setPluginConfigForPlugin);
admin.get('/plugins/events', eventslist);
admin.get('/plugins/events/fire/:eventname', fireTestEvent);
admin.get('/plugins/events/event_new_alarm', eventsNewAlarm);
admin.post('/plugins/events/event_new_alarm', eventsNewAlarmSend);
admin.get('/plugins/events/event_generic/:eventname', eventsGeneric);
admin.post('/plugins/events/event_generic/:eventname', eventsGenericSend);

// - LogViewer
admin.get('/logtail/logviewer', logViewer);
admin.get('/logtail/server', logTailServer);
admin.get('/logtail/plgManager', logTailPLuginManager);
admin.get('/logtail/wallboard', logTailWallboard);
admin.get('/logtail/api', logTailAPI);
admin.get('/logtail/logfiles', logFilesDownloadPage);
admin.get('/logtail/logfiles/:log', logFilesDownloadPage);
admin.get('/logtail/logfiles/download/:category/:logfile', downloadLogfile);
admin.get('/logtail/logfiles/delete/:category/:logfile', deleteLogFile);

// - EMail Queue
admin.get('/emailqueue/list', getQueueList);
admin.get('/emailqueue/filteredlist/:filteredState', getQueueListFiltered);
admin.get('/emailqueue/preview/:id', getEMailById);
admin.get('/emailqueue/truncatequeue', truncateQueue);

// - Maintenace
admin.get('/backup/files', BackupPage);
admin.post('/backup/create', createBackup);
admin.post('/backup/restore/:backupfile', restoreBackup);
admin.get('/backup/download/:backupfile', downloadBackup);
admin.post('/backup/upload', uploadBackup);
admin.get('/backup/delete/:backupfile', deleteBackup);
admin.get('/system/reboot', RebootSytem);
admin.get('/system/shutdown', ShutdownSytem);

// MARKER_IMAGE_BASE64_MIGRATION
const {
    ImageMigration, 
    getBasedataImage, 
    getOrganizationImage, 
    migrateBasedataImage, 
    migrateOrganizationImage
} = require('./admin/maintenance');
admin.get('/system/image-migration', ImageMigration);
admin.get('/system/image-migration/basedata/:id', getBasedataImage);
admin.get('/system/image-migration/organization/:id', getOrganizationImage);
admin.post('/system/image-migration/basedata/:id', migrateBasedataImage);
admin.post('/system/image-migration/organization/:id', migrateOrganizationImage);

// - Access Tokens
admin.get('/accesstokens/list', getAccessTokensList);
admin.get('/accesstokens/list/data', getAccessTokensListData);
admin.get('/accesstokens/add', addAccessTokenPage);
admin.post('/accesstokens/add', addAccessToken);
admin.get('/accesstokens/delete/:id', deleteAccessToken);
admin.get('/accesstokens/setactivestate/:tokenid/:state', setAccessTokenActiveState);
admin.get('/accesstokens/recalculateToken/:id', recalculateToken);

// - Tasks
admin.get('/cron/add', addCronJobPage);
admin.post('/cron/add', addCronJob);
admin.get('/cron/list', GetCronJobMainPage);
admin.get('/cron/data', GetCronJobMainPageData);
admin.get('/cron/toggleActive/:name/:state', toggleCronState);
admin.get('/cron/edit/:id', editCronJobPage);
admin.post('/cron/edit/:id', editCronJob);


// - Database Maintenance
admin.get('/database/download', downloadDatabase);

// - Outbound Jobs - General
//admin.get('/outbound/list',  getOutboundList);
admin.get('/outbound/edit/:id',  getOutboundConfigPage);
admin.post('/outbound/edit/:id',  editOutboundConfig);
admin.get('/outbound/setactivestate/:job/:state',  setActiveState);

// - Outbound Jobs - Job specifics
// - Outbound Jobs - Job specifics - SMS77io
admin.get('/outbound/helpers/sms77/:id',  checkSMS77credits);

// - Outbound Jobs - Job specifics - ALARMiator
admin.get('/demosendpushalarm',  demoSendPushAlarm);

// - Outbound Jobs - Job specifics - Telegram
admin.get('/outbound/helpers/telegram/:id',  telegramAPIGetMe);

module.exports = admin;