let organizations = require('../../models/organizations');

module.exports = {
    getGroupsList: (req, res) => {
        let query = "SELECT groups.id," +
                            "groups.groupname," +
                            "organizations.id AS organizationid, " +
		                    "organizations.name AS organizationname, " +
		                    "organizations.city AS organizationcity " +
                    "FROM `groups` " +
                    "INNER JOIN organizations ON groups.organizationid = organizations.id";
        // execute query
        db.query(query, (err, result) => {
            if (err) {
                console.log('Error reading groups and organizations ' + err)
                res.redirect('/admin/dashboard/groups/list');
            }
            res.render('admin/groups.ejs', {
                title: 'ALARMiator | Gruppen',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                groups: result
            });
        });
    },
    addGroupsPage: (req, res) => {
        let orgs = new organizations();
        orgs.getListOfOrganizations(function(resultOrgs) {
            res.render('admin/groups_add.ejs', {
                title: 'ALARMiator',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                orgs: resultOrgs,
                message: ''
            });
     
        })
    },
    addGroup: (req, res) => {

        let message = '';
        let groupname = req.body.groupname;
        let organizationid = req.body.organizationid;

        let groupnameQuery = "SELECT * FROM `groups` WHERE groupname = '" + groupname + "'";

        db.query(groupnameQuery, (err, result) => {
            if (err) {
                return res.status(500).send(err);
            }
            if (result.length > 0) {
                message = 'Groupname already exists';
                res.render('admin/group_add.ejs', {
                    message,
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    title: 'Welcome to Socka | Add a new Group'
                });
            } else {
                
                // send the user's details to the database
                let query = "INSERT INTO `groups` (groupname, organizationid) VALUES ('" + groupname + "', " + organizationid + ")";
                db.query(query, (err, result) => {
                    if (err) {
                        return res.status(500).send(err);
                    }
                    res.redirect('/admin/groups/list');
                });
            }
        });
    },
    editGroupPage: (req, res) => {
        let groupId = req.params.id;
        let query = "SELECT * FROM `groups` WHERE id = '" + groupId + "' ";
        let orgs = new organizations();
        orgs.getListOfOrganizations(function(resultOrgs) {
            db.query(query, (err, result) => {
                if (err) {
                    return res.status(500).send(err);
                }
                res.render('admin/groups_edit.ejs', {
                    title: 'Edit  group',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    group: result[0],
                    orgs: resultOrgs,
                    message: ''
                });
            });
        });
    },
    editGroup: (req, res) => {
        let groupId = req.params.id;
        let groupname = req.body.groupname;
        let organizationid = req.body.organizationid;

        let query = "UPDATE `groups` SET `groupname` = '" + groupname + "', organizationid = " + organizationid + "  WHERE `groups`.`id` = '" + groupId + "'";
        db.query(query, (err, result) => {
            if (err) {
                return res.status(500).send(err);
            }
            res.redirect('/admin/groups/list');
        });
    },
    deleteGroup: (req, res) => {
        let groupId = req.params.id;
        let deleteGroupQuery = 'DELETE FROM groups WHERE id = "' + groupId + '"';
        db.query(deleteGroupQuery, (err, result) => {
            if (err) {
                return res.status(500).send(err);
            }
            res.redirect('/admin/groups/list');
        });
    }
};