const AccessTokens = require('../../models/accesstokens');

module.exports = {
    getAccessTokensList: (req, res) => {
        req.app.logger.debug('ROUTES-ACCESSTOKENS | loading list of access tokens page');
    
        res.render('admin/accesstokens', {
            title: 'ALARMiator | API Tokens',
            navarea: 'admin',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });
    },
    getAccessTokensListData: (req, res)  => {
        var accesstokens = new AccessTokens(req.app.logger);
        accesstokens.getAccessTokens((rowsTokens) => {
            res.setHeader('Content-Type', 'application/json');
            res.json({ data: rowsTokens });
        })
    },
    addAccessTokenPage: (req, res) => {
        req.app.logger.debug('ROUTES-ACCESSTOKENS | loading page to add new access token');
        res.render('admin/accesstokens_add', {
            title: 'ALARMiator | API Tokens',
            navarea: 'admin',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session
        });
    },
    addAccessToken: (req, res) => {
        req.app.logger.debug('ROUTES-ACCESSTOKENS | adding new access token to core database');
        var accesstokens = new AccessTokens(req.app.logger);

        accesstokens.addNewAccessToken(req.body.description, req.body.type, 1, (success, idOfToken) => {
            if (success) {
                // Token successfully created --> TBD open Form in Edit mode to have the token displayed
                res.redirect('/admin/accesstokens/list?add=accesstoken');
            } else {
                // Token could not be created --> go back to list
                res.redirect('/admin/accesstokens/list');
            }
        })
    },
    deleteAccessToken: (req, res) => {
        req.app.logger.debug('ROUTES-ACCESSTOKENS | deleting access token from core database');
        var accesstokens = new AccessTokens(req.app.logger);
        accesstokens.removeAccessToken(req.params.id, (success) => {
            res.redirect('/admin/accesstokens/list?delete=accesstoken');
        })
    },
    setAccessTokenActiveState: (req, res) => {
        req.app.logger.debug('ROUTES-ACCESSTOKENS | setting activestate for access token in core database');
        let state = req.params.state;
        let tokenid = req.params.tokenid;

        var accesstokens = new AccessTokens(req.app.logger);
        accesstokens.setActiveState(tokenid, state, (success) => {
            res.redirect('/admin/accesstokens/list?edit=accesstoken');
        })
    },
    recalculateToken: (req, res) => {
        let atId = req.params.id;
        let accesstokens = new AccessTokens(req.app.logger);
        accesstokens.recalculateToken(atId, (success) => {
            res.redirect(`${req.headers.referer}?edit=accesstoken`);
        })
    }
};