const admin = require('../../models/admin');
const Alertrules = require('../../models/alertrules');
const os = require('os-utils');

module.exports = {
    getDashboard: (req, res) => {
        req.app.logger.debug('ROUTES-ADMIN-DASHBOARD | loading admin dashboard page');
            var adminhelper = new admin(req.app.logger);
            adminhelper.getExternalIp(req, res, (req, res, externalip) => {
                var activeInboundPlugins = global.plgManager.getCountActivePlugingsInbound();
                var activeOutboundPlugins = global.plgManager.getCountActivePlugingsOutbound();
                var alertrules = new Alertrules();
                alertrules.getAllActiveRules((activeRules) => {
                    res.render('admin/dashboard', {
                        title: 'ALARMiator | Admin',
                        navarea: 'admin',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        uptime: os.processUptime(),
                        platform: os.platform(),
                        freemem: os.freememPercentage(),
                        externalip: externalip,
                        activeInboundPlg: activeInboundPlugins,
                        activeOutboundPlg: activeOutboundPlugins,
                        activeAlertRules: activeRules
                    });
                })
            })
    },
    demoSendPushAlarm: (req, res) => {
        const gcm = require('node-gcm'); //Google Cloud Messaging
        const gcmKey = 'AIzaSyD3AhR0yQSSGWou8SlKryaFm3pZikeo6r4'; // Your gcm key in quotes
        const deviceToken = 'fS3j_bam3sg:APA91bGFxx8jNWwYvBcgIBwiIiSfFN0JuP7FbOrCRS8ibXKd3PkCNB7mlhKhZ4NnitI0W5HZC0nq2mVFYwLwi032NzeSoiDdwfN-oxj2R05ABfcz4rIZSwpO0x9fs83j67324AOdL_Rm'; // Receiver device token
        const sender = new gcm.Sender(gcmKey);

        var message = new gcm.Message();

        var message = new gcm.Message({
            collapseKey: 'ALARMiator',
            priority: 'high',
            alert: 'Einsatz für Feuerwehr Reichenschwand',
            body: 'Einsatzort',
            contentAvailable: true,
            data: {
                opid: '111111111111111111',
                opkeyword: 'THL 3',
                opdesc: 'Beschreibung',
                oplat: '49.5140795',
                oplon: '11.371378700000037',
                optimestamp: '20190510T13:18:00',
                optimestampIncoming: '20190510T13:18:00',
                content_available: "1"
            },
            notification: {
                alert: "Einsatz für Feuerwehr Reichenschwand",
                title: "Einsatz für Feuerwehr Reichenschwand",
                body: "Ortsgebiet Reichenschwand"
            }
        });




        sender.send(message, {registrationIds: [deviceToken]}, (err) => {
        if (err) {
            console.error(err);
            res.redirect('/admin/dashboard');
        }
        else {
            console.log('Sent');
            res.redirect('/admin/dashboard');
        }
        });
    }
};



