const EmailQueue = require('../../models/emailqueue');

module.exports = {
    getQueueList: (req, res) => {
        req.app.logger.debug('ROUTES-EMAILQUEUE | loading email queue list page');
        let emailqueue = new EmailQueue(req.app.logger);
        emailqueue.getEmailsinQueue(null, null, (rowsEmails) => {
            res.render('admin/emailqueue.ejs', {
                title: 'ALARMiator | Email Warteschlange',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                emails: rowsEmails
            });
        })
    },
    getQueueListFiltered: (req, res) => {
        req.app.logger.debug('ROUTES-EMAILQUEUE | loading filtered email queue list page');
        let filteredState = req.params.filterState;
        let emailqueue = new EmailQueue(req.app.logger);
        emailqueue.getEmailsinQueue(null, filteredState, (rowsEmails) => {
            res.render('admin/emailqueue.ejs', {
                title: 'ALARMiator | Email Warteschlange',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                emails: rowsEmails
            });
        })
    },
    getEMailById: (req, res) => {
        let id = req.params.id;
        let emailqueue = new EmailQueue(req.app.logger);
        emailqueue.getEMailById(id, (rowsEmail) => {
            if (rowsEmail != null) {
                if (rowsEmail.length === 1) {
                    res.send(rowsEmail[0].html);
                } else {
                    res.send('Email konnte nicht gefunden werden');
                }
            } else {
                res.send('Email konnte nicht gefunden werden');
            }
        })
    },
    truncateQueue: (req, res) => {
        req.app.logger.debug('ROUTES-EMAILQUEUE | truncating email queue');
        let emailqueue = new EmailQueue(req.app.logger);
        emailqueue.truncateQueue((success) => {
            res.redirect(req.headers.referer);
        })
    }
};