// Logging
const LogTail = require('../../models/logtail');
const path = require('path');
const fs = require('fs');

module.exports = {
    logViewer: (req, res) => {

        var logfileToView = req.query.logfile;

        if (typeof logfileToView === 'undefined') {
            logfileToView = 'server';
        }
        var logFilePath = global.appRoot + '/logs/server/server.log';

        if (logfileToView.length > 0) {
            // user wants to see plugin manager logfile
            // construct path to plgManager Logfile from today
            var date = new Date();
            var year = date.getFullYear();
            var month = date.getMonth() + 1;
            var dt = date.getDate();
            if (dt < 10) {
                dt = '0' + dt;
            }
            if (month < 10) {
                month = '0' + month;
            }
            if (logfileToView === 'plgManager') {
                logFilePath = global.appRoot + '/logs/plgmanager/ALARMiator-PluginManager-' + year + '.' + month + '.' + dt + '.log';
            } else if (logfileToView === 'server') {
                logFilePath = global.appRoot + '/logs/server/ALARMiator-Server-' + year + '.' + month + '.' + dt + '.log';
            }
        }



        // LogFilePath is set now -> read logfile and output to view
        var logTail = new LogTail(req.app.logger);

        var logLines = logTail.tailNumberOfLines(logFilePath, 50, (logLines) => {
            res.render('admin/logviewer.ejs', {
                title: 'ALARMiator | LogTail',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                logfileToView: logfileToView,
                logLines: logLines
            });
        })
        logLines = null;
    },
    logTailServer: (req, res) => {
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var dt = date.getDate();
        if (dt < 10) {
            dt = '0' + dt;
        }
        if (month < 10) {
            month = '0' + month;
        }
        logFilePath = global.appRoot + '/logs/server/ALARMiator-Server-' + year + '.' + month + '.' + dt + '.log';


        // LogFilePath is set now -> read logfile and output to view
        var logTail = new LogTail(req.app.logger);

        var logLines = logTail.tailNumberOfLines(logFilePath, 50, (logLines) => {
            res.render('admin/logtail.ejs', {
                title: 'ALARMiator | LogTail',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                logfileToView: '',
                logLines: logLines
            });
        })
        logLines = null;
    },
    logTailPLuginManager: (req, res) => {
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var dt = date.getDate();
        if (dt < 10) {
            dt = '0' + dt;
        }
        if (month < 10) {
            month = '0' + month;
        }
        logFilePath = global.appRoot + '/logs/plgmanager/ALARMiator-PluginManager-' + year + '.' + month + '.' + dt + '.log';


        // LogFilePath is set now -> read logfile and output to view
        var logTail = new LogTail(req.app.logger);

        var logLines = logTail.tailNumberOfLines(logFilePath, 50, (logLines) => {
            res.render('admin/logtail.ejs', {
                title: 'ALARMiator | LogTail',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                logfileToView: '',
                logLines: logLines
            });
        })
        logLines = null;
    },
    logTailWallboard: (req, res) => {
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var dt = date.getDate();
        if (dt < 10) {
            dt = '0' + dt;
        }
        if (month < 10) {
            month = '0' + month;
        }
        logFilePath = global.appRoot + '/logs/wallboard/ALARMiator-WALLBOARD-' + year + '.' + month + '.' + dt + '.log';


        // LogFilePath is set now -> read logfile and output to view
        var logTail = new LogTail(req.app.logger);

        var logLines = logTail.tailNumberOfLines(logFilePath, 50, (logLines) => {
            res.render('admin/logtail.ejs', {
                title: 'ALARMiator | LogTail',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                logfileToView: '',
                logLines: logLines
            });
        })
        logLines = null;
    },
    logTailAPI: (req, res) => {
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var dt = date.getDate();
        if (dt < 10) {
            dt = '0' + dt;
        }
        if (month < 10) {
            month = '0' + month;
        }
        logFilePath = global.appRoot + '/logs/api/ALARMiator-API-' + year + '.' + month + '.' + dt + '.log';


        // LogFilePath is set now -> read logfile and output to view
        var logTail = new LogTail(req.app.logger);

        var logLines = logTail.tailNumberOfLines(logFilePath, 50, (logLines) => {
            res.render('admin/logtail.ejs', {
                title: 'ALARMiator | LogTail',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                logfileToView: '',
                logLines: logLines
            });
        })
        logLines = null;
    },
    logFilesDownloadPage: (req, res) => {
        
        var logfolder = req.params.log;
        if (logfolder === null) logfolder = 'server';
        if (typeof logfolder === 'undefined') logfolder = 'server';
        if ((logfolder === 'server') || (logfolder === 'plgmanager') || (logfolder === 'api') || (logfolder === 'wallboard')) {

            var logTail = new LogTail(req.app.logger);
            var fileList = [];
            logTail.getListOfLogfilesInFolder(logfolder, (filesArray) => {
                
                filesArray.forEach(file => {
                    fileList.push(path.basename(file));
                });
                res.render('admin/logfiles.ejs', {
                    title: 'ALARMiator | Logfiles',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    filesList: fileList,
                    category: logfolder
                });
            })
        } else {
            // wrong folder name !!!
            console.log('not a valid logfile');
        }
    },
    downloadLogfile: (req, res) => {
        var logfile = req.params.logfile;
        var category = req.params.category;

        if (typeof logfile !== 'undefined') {
            // check if file exists
            var fileExists = false;
            var logTail = new LogTail(req.app.logger);
            logTail.getListOfLogfilesInFolder(category, (filesArray) => {
                filesArray.forEach(file => {
                    var loopLogfile = path.basename(file);
                    if (loopLogfile == logfile) {
                        // file exists
                        fileExists = true;
                    } 
                });
                if (fileExists === true) {
                    var filepath = global.appRoot + '/logs/' + category + '/' + logfile;
                    res.download(filepath); // Set disposition and send it.
                } else {
                    res.sendStatus(404);
                }
            });
        } else {
            res.sendStatus(500);
        }
    },
    deleteLogFile: (req, res) => {
        var logfile = req.params.logfile;
        var category = req.params.category;

        if (typeof logfile !== 'undefined') {
            // check if file exists
            var fileExists = false;
            var logTail = new LogTail(req.app.logger);
            logTail.getListOfLogfilesInFolder(category, (filesArray) => {
                filesArray.forEach(file => {
                    var loopLogfile = path.basename(file);
                    if (loopLogfile == logfile) {
                        // file exists
                        fileExists = true;
                    } 
                });
                if (fileExists === true) {
                    var filepath = global.appRoot + '/logs/' + category + '/' + logfile;
                    try {
                        fs.unlinkSync(filepath);
                    } catch (err) {
                        console.log('CORE | ROUTES | LOGTAIL | Error deleting logfile: ' + err.message);
                    }
                    res.redirect('/admin/logtail/logfiles/' + category);
                } else {
                    res.sendStatus(404);
                }
            });
        } else {
            res.sendStatus(500);
        }
    }
};