const BackupManager = require('../../models/backupmanager');
const fs = require('fs');
const path = require('path');
const pm2 = require('pm2');

module.exports = {
    /**
     * render the Backup-Page
     */
    BackupPage:(req, res) => {

        var BM = new BackupManager();
        var fileList = [];
        BM.getListOfBackupfilesInFolder((filesArray) => {
            console.log('found files: ' + filesArray.length);
            filesArray.forEach(file => {
                fileList.push(path.basename(file));
            });
            res.render('admin/backupfiles.ejs', {
                title: 'ALARMiator | Backup',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                filesList: fileList,
            });
        })
    },
    /**
     * create a backup of the coredatabse and the picture in public/assets/img as a zip-file under the backup-folder
     */
    createBackup: (req, res) => {

        var BM = new BackupManager();
        var pwd = null;

        if(req.body.modalpass)
        {
            console.log('CORE | MODELS | BACKUP | found password to protect the backupfiles.');
            pwd = req.body.modalpass;
        }
        
        BM.Create(pwd, (err) => {
            if(err === null){
                console.log('CORE | MODELS | BACKUP | create of backup-file started.');
            }
            else if(err === 'reloadPage')
            {
                console.log('CORE | MODELS | BACKUP | create of backup-file finished.');
                res.redirect('/admin/backup/files');
            }
            else{
                console.log('CORE | MODELS | BACKUP | error on create a backup-file!');
                console.log('CORE | MODELS | BACKUP | ' + err);
            }
        });
    },

    /**
     * create a backup of the coredatabse and the picture in public/assets/img as a zip-file under the backup-folder
     */
    restoreBackup: (req, res) => {

        var backupfile = req.params.backupfile;

        var BM = new BackupManager();
        var pwd = null;

        if(req.body.modalpass)
        {
            console.log('CORE | MODELS | BACKUP | found password to unprotect the backupfiles.');
            pwd = req.body.modalpass;
        }
        BM.Restore(backupfile, pwd, (err) => {
            if(err === null)
            {
                console.log('CORE | MODELS | BACKUP | restore of backup-file started.');
            }
            else if(err === 'finished')
            {
                console.log('CORE | MODELS | BACKUP | restore of backup-file finished.');
                console.log('CORE | MODELS | BACKUP | reboot server.');
                res.redirect('/admin/system/reboot');
                
            }
            else
            {
                console.log('CORE | MODELS | BACKUP | error on restore a backup-file!');
                console.log('CORE | MODELS | BACKUP | ' + err);

                var msg = '<h1>Falsches Passwort!</h1>';
                msg = msg + '<h5>';
                msg = msg + '<p><strong>Das Passwort ist Falsch!</strong></p>'
                msg = msg + '<p>Das wiederhestellen des Backups wurde abgeprochen!</p>'
                msg = msg + '</h5>'
                msg = msg + '<a class="nav-link" href="/admin/backup/files">Zurück zur Backup &amp Restore Page</a>';

                res.status(403).send(msg);
            }
        });
    },
    
    /**
     * delete a backup-file
     */
    deleteBackup: (req, res) => {
        
        var backupfile = req.params.backupfile;

        var BM = new BackupManager();
        BM.Delete(backupfile, (err) => {
            if(err === null){
                res.redirect('/admin/backup/files');
            }
            else{
                console.log('CORE | MODELS | BACKUP | error on delete ' + backupfile + '!');
                console.log('CORE | MODELS | BACKUP | ' + err);
            }
        });

    },
    /**
     * download a backup-file
     */
    downloadBackup: (req, res) => {

        var backupfile = req.params.backupfile;

        var BM = new BackupManager();
        BM.GetBackupfilePath(backupfile, (fullbackupfilepath) => {
            if(fullbackupfilepath === null)
            {
                console.log('CORE | MODELS | BACKUP | error on download ' + backupfile + '!');
            }
            else
            {
                res.download(fullbackupfilepath); // Set disposition and send it.
            }
        });
    },
    /**
     * upload a backup-file to the server
     */
    uploadBackup: (req, res) => {
        console.log('CORE | MODELS | BACKUP | upload a new backup-file');
        
        if (!req.files) {
            console.log('CORE | MODELS | BACKUP | no backup-file given to upload');
            return res.status(400).send("No files were uploaded.");
        }

        var BM = new BackupManager();
        let uploadedFile = req.files.uploadfile_input;
 
        // check the filetype before uploading it
        if (uploadedFile.mimetype === 'application/octet-stream' ) {
            // upload the file to the backup directory

            uploadedFile.name
            var localpath = path.join(BM.backupfolder, uploadedFile.name)

            uploadedFile.mv(localpath, (err ) => {
                if (err) {
                    console.log('CORE | MODELS | BACKUP | ERROR | ' + err);
                    return res.status(500).send(err);
                }
                else {
                    res.redirect('/admin/backup/files');
                }
            });
        } else {
                message = "Invalid File format. Only " + BM.backup_extension + " are allowed.";
                console.log('CORE | MODELS | BACKUP | ' + message);
                console.log('CORE | MODELS | BACKUP | wrong file type for upload');
                res.redirect('/admin/backup/files');
        }
    },
    
    /**
     * reboots the server
     */
    RebootSytem: (req, res)=>{
        global.plgManager.event_new_admin_notification('Ein Server-Neustart wird ausgeführt!');
        global.plgManager.event_server_shutdown();
        setTimeout(function () {
            
            if(global.serverStartedByPM2){
                console.log('CORE | restart server with pm2!');
                pm2.connect(function(err) {
                    if(err)
                    {
                        console.log('CORE | error at connect to pm2!');
                        console.log('CORE | ' + err);        
                    }
                });

                pm2.restart(global.PM2_Name, (err, proc) => {
                    if(err)
                    {
                        console.log('CORE | error at restart with pm2!');
                        console.log('CORE | ' + err);        
                    }
                });

                pm2.disconnect();
            }
            else
            {
                console.log('CORE | restart server with process.exit and detached child-process!')
                process.on("exit", function () {
        
                    require("child_process").spawn(process.argv.shift(), process.argv, {
                        cwd: process.cwd(),
                        detached : true,
                        stdio: "inherit"
                    });
                });
                process.exit();
            }
        }, 1000);

        res.redirect('/auth/logoff');
    },

     /**
     * shutdown the server
     */
    ShutdownSytem: (req, res)=>{
        global.plgManager.event_new_admin_notification('Der Server wird herunter gefahren!');
        global.plgManager.event_server_shutdown();
        setTimeout(function () {
            if(global.serverStartedByPM2){
                console.log('CORE | shutdown server with pm2!');
                pm2.connect(function(err) {
                    if(err)
                    {
                        console.log('CORE | error at connect to pm2!');
                        console.log('CORE | ' + err);        
                    }
                });

                pm2.stop(global.PM2_Name, (err, proc) => {
                    if(err)
                    {
                        console.log('CORE | error at stop with pm2!');
                        console.log('CORE | ' + err);        
                    }
                });

                pm2.disconnect();
            }
            else
            {
                process.exit();
            }
        }, 1000);
        res.redirect('/auth/logoff');
    },

    /**
     * MARKER_IMAGE_BASE64_MIGRATION
     * - renders the image migration page to migrate organization and basedata images to base64
     */
    ImageMigration: (req, res) => {
        // include models
        const Configuration = require('../../models/configuration')
        const BaseData = require('../../models/basedata')
        const Organizations = require('../../models/organizations')

        // load image size limits
        const configuration = new Configuration(req.app.logger)
        const imageSizeLimits = {
            basedata: null,
            organization: null,
        }
        const migrationEntities = {
            basedata: [],
            organizations: [],
        }
        configuration.getBasedataImageSizeLimits(baseDataImageSize => {
            imageSizeLimits.basedata = baseDataImageSize
            configuration.getOrganizationImageSizeLimits(orgImageSize => {
                imageSizeLimits.organization = orgImageSize

                // get list of basedata and organizations to be migrated
                const organizations = new Organizations(req.app.logger)
                const basedata = new BaseData(req.app.logger)
                organizations.getOrganizationsWithPendingImageMigration()
                    .then(orgInfos => {
                        migrationEntities.organizations = orgInfos
                    })
                    .catch(err => {
                        console.log("IMAGE-MIGRATION | Error fetching organizations with pending image (base64) migration:", err)
                    })
                    .then(() => basedata.getBasedataWithPendingImageMigration())
                    .then(basedataInfos => {
                        migrationEntities.basedata = basedataInfos
                    })
                    .catch(err => {
                        console.log("IMAGE-MIGRATION | Error fetching basedata with pending image (base64) migration:", err)
                    })
                    .then(() => {
                        // all required info gathered, render page
                        res.render('admin/image-migration.ejs', {
                            title: 'ALARMiator | Image Migration',
                            navarea: 'admin',
                            avatarpath: req.session.avatar,
                            name: req.session.name,
                            organizationname: req.session.organization,
                            session: req.session,
                            // custom data for this page
                            imageLimits: imageSizeLimits,
                            entities: migrationEntities,
                        });
                    })
            })
        })
    },

    // MARKER_IMAGE_BASE64_MIGRATION
    getBasedataImage: (req, res) => {
        const basedataId = req.params.id
        const BaseData = require('../../models/basedata')
        const baseData = new BaseData(req.app.logger)
        baseData.getImageForBasedata(basedataId, (imagePath) => {
            if (!fs.existsSync(`public/assets/img/${imagePath}`)) {
                // image file doesn't exist, set record to null
                console.log(`IMAGE MIGRATION | Image file 'public/assets/img/${imagePath}' for basedata ${basedataId} doesn't exist. Cleaning up database record.`)
                baseData.migrateBasedataImageBase64(basedataId, null).then(() => {
                    res.status(404).send()
                })
                return
            }
            if (imagePath == null) {
                res.status(404).send()
                return
            }
            res.json({ imagePath })
        })
    },

    // MARKER_IMAGE_BASE64_MIGRATION
    getOrganizationImage: (req, res) => {
        const orgId = req.params.id
        const Organizations = require('../../models/organizations')
        const organization = new Organizations(req.app.logger)
        organization.getOrganizationImage(orgId).then(imagePath => {
            if (!fs.existsSync(`public/assets/img/${imagePath}`)) {
                // image file doesn't exist, set record to null
                console.log(`IMAGE MIGRATION | Image file 'public/assets/img/${imagePath}' for organization ${orgId} doesn't exist. Cleaning up database record.`)
                organization.migrateOrganizationImageBase64(orgId, null).then(() => {
                    res.status(404).send()
                })
                return
            }
            if (imagePath == null) {
                // image path is null already
                res.status(404).send()
                return
            }
            res.json({ imagePath })
        })
    },

    // MARKER_IMAGE_BASE64_MIGRATION
    migrateBasedataImage: (req, res) => {
        const basedataId = req.params.id
        const BaseData = require('../../models/basedata')
        const baseData = new BaseData(req.app.logger)
        const { base64, imagePath } = req.body
        baseData.migrateBasedataImageBase64(basedataId, base64)
            .then(() => {
                // clean up image file
                const oldImage = `public${imagePath}`
                if (fs.existsSync(oldImage) && imagePath !== "/assets/img/stock/userDefault.png") {
                    fs.unlinkSync(oldImage)
                }
                res.send()  // success with empty response
            })
            .catch(err => {
                console.log("IMAGE-MIGRATION | Error migrating basedata image to base64:", err)
            })
    },

    // MARKER_IMAGE_BASE64_MIGRATION
    migrateOrganizationImage: (req, res) => {
        const orgId = req.params.id
        const Organizations = require('../../models/organizations')
        const organization = new Organizations(req.app.logger)
        const { base64, imagePath } = req.body
        organization.migrateOrganizationImageBase64(orgId, base64)
            .then(() => {
                // clean up image file
                const oldImage = `public${imagePath}`
                if (fs.existsSync(oldImage) !== "/assets/img/stock/userDefault.png") {                    
                    fs.unlinkSync(oldImage)
                }
                res.send()  // success with empty response
            })
            .catch(err => {
                console.log("IMAGE-MIGRATION | Error migrating organization image to base64:", err)
            })
    },
};