const request = require('request');

// Constructor
function sms77io(logger) {
    // always initialize all instance properties
    this._logger = logger;
    this.apikey = ''; // default value for api key
    this.debugmode = 1; // default value for debug mode

}

// class methods
sms77io.prototype.readConfig = function(callback) {
    let confQuery = "SELECT * FROM `configuration` WHERE keyword = 'sms77.configuration'";
    db.query(confQuery, (err, result) => {
        if (err) {
            // Error reading config
            this._logger.error('ROUTES-OUTBOUND-SMS77 | error reading configuration from database');
            return callback(false);
        } else {
            if (result.length > 0) {
                config = JSON.parse(result[0]['value']);
                this.apikey = config.apikey;
                this.debugmode = config.debugmode;
            }
            return callback(true);
        }
    })
};

sms77io.prototype.checkSMS77credits = function(tmpapikey, req, res) {
    // Helper Lösung für die Abfrage des Guthabens bei SMS77.io
    // zur Umgehung des CORS Problems in Browsern
    var url = 'https://gateway.sms77.io/api/balance?p=' + tmpapikey;

    request(url, (err, res2, body) => {
        if(err) {
            res.send('fehler');
        }
        if (body === "900") {
            res.send('HTTP API Key falsch');
        } else {
            res.send(body);
        }
    });
}

sms77io.prototype.getJSONfromConfig = function() {
    let output = '{"apikey":"' + this.apikey + '", "debugmode":"' + this.debugmode + '"}';
    return output;
}

sms77io.prototype.writeConfig = function(callback) {
    let query = "SELECT * FROM `configuration` WHERE keyword = 'sms77.configuration'";
    let confQuery = "";
    
    db.query(query, (err, result) => {
        if (err) {
            this._logger.info('ROUTES-ADMIN-OUTBOUND-SMS77IO | error reading config from database');
            return callback(false);
        } else {
            //console.log('sms77io.writeConfig: found existing configuration settings');
        }
        if (result.length > 0) {
            confQuery = "UPDATE `configuration` SET value = '" + this.getJSONfromConfig() + "' WHERE keyword = 'sms77.configuration'";
            db.query(confQuery, (err2, result2) => {
                if (err2) {
                    this._logger.error('ROUTES-ADMIN-OUTBOUND-SMS77IO | write config started');
                    console.log('Error while updating sms77io config to database');
                    return callback(false);
                } else {
                    console.log('sms77io.writeConfig: successfully refreshed config at database');
                    return callback(true);
                }
            })
        } else {
            confQuery = "INSERT INTO `configuration` (keyword, value) VALUES ('sms77.configuration', '" + this.getJSONfromConfig() + "')";
            db.query(confQuery, (err2, result2) => {
                if (err2) {
                    console.log('Error while creating sms77io config to database');
                    return callback(false);
                }
                return callback(true);
            })
        }
    });
}


// export the class
module.exports = sms77io;