const request = require('request');

// Constructor
function outboundTelegram() {
    // always initialize all instance properties
    this.apikey = ''; // default value for api key
    this.debugmode = 1; // default value for debug mode
}

// class methods
outboundTelegram.prototype.readConfig = function(callback) {
    let confQuery = "SELECT * FROM `configuration` WHERE keyword = 'telegram.configuration'";
    db.query(confQuery, (err, result) => {
        if (err) {
            // Error reading config
            return callback(false);
        } else {
            if (result.length > 0) {
                config = JSON.parse(result[0]['value']);
                this.apikey = config.apikey;
                this.debugmode = config.debugmode;   
            }
            return callback(true);
        }
    })
};


outboundTelegram.prototype.apiGetMe = function(tmpapikey, req, res) {
    // Helper getter of Bot Informations
    var url = 'https://api.telegram.org/bot' + tmpapikey + '/getMe';
    //var url = 'https://gateway.telegram.io/api/balance?p=' + this.apikey;

    request(url, (err, res2, body) => {
        if(err) {
            res.send('fehler');
        } else {
            res.send(body);
        }
    });
}

outboundTelegram.prototype.getJSONfromConfig = function() {
    let output = '{"apikey":"' + this.apikey + '", "debugmode":"' + this.debugmode + '"}';
    return output;
}

outboundTelegram.prototype.writeConfig = function(callback) {
    let query = "SELECT * FROM `configuration` WHERE keyword = 'telegram.configuration'";
    let confQuery = "";
    console.log('telegram.writeConfig: started');

    db.query(query, (err, result) => {
        if (err) {
            console.log('telegram.writeConfig: Error while writing telegram config to database: ' + err);
            return callback(false);
        } else {
            console.log('telegram.writeConfig: found existing configuration settings');
        }
        if (result.length > 0) {
            confQuery = "UPDATE `configuration` SET value = '" + this.getJSONfromConfig() + "' WHERE keyword = 'telegram.configuration'";
            console.log('telegram.writeConfig: Query: ' + confQuery);
            db.query(confQuery, (err2, result2) => {
                if (err2) {
                    console.log('Error while updating telegram config to database');
                    return callback(false);
                } else {
                    console.log('telegram.writeConfig: successfully refreshed config at database');
                    return callback(true);
                }
            })
        } else {
            confQuery = "INSERT INTO `configuration` (keyword, value) VALUES ('telegram.configuration', '" + this.getJSONfromConfig() + "')";
            console.log('Query: ' + confQuery);
            db.query(confQuery, (err2, result2) => {
                if (err2) {
                    console.log('Error while creating telegramio config to database');
                    return callback(false);
                }
                return callback(true);
            })
        }
    });
}


// export the class
module.exports = outboundTelegram;