const request = require('request');
const sms77 = require('./helper_sms77');
const telegr = require('./helper_telegram');
let sms77io = new sms77();
let telegram = new telegr();



module.exports = {
    checkSMS77credits: (req, res) => {
        // Helper Lösung für die Abfrage des Guthabens bei SMS77.io
        // zur Umgehung des CORS Problems in Browsern
        var apikey = req.params.id;
        sms77io.checkSMS77credits(apikey, req, res);
    },
    telegramAPIGetMe: (req, res) => {
        var apikey = req.params.id;
        telegram.apiGetMe(apikey, req, res);
    },
    editOutboundConfig: (req, res) => {
        let job = req.params.id;
        switch (job) {
            case 'sms77':
                let apikey = req.body.apikey;
                let debugmode = req.body.debugmode;
    
                sms77io.apikey = apikey;
                sms77io.debugmode = debugmode;
                sms77io.writeConfig(function(writeResult) {
                    if (writeResult === true) {
                        res.redirect('/admin/outbound/list');
                    } else {
                        req.app.logger.error('ROUTES-ADMIN-OUTBOUND | error writing sms77io config to database');
                        res.send('Error writing sms77io config to database');
                    }
                });
                break;

            case 'telegram':
              
                telegram.apikey = req.body.apikey;
                telegram.debugmode = req.body.debugmode;
                telegram.writeConfig(function(writeResult) {
                    if (writeResult === true) {
                        res.redirect('/admin/outbound/list');
                    } else {
                        req.app.logger.error('ROUTES-ADMIN-OUTBOUND | Error writing telegram config to database');
                        res.send('Error writing telegram config to database');
                    }
                });
                
                break;
            default:
                break;
        }
    },
    setActiveState: (req, res) => {
        let job = req.params.job;
        let state = req.params.state;
        req.app.logger.debug('ROUTES-ADMIN-OUTBOUND | Set Actice State for job ' + job + ' to value ' + state);                  
        let query = "UPDATE `outboundjobs` SET state = " + state + " WHERE configKey = '" + job + "'";
        db.query(query, (err, result) => {
            if (err) {
                req.app.logger.error('ROUTES-ADMIN-OUTBOUND | error setting Actice State for job ' + job + ' to value ' + state);
                res.send('Fehler beim setzen des Jobstatus in der Datenbank');
            } else {
                res.redirect('/admin/outbound/list');
            }
        })
    },
    getOutboundConfigPage: (req, res) => {
        let job = req.params.id;

        switch (job) {
            case 'sms77':
                /*
                / SMS 77 
                */
                sms77io.readConfig(function(readResult) {
                    if (readResult === false) {
                        sms77io.debugmode = 1;
                        sms77io.apikey = '';
                    }
                    res.render('admin/outbound/outbound_edit_sms77.ejs', {
                        title: 'ALARMiator | Alarmweg SMS77.io',
                        navarea: 'admin',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        apikey: sms77io.apikey,
                        debugmode: sms77io.debugmode,
                        organizationname: req.session.organization,
                        pagename: 'sms77'
                    });
                });
                break;
            case 'telegram':
                /*
                / TELEGRAM 
                */
               telegram.readConfig(function(readResult) {
                if (readResult === false) {
                    
                    telegram.debugmode = 1;
                    telegram.apikey = '';
                }
                res.render('admin/outbound/outbound_edit_telegram.ejs', {
                    title: 'ALARMiator | Alarmweg Telegram.io',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    apikey: telegram.apikey,
                    debugmode: telegram.debugmode,
                    organizationname: req.session.organization,
                    pagename: 'telegram'
                });
            });
            break;
                break;
            default:
                res.redirect('/admin/outbound/list');
                break;
        }
    }
}