// Logging
var log4js = require('log4js');
log4js.configure({
    appenders: { mylogger: { type:"file", filename: "logs/server/server.log" }, console: { type:"console" } },
    categories: { default: { appenders:["mylogger", "console"], level:"ALL" } }
});
const logger = log4js.getLogger("default");
servicesInboundObj = require('../../models/services_inbound');
servicesInboundHelper = new servicesInboundObj(logger);

module.exports = {
    getServicesInboundList: (req, res) => {
        servicesInboundHelper.getListOfServicesInbound(req, res, (req, res, resultServicesInbound) => {
            res.render('admin/services_inbound.ejs', {
                title: 'ALARMiator | Services',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                servicesInbound: resultServicesInbound
            });
        })
    },
    getServicesInboundInstancesList: (req, res) => {
        servicesInboundHelper.getListOfServicesInstancesInbound(req, res, (req, res, resultServicesInstancesInbound) => {
            res.render('admin/services_inbound_store.ejs', {
                title: 'ALARMiator | Services',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                serviceInstancesInbound: resultServicesInstancesInbound
            });
        })
    },
    setServicesInboundInstanceState: (req, res) => {
        let newState = req.params.newstate;
        let serviceId = req.params.id;
        logger.info('Setting new service instance state ' + newState + ' for service instance with id ' +  serviceId);
        serviceInboundHelper.setServiceInboundInstanceState(serviceId, newState, req, res, (req, res, resultServicesInstancesInbound) => {
            servicesInboundHelper.getListOfServicesInstancesInbound(req, res, (req, res, resultServicesInstancesInbound) => {
                res.render('admin/services_inbound_store.ejs', {
                    title: 'ALARMiator | Services',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    serviceInstancesInbound: resultServicesInstancesInbound
                });
            });
        });
    },
    setServicesInboundState: (req, res) => {
        let newstate = req.params.newstate;
        let serviceId = req.params.id;
        logger.info('Setting new Service State ' + newstate + ' for inbound service with id ' + serviceId);
        if (newstate == 1) {
            servicesInboundHelper.startServiceInbound(req, res, serviceId, (req, res, result) => {
                servicesInboundHelper.getListOfServicesInbound(req, res, (req, res, resultServicesInbound) => {
                    res.render('admin/services_inbound.ejs', {
                        title: 'ALARMiator | Services',
                        navarea: 'admin',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        servicesInbound: resultServicesInbound
                    });
                })
            }) 
        } else if (newstate == 0) {
            servicesInboundHelper.stopServiceInbound(req, res, serviceId, (req, res, result) => {
                servicesInboundHelper.getListOfServicesInbound(req, res, (req, res, resultServicesInbound) => {
                    res.render('admin/services_inbound.ejs', {
                        title: 'ALARMiator | Services',
                        navarea: 'admin',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        servicesInbound: resultServicesInbound
                    });
                })
            }) 
        } else {
            servicesInboundHelper.getListOfServicesInbound(req, res, (req, res, resultServicesInbound) => {
                res.render('admin/services_inbound.ejs', {
                    title: 'ALARMiator | Services',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    servicesInbound: resultServicesInbound
                });
            })
        }
    }


};