const Usersgroups = require('../../models/usersgroups');
const Roles = require('../../models/roles');
const AccessManagement = require('../../models/accessmanagement');

module.exports = {
    getUsersGroups: (req, res) => {
        req.app.logger.debug('ROUTES-USERSGROUPS | loading list of users groups page');
        var usersgroups = new Usersgroups(req.app.logger);
        usersgroups.getListOfGroups((rowsUsersGroups) => {
            res.render('admin/usersgroups', {
                title: 'ALARMiator | User Gruppen',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                groups: rowsUsersGroups
            });
        })
    },

    getAccessMatrix: (req, res) => {
        req.app.logger.debug('ROUTES-USERSGROUPS | loading access matrix page');
        let roles = new Roles(global.app.logger);
        roles.getListOfRoles((rolesRows) => {
            let accessmanagement = new AccessManagement(req.app.logger);
            accessmanagement.getAccessEndpoints((accessEndpoints) => {
                res.render('admin/access_matrix', {
                    title: 'ALARMiator | Zugriffsberechtigungen',
                    navarea: 'admin',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    groups: global.accessmanager.accessgroups,
                    accessEndpoints: accessEndpoints,
                    roles: rolesRows
                });
            })
        })
    },

    getAccessMatrixDataForRole: (req, res) => {
        var id = req.params.id;

        req.app.logger.debug('ROUTES-USERSGROUPS | loading access matrix page');
        let accessmanagement = new AccessManagement(req.app.logger);
        accessmanagement.getDefinedAccessEndpointsForRoleWithId(id, (rows) => {
            
            res.json(rows);
        })
        
    }

};



