var express = require('express');
var alarm = express.Router();

// ASSETS
// - Dashboard
const { getDashboard } = require('./alarm/alarm');
const { getMatrix } = require('./alarm/alarm');
const { setAlarmForBasedata } = require('./alarm/alarm');
const { removeAlarmForBasedata } = require('./alarm/alarm');
const { getDevicesList, getDevicesListData } = require('./alarm/alarm');
const { setGearState } = require('./alarm/alarm');

const { getTokensList, getTokensListData } = require('./alarm/alarm');
const { addTokenPage } = require('./alarm/alarm');
const { addToken } = require('./alarm/alarm');
const { removeToken } = require('./alarm/alarm');
const { activateToken } = require('./alarm/alarm');
const { deactivateToken } = require('./alarm/alarm');
const { addVirtualDevicePage } = require('./alarm/alarm');
const { addVirtualDevice } = require('./alarm/alarm');
const { removeDevice } = require('./alarm/alarm');
const { toggleDevice } = require('./alarm/alarm');
const { addRulePage } = require('./alarm/alarm');
const { addRule } = require('./alarm/alarm');
const { editRulePage } = require('./alarm/alarm');
const { editRule } = require('./alarm/alarm');
const { getRulesList, getRulesListData } = require('./alarm/alarm');
const { removeRule } = require('./alarm/alarm');
const { testModalChooser } = require('./alarm/alarm');
const { testAllModalChooser} = require('./alarm/alarm');
const { loadOperationDetailsForTest } = require('./alarm/alarm');
const { testRuleWithOperation } = require('./alarm/alarm');
const { testAllRulesWithOperation } = require('./alarm/alarm');
const { toggleRule } = require('./alarm/alarm');
const { sendTestAlarmForUserAndPlugin } = require('./alarm/alarm');
const { getFeedbackStatesList } = require('./alarm/alarm');
const { activateFeedbackState } = require('./alarm/alarm');
const { deactivateFeedbackState } = require('./alarm/alarm');
const { orderUpState } = require('./alarm/alarm');
const { orderDownState } = require('./alarm/alarm');
const { getAlarmableAssetsList } = require('./alarm/alarm');
const { getWallboardsList, getWallboardsListData }  = require('./alarm/alarm');
const { addWallboardPage } = require('./alarm/alarm');
const { addWallboard } = require('./alarm/alarm');
const { removeWallboard } = require('./alarm/alarm');
const { editWallboardPage } = require('./alarm/alarm');
const { editWallboard } = require('./alarm/alarm');
const { toggleState } = require('./alarm/alarm');
const { recalculateToken } = require('./alarm/alarm');
const { gearGroupsList, gearGroupsListData } = require('./alarm/alarm');
const { getGearGroupEditForm } = require('./alarm/alarm');
const { gearGroupEdit } = require('./alarm/alarm');
const { gearGroupsAddPage } = require('./alarm/alarm');
const { gearGroupsAdd } = require('./alarm/alarm');
const { gearsGroupDelete } = require('./alarm/alarm');
const { getGearForOrganization } = require('./alarm/alarm');
const { getGearGroupMembersAsHTML } = require('./alarm/alarm');


// testalarms
const { GetTestAlarmMainPage } = require('./alarm/testalarm');
const { AddNewTestAlarmPage } = require('./alarm/testalarm');
const { showNewTestAlarmAddPage } = require('./alarm/testalarm');
const { deleteTestalarm } = require('./alarm/testalarm');
const { toggleTestalarm } = require('./alarm/testalarm');
const { showTestAlarmEditPage } = require('./alarm/testalarm');
const { TestAlarmEditPage } = require('./alarm/testalarm');
const { getTestalarmsOperationsList, getTestalarmsOperationsListData } = require('./alarm/testalarm')
const { showTestalarmOperationDetails } = require('./alarm/testalarm');
const { deleteTestalarmOperation } = require('./alarm/testalarm');

// define the routes
alarm.get('/dashboard', getDashboard);
alarm.get('/matrix', getMatrix);
alarm.get('/setAlarm/:basedataId/:namespace', setAlarmForBasedata);
alarm.get('/removeAlarm/:basedataId/:namespace', removeAlarmForBasedata);
alarm.get('/devices/list', getDevicesList);
alarm.get('/devices/list/data', getDevicesListData);
alarm.get('/devices/addvirtual', addVirtualDevicePage);
alarm.post('/devices/addvirtual', addVirtualDevice);
alarm.get('/devices/delete/:id', removeDevice);
alarm.get('/devices/toggleActive/:deviceid/:state', toggleDevice);
alarm.get('/tokens/list', getTokensList);
alarm.get('/tokens/list/data', getTokensListData);
alarm.get('/tokens/add', addTokenPage);
alarm.post('/tokens/add', addToken);
alarm.get('/tokens/delete/:tokenid', removeToken);
alarm.get('/tokens/activate/:tokenid', activateToken);
alarm.get('/tokens/deactivate/:tokenid', deactivateToken);
alarm.get('/rules/list', getRulesList);
alarm.get('/rules/list/data', getRulesListData);
alarm.get('/rules/add', addRulePage);
alarm.post('/rules/add', addRule);
alarm.get('/rules/edit/:id', editRulePage);
alarm.post('/rules/edit/:id', editRule);
alarm.get('/rules/delete/:id', removeRule);
alarm.get('/rules/test/:id', testModalChooser);
alarm.get('/rules/testall', testAllModalChooser);
alarm.get('/rules/loadOperationDetailsForTest/:id', loadOperationDetailsForTest);
alarm.post('/rules/testRuleWithOperation', testRuleWithOperation);
alarm.post('/rules/testAllRulesWithOperation', testAllRulesWithOperation);
alarm.get('/rules/toggleActive/:id/:state', toggleRule);
alarm.get('/matrix/sendTestAlarm/:basedataId/:namespace', sendTestAlarmForUserAndPlugin);
alarm.get('/states/list', getFeedbackStatesList);
alarm.get('/states/activate/:stateid', activateFeedbackState);
alarm.get('/states/deactivate/:stateid', deactivateFeedbackState);
alarm.get('/states/orderUp/:id', orderUpState);
alarm.get('/states/orderDown/:id', orderDownState);

alarm.get('/wallboards/list', getWallboardsList);
alarm.get('/wallboards/list/data', getWallboardsListData);
alarm.get('/wallboards/add', addWallboardPage);
alarm.post('/wallboards/add', addWallboard);
alarm.get('/wallboards/delete/:id', removeWallboard);
alarm.get('/wallboards/edit/:id', editWallboardPage);
alarm.post('/wallboards/edit/:id', editWallboard);
alarm.get('/wallboards/toggleActive/:id/:state', toggleState);
alarm.get('/wallboards/recalculateToken/:id', recalculateToken);

alarm.get('/gear/list', getAlarmableAssetsList);
alarm.get('/gear/groups/list', gearGroupsList);
alarm.get('/gear/groups/list/data', gearGroupsListData);
alarm.get('/gear/groups/edit/:id', getGearGroupEditForm);
alarm.post('/gear/groups/edit/:id', gearGroupEdit);
alarm.get('/gear/groups/add', gearGroupsAddPage);
alarm.post('/gear/groups/add', gearGroupsAdd);
alarm.get('/gear/groups/delete/:id', gearsGroupDelete);
alarm.get('/gear/forOrganization/:id', getGearForOrganization);
alarm.get('/gear/setGearState/:id/:state', setGearState);
alarm.get('/gear/groups/getGearGroupMembersAsHTML/:id', getGearGroupMembersAsHTML);

// testalarms
alarm.get('/testalarms', GetTestAlarmMainPage);
alarm.get('/testalarms/add', showNewTestAlarmAddPage);
alarm.post('/testalarms/add', AddNewTestAlarmPage);
alarm.get('/testalarms/delete/:name', deleteTestalarm);
alarm.get('/testalarms/toggleActive/:name/:state', toggleTestalarm);
alarm.get('/testalarms/edit/:name/:state', showTestAlarmEditPage);
alarm.post('/testalarms/edit/:name/:state', TestAlarmEditPage);
alarm.get('/testalarms/operations', getTestalarmsOperationsList);
alarm.get('/testalarms/operations/data', getTestalarmsOperationsListData);
alarm.get('/testalarm/details/:oId', showTestalarmOperationDetails);
alarm.get('/testalarm/delete/:oId', deleteTestalarmOperation);

module.exports = alarm;