var express = require('express');
var assets = express.Router();

// ASSETS
// - Dashboard
const {getAssetsDashboard} = require('./assets/dashboard');
// - Groups
const {getAssetsGroupsList, getAssetsGroupsListData} = require('./assets/groups');
const {addAssetsGroupPage} = require('./assets/groups');
const {addAssetsGroup} = require('./assets/groups');
const {addAssetsGroupAsCopyPage} = require('./assets/groups');
const {editGroupPage} = require('./assets/groups');
const {editGroup} = require('./assets/groups');
const {deleteGroup} = require('./assets/groups');
const {getAssetsGroupsAsJSON} = require('./assets/groups');

// - Assets
const {getAssetsList} = require('./assets/assets');
const {getAssetsListForGroup} = require('./assets/assets');
const {addAssetsPage} = require('./assets/assets');
const {editAssetsPage} = require('./assets/assets');
const {editAsset} = require('./assets/assets');
const {addAssets} = require('./assets/assets');
const {deleteAsset} = require('./assets/assets');
const {getParametersList, getParametersListData} = require('./assets/assets');
const {getParametersTabsList} = require('./assets/assets');

const {editAssetsParameterTabPage} = require('./assets/assets');
const {addAssetsParameterTabPage} = require('./assets/assets');
const {addAssetsParametersTab} = require('./assets/assets');
const {editAssetsParameterTab} = require('./assets/assets');
const {removeAssetsParametersTab} = require('./assets/assets');
const {getParametersTabsListForGroup} = require('./assets/assets');

const {addParameterPage}  = require('./assets/assets');
const {addParameter} = require('./assets/assets');
const {editAssetsParameterPage} = require('./assets/assets');
const {editAssetsParameter} = require('./assets/assets');
const {addParameterOption} = require('./assets/assets');
const {deleteParameterOption} = require('./assets/assets');

// - Assets - Subforms Servive
const {getSubformForAssetGroup} = require('./assets/assetsparameters');
const {getSubformForAssetGroupAndAssetId} = require('./assets/assetsparameters');

// - Warehouses
const {getWarehousesList, getWarehousesListData} = require('./assets/warehouses');
const {addWarehousePage} = require('./assets/warehouses');
const {addWarehouse} = require('./assets/warehouses');
const {addWarehousePageAsCopy} = require('./assets/warehouses');
const {getLocationsForOrganization} = require('./assets/warehouseparameters');
const {getWarehousesForLocation} = require('./assets/warehouseparameters');
const {editWarehousePage} = require('./assets/warehouses');
const {editWarehouse} = require('./assets/warehouses');
const {deleteWarehouse} = require('./assets/warehouses');
const {getWarehousesForOrganizationJSON} = require('./assets/warehouses');

// - Hydrants
const {getHydrantsList, getHydrantsListData} = require('./assets/hydrants');
const {getHydrantsMap} = require('./assets/hydrants');
const {addHydrantsPage} = require('./assets/hydrants');
const {addHydrant} = require('./assets/hydrants');
const {deleteHydrant} = require('./assets/hydrants');
const {editHydrantsPage} = require('./assets/hydrants');
const {editHydrants} = require('./assets/hydrants');

// - Suppliers
const {getSuppliersList, getSuppliersListData} = require('./assets/suppliers');
const {editSupplierPage} = require('./assets/suppliers');
const {editSupplier} = require('./assets/suppliers');
const {addSupplierPage} = require('./assets/suppliers');
const {addSupplier} = require('./assets/suppliers');
const {deleteSupplier} = require('./assets/suppliers');

// - Orders
const {getOrdersList, getOrdersListData} = require('./assets/orders');
const {editOrderPage} = require('./assets/orders');
const {editOrder} = require('./assets/orders');
const {addOrderPage} = require('./assets/orders');
const {addOrder} = require('./assets/orders');
const {deleteOrder} = require('./assets/orders');

// - Orders
const {getReceiptList, getReceiptListData} = require('./assets/goodsreceipts');
const {editReceiptPage} = require('./assets/goodsreceipts');
const {editReceipt} = require('./assets/goodsreceipts');
const {addReceiptPage} = require('./assets/goodsreceipts');
const {addReceipt} = require('./assets/goodsreceipts');
const {deleteReceipt} = require('./assets/goodsreceipts');



// define the routes
assets.get('/dashboard', getAssetsDashboard);
assets.get('/groups/list', getAssetsGroupsList);
assets.get('/groups/list/data', getAssetsGroupsListData);
assets.get('/groups/add', addAssetsGroupPage);
assets.post('/groups/add', addAssetsGroup);
assets.get('/groups/copy/:id', addAssetsGroupAsCopyPage);
assets.get('/groups/edit/:id', editGroupPage);
assets.post('/groups/edit/:id', editGroup);
assets.get('/groups/delete/:id', deleteGroup);
assets.get('/groups/json', getAssetsGroupsAsJSON);

assets.get('/parameterstabs/list', getParametersTabsList);
assets.get('/parameterstabs/add', addAssetsParameterTabPage);
assets.post('/parameterstabs/add', addAssetsParametersTab);
assets.get('/parameterstabs/edit/:id', editAssetsParameterTabPage);
assets.post('/parameterstabs/edit/:id', editAssetsParameterTab);
assets.get('/parameterstabs/delete/:id', removeAssetsParametersTab);
assets.get('/parameterstabs/getforgroup/:id', getParametersTabsListForGroup);

assets.get('/parameters/list', getParametersList);
assets.get('/parameters/list/data', getParametersListData);
assets.get('/parameters/add', addParameterPage);
assets.post('/parameters/add', addParameter);
assets.get('/parameters/edit/:id', editAssetsParameterPage);
assets.post('/parameters/edit/:id', editAssetsParameter);

assets.post('/parameters/options/add/:pId/:label', addParameterOption);
assets.get('/parameters/options/delete/:id/:pid', deleteParameterOption);

assets.get('/assets/delete/:id', deleteAsset);
assets.get('/assets/list', getAssetsList);
assets.get('/assets/listForGroup/:id', getAssetsListForGroup);
assets.get('/assets/add', addAssetsPage);
assets.post('/assets/add', addAssets);
assets.get('/assets/edit/:id', editAssetsPage);
assets.post('/assets/edit/:id', editAsset);

// Assets Subform Service
assets.get('/assets/assetparameters/:assetsGroupId', getSubformForAssetGroup);
assets.get('/assets/assetparameters/edit/:assetsGroupId/:assetId', getSubformForAssetGroupAndAssetId);

// Warehouses
assets.get('/warehouses/list', getWarehousesList);
assets.get('/warehouses/list/data', getWarehousesListData);
assets.get('/warehouses/add', addWarehousePage);
assets.get('/warehouses/copy/:id', addWarehousePageAsCopy);
assets.post('/warehouses/add', addWarehouse);
assets.get('/warehouses/getLocations/:organizationId', getLocationsForOrganization);
assets.get('/warehouses/getWarehousesForLocation/:locationId', getWarehousesForLocation);
assets.get('/warehouses/edit/:warehouseId', editWarehousePage);
assets.post('/warehouses/edit/:warehouseId', editWarehouse);
assets.get('/warehouses/delete/:warehouseId', deleteWarehouse);
assets.get('/warehouses/getWarehousesForOrganizationJSON/:id', getWarehousesForOrganizationJSON);

// Hydrants
assets.get('/hydrants/list', getHydrantsList);
assets.get('/hydrants/list/data', getHydrantsListData);
assets.get('/hydrants/map', getHydrantsMap);
assets.get('/hydrants/map/:lat/:lon', getHydrantsMap);
assets.get('/hydrants/add', addHydrantsPage);
assets.post('/hydrants/add', addHydrant);
assets.get('/hydrants/add/:lat/:lon', addHydrantsPage);
assets.post('/hydrants/add/:lat/:lon', addHydrant);
assets.get('/hydrants/delete/:id', deleteHydrant);
assets.get('/hydrants/edit/:id', editHydrantsPage);
assets.post('/hydrants/edit/:id', editHydrants);

// Suppliers
assets.get('/suppliers/list', getSuppliersList);
assets.get('/suppliers/list/data', getSuppliersListData);
assets.get('/suppliers/edit/:id', editSupplierPage);
assets.post('/suppliers/edit/:id', editSupplier);
assets.get('/suppliers/add', addSupplierPage);
assets.post('/suppliers/add', addSupplier);
assets.get('/suppliers/delete/:id', deleteSupplier);

// Orders
assets.get('/orders/list', getOrdersList);
assets.get('/orders/list/data', getOrdersListData);
assets.get('/orders/edit/:id', editOrderPage);
assets.post('/orders/edit/:id', editOrder);
assets.get('/orders/add', addOrderPage);
assets.post('/orders/add', addOrder);
assets.get('/orders/delete/:id', deleteOrder);

// Goods Receipts
assets.get('/receipts/list', getReceiptList);
assets.get('/receipts/list/data', getReceiptListData);
assets.get('/receipts/edit/:id', editReceiptPage);
assets.post('/receipts/edit/:id', editReceipt);
assets.get('/receipts/add', addReceiptPage);
assets.post('/receipts/add', addReceipt);
assets.get('/receipts/delete/:id', deleteReceipt);


module.exports = assets;