
let assetsparameterhelper = require('../../models/assetsparametershelper');
let Assets = require('../../models/assets');

/**
 * Module offers routes for assets handling
 * @module routes/assetsparameters
 */
module.exports = {

    /**
     * Route returning addition formdata for asset group
     * @function
     * @memberof module:routes/assetsparameters
     * @param {object} req - Express request
     * @param {object} res - Express response.
     */
    getSubformForAssetGroup: (req, res) => {
        let assetsGroupId = req.params.assetsGroupId;

        req.app.logger.debug('ROUTES-ASSETPARAMETERS | reading parameters for assets group with id ' + assetsGroupId + ' to render SubForm');
        let assetsparameter = new assetsparameterhelper(req, res);
        assetsparameter.getAssetsParametersFormHTMLForAssetGroup(req, res, assetsGroupId, (result) => {
            if (result === false) {
                req.app.logger.error('ROUTES-ASSETPARAMETERS | Error loading subform');
                res.send('');
            } else {
                req.app.logger.debug('ROUTES-ASSETPARAMETERS | successfully loaded subform for asset group with id ' + assetsGroupId);
                res.send(result);
            }
        })
    },
    /**
     * Route returning addition formdata for asset group and asset with given id
     * @function
     * @memberof module:routes/assetsparameters
     * @param {object} req - Express request
     * @param {object} res - Express response.
     */
    getSubformForAssetGroupAndAssetId: (req, res) => {
        console.log('getSubformForAssetGroupAndAssetId');
        let assetId = req.params.assetId;
        let assetsGroupId = req.params.assetsGroupId;
        console.log(`Parameters | assetId: ${assetId} assetsGroupId: ${assetsGroupId}`);
        req.app.logger.debug('ROUTES-ASSETPARAMETERS | reading parameters for assets group with id ' + assetsGroupId + ' and assetId ' + assetId);

        var assets = new Assets(req.app.logger);
        assets.getAssetwithId(assetId, (rowsAsset) => {
            var isGear = 0;
            var gearname = '';
            if(rowsAsset.length > 0) {
                isGear = rowsAsset[0].isGear;
                gearname = rowsAsset[0].gearname;
                issi = rowsAsset[0].issi;
            }
            let assetsparameter = new assetsparameterhelper(req, res);
            assetsparameter.getAssetsParametersFormHTMLForAssetGroupAndAsset(req, res, assetsGroupId, assetId, isGear, gearname, issi, (result) => {
                console.log('returned');
                if (result === false) {
                    req.app.logger.error('ROUTES-ASSETPARAMETERS | Error loading subform');
                    res.send('Fehler beim laden der spezifischen Inventareigenschaften. Bitte den Administrator informieren.');
                } else {
                    req.app.logger.debug('ROUTES-ASSETPARAMETERS | successfully loaded subform for asset group with id ' + assetsGroupId);
                    res.send(result);
                }
            })
        })
    }
};