let assetsgroupshelper = require('../../models/assetsgroups');
let Assets = require('../../models/assets');
let Orders = require('../../models/orders');

module.exports = {
    getAssetsDashboard: (req, res) => {
        let assetsgroups = new assetsgroupshelper(req.app.logger);
        assetsgroups.getListOfAssetGroups((resultAssets) => {
            let assets = new Assets(req.app.logger);
            assets.getAssetsInMaintenanceWindow(30, (rowsAssetsMaintenance) => {
                let orders = new Orders();
                orders.getOrderStatistics((rowOrderStatistics) => {
                    res.render('assets/dashboard', {
                        title: 'ALARMiator | Inventar',
                        navarea: 'assets',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        assetsgroups: resultAssets,
                        assetsMaintenance: rowsAssetsMaintenance,
                        orderStatistics: rowOrderStatistics[0]
                    });
                });
            })
        });
    }
};



