const Suppliers = require('../../models/suppliers');
const Orders = require('../../models/orders');

/**
 * Module offers routes for suppliers handling
 * @module routes/orders
 */
module.exports = {

    getOrdersList: (req, res) => {
        res.render('assets/orders.ejs', {
            title: 'ALARMiator | Bestellungen',
            navarea: 'assets',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });
    },
    getOrdersListData: (req, res) => {
        let orders = new Orders();
        orders.getOrders((ordersRows) => {
            res.json({ data: ordersRows })
        })
    },
    editOrderPage: (req, res) => {
        var oId = req.params.id;
        let orders = new Orders();
        orders.getOrder(oId, (orderRows) => {
            orders.getOrdersStates((rowsOrdersStates) => {
                orders.getOderPositionsForOrder(oId, (rowsOrderPositions) => {
                    var suppliers = new Suppliers();
                    suppliers.getSuppliers((rowsSuppliers) => {
                        res.render('assets/orders_edit.ejs', {
                            title: 'ALARMiator | Bestellung bearbeiten',
                            navarea: 'assets',
                            avatarpath: req.session.avatar,
                            name: req.session.name,
                            organizationname: req.session.organization,
                            session: req.session,
                            ordersStates: rowsOrdersStates,
                            orderPositions: rowsOrderPositions,
                            suppliers: rowsSuppliers,
                            order: orderRows[0]
                        });
                    });
                })
            });
        })
    },
    editOrder: (req, res) => {
        var oId = req.params.id;
        let orders = new Orders();
        console.log(req.body);
        orders.editOrder(oId, req.body, (success) => {
            if (success) {
                res.redirect('/assets/orders/list?edit=order');
            }
        })
    },
    addOrderPage: (req, res) => {
        var orders = new Orders();
        orders.getOrdersStates((rowsOrdersStates) => {
            var suppliers = new Suppliers();
            suppliers.getSuppliers((rowsSuppliers) => {
                res.render('assets/orders_add.ejs', {
                    title: 'ALARMiator | Bestellung anlegen',
                    navarea: 'assets',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    ordersStates: rowsOrdersStates,
                    suppliers: rowsSuppliers
                });
            })
        });
    },
    addOrder: (req, res) => {
        let orders = new Orders();
        orders.addOrder(req.body, (success, orderId) => {
            if (success) {
                // Order has been created, open it again in edit view to add order positions
                res.redirect(`/assets/orders/edit/${orderId}?add=order`);
            } else {
                res.redirect('/assets/orders/list');
            }
        })
    },
    deleteOrder: (req, res) => {
        var oId = req.params.id;
        let orders = new Orders();
        orders.removeOrder(oId, (success) => {
            res.redirect('/assets/orders/list?delete=order');
        })

    }


};