const Suppliers = require('../../models/suppliers');

/**
 * Module offers routes for suppliers handling
 * @module routes/suppliers
 */
module.exports = {

    getSuppliersList: (req, res) => {
        res.render('assets/suppliers.ejs', {
            title: 'ALARMiator | Lieferanten',
            navarea: 'assets',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });    
    },
    getSuppliersListData: (req, res) => {
        let suppliers = new Suppliers();
        suppliers.getSuppliers((supplierRows) => {
            res.json({ data: supplierRows })
        })
    },
    editSupplierPage: (req, res) => {
        var sId = req.params.id;
        let suppliers = new Suppliers();
        suppliers.getSupplier(sId, (supplierRows) => {
            res.render('assets/suppliers_edit.ejs', {
                title: 'ALARMiator | Lieferanten bearbeiten',
                navarea: 'assets',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                supplier: supplierRows[0]
            });
        })
    },
    editSupplier: (req, res) => {
        var sId = req.params.id;
        let suppliers = new Suppliers();
        suppliers.editSupplier(sId, req.body, (success) => {
            res.redirect('/assets/suppliers/list?edit=supplier');
        })
    },
    addSupplierPage: (req, res) => {
        res.render('assets/suppliers_add.ejs', {
            title: 'ALARMiator | Lieferanten anlegen',
            navarea: 'assets',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session
        });
    },
    addSupplier: (req, res) => {
        let suppliers = new Suppliers();
        suppliers.addSupplier(req.body, (success) => {
            res.redirect('/assets/suppliers/list?add=supplier');
        })
    },
    deleteSupplier: (req, res) => {
        var sId = req.params.id;
        let suppliers = new Suppliers();
        suppliers.removeSupplier(sId, (success) => {
            res.redirect('/assets/suppliers/list?delete=supplier');
        })
    }    
};
