let locationshelper = require('../../models/locations');
let warehouseshelper = require('../../models/warehouses');

module.exports = {

    getLocationsForOrganization: (req, res) => {
        let organizationId = req.params.organizationId;
        req.app.logger.debug('ROUTES-WAREHOUSEPARAMETERS | reading locations for organization with id ' + organizationId);
        let locations = new locationshelper(req.app.logger);
        locations.getListOfLocationsForOrganizationWithId(organizationId, (resultLocations) => {
            if (resultLocations === false) {

                req.app.logger.error('ROUTES-WAREHOUSEPARAMETERS | Error loading locations for organization with id ' + organizationId);
                res.send('');
            } else {
                req.app.logger.debug('ROUTES-WAREHOUSEPARAMETERS | successfully loaded locations for organization with id ' + organizationId);
                res.send(resultLocations);
            }
        })
    },

    getWarehousesForLocation: (req, res) => {
        let locationId = req.params.locationId;
        let warehouses = new warehouseshelper(req.app.logger);
        warehouses.getListOfWarehousesForLocationId(locationId, (resultWarehouses) => {
            if (resultWarehouses === false) {
                
                req.app.logger.error('ROUTES-WAREHOUSEPARAMETERS | Error loading warehouses for location with id ' + locationId);
                res.send('');
            } else {
                req.app.logger.debug('ROUTES-WAREHOUSEPARAMETERS | successfully loaded warehouses for location with id ' + locationId);
                res.send(resultWarehouses);
            }
        })
        
    }
};