var warehousehelper = require('../../models/warehouses');
var organizationshelper = require('../../models/organizations');
var locationshelper = require('../../models/locations');
var moment = require('moment');
moment().format();



module.exports = {
    getWarehousesList: (req, res) => {
        res.render('assets/warehouses.ejs', {
            title: 'ALARMiator | Lagerorte',
            navarea: 'assets',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });  
    },
    getWarehousesListData: (req, res) => {
        let warehouses = new warehousehelper(req.app.logger);
        warehouses.getListOfWarehousesForTable((resultWarehouses) => {
            res.setHeader('Content-Type', 'application/json');
            res.json({ data: resultWarehouses });
        })
    },
    getWarehousesForOrganizationJSON: (req, res) => {
        let warehouses = new warehousehelper(req.app.logger);
        warehouses.getListOfWarehousesForOrganizationId(req.params.id, (rowsWarehouses) => {
            res.json(rowsWarehouses);
        })
    },
    addWarehousePage: (req, res) => {
        let organizations = new organizationshelper(req.app.logger);
        organizations.getListOfOrganizations((resultOrganizations) => {
            let warehouses = new warehousehelper(req.app.logger);
            warehouses.getListOfWarehouses((resultWarehouses) => {
                res.render('assets/warehouses_add.ejs', {
                    title: 'ALARMiator | Neuer Lagerort',
                    navarea: 'assets',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    organizations: resultOrganizations,
                    mainWarehouses: resultWarehouses
                });
            })
        })
    },
    addWarehousePageAsCopy: (req, res) => {
        var sourceWarehouseId = req.params.id;

        let organizations = new organizationshelper(req.app.logger);
        organizations.getListOfOrganizations((resultOrganizations) => {
            let warehouses = new warehousehelper(req.app.logger);
            warehouses.getWarehouseWithId(sourceWarehouseId, (rowsSourceWarehouse) => {
                warehouses.getListOfWarehouses((resultWarehouses) => {
                    res.render('assets/warehouses_add_copy.ejs', {
                        title: 'ALARMiator | Neuer Lagerort',
                        navarea: 'assets',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        organizations: resultOrganizations,
                        mainWarehouses: resultWarehouses,
                        sourceWarehouse: rowsSourceWarehouse
                    });
                })
            })
        })
    },
    addWarehouse: (req, res) => {
        let warehouses = new warehousehelper(req.app.logger);
        warehouses.addWarehouse(req.body, (success) => {
            if (success) {
                res.redirect('/assets/warehouses/list?add=warehouse');
            } else {
                res.redirect('/assets/warehouses/list');
            }
            
        })
    },
    editWarehousePage: (req, res) => {
        let warehouseId = req.params.warehouseId;
        let warehouses = new warehousehelper(req.app.logger);
        warehouses.getWarehouseWithId(warehouseId, (rows) => {
            let organizations = new organizationshelper(req.app.logger);
            organizations.getListOfOrganizations((resultOrganizations) => {
                let locations = new locationshelper(req.app.logger);
                locations.getListOfLocationsForOrganizationWithId(rows[0].organizationId, (resultLocations) => {
                    console.log('locations: ' + resultLocations.length);
                    let warehouses = new warehousehelper(req.app.logger);
                    warehouses.getListOfWarehouses((resultWarehouses) => {
                        res.render('assets/warehouses_edit.ejs', {
                            title: 'ALARMiator | Neuer Lagerort',
                            navarea: 'assets',
                            avatarpath: req.session.avatar,
                            name: req.session.name,
                            organizationname: req.session.organization,
                            session: req.session,
                            warehouse: rows[0],
                            organizations: resultOrganizations,
                            locations: resultLocations,
                            mainWarehouses: resultWarehouses
                        });
                    })
                })
            })
        })
    },
    editWarehouse: (req, res) => {

        let warehouseId = req.params.warehouseId;
        let warehouses = new warehousehelper(req.app.logger);
        warehouses.editWarehouse(req.body, warehouseId, (success) => {
            if (success) {
                res.redirect('/assets/warehouses/list?edit=warehouse');
            } else {
                res.redirect('/assets/warehouses/list');
            }
        })
    },
    deleteWarehouse: (req, res) => {
        let warehouseId = req.params.warehouseId;

        let warehouses = new warehousehelper(req.app.logger);
        warehouses.removeWarehouse(warehouseId, (success) => {
            if (success) {
                res.redirect('/assets/warehouses/list?delete=warehouse');
            } else {
                res.redirect('/assets/warehouses/list');
            }
        })
    }
};