var express = require('express');
var basedata = express.Router();

// BASEDATA
// - Dashboard
const {getBaseDataDashboard} = require('./basedata/dashboard');
// - BaseData Explorer
const {getBaseDataExplorerPage} = require('./basedata/basedata');
const {getBaseDataExplorerJSON} = require('./basedata/basedata');
// - Organizations
const {getOrganizationsPage, getOrganizationsPageData} = require('./basedata/organization');
const {editOrganization} = require('./basedata/organization');
const {addOrganizationPage} = require('./basedata/organization');
const {editOrganizationPage} = require('./basedata/organization');
const {addOrganization} = require('./basedata/organization');
const {getOrganizationsChartPage} = require('./basedata/organization');
const {setOrganizationAvatar} = require('./basedata/organization');
const {removeOrganization} = require('./basedata/organization');

// - Locations
const {getLocationsPage, getLocationsPageData} = require('./basedata/locations');
const {addLocationPage} = require('./basedata/locations')
const {addLocation} = require('./basedata/locations')
const {editLocationsPage} = require('./basedata/locations')
const {editLocation} = require('./basedata/locations')
const {deleteLocation} = require('./basedata/locations')
const {getLocationsForOrganizationJSON} = require('./basedata/locations');

// - Roles
const {getRolesList} = require('./basedata/roles');
const {addRolesPage} = require('./basedata/roles')
const {addRole} = require('./basedata/roles')
const {editRolePage} = require('./basedata/roles')
const {editRole} = require('./basedata/roles')
const {deleteRole} = require('./basedata/roles')
// - Basedata
const {getBasedataList, getBasedataListData} = require('./basedata/basedata');
const {addBasedataPage} = require('./basedata/basedata');
const {addBasedata} = require('./basedata/basedata')
const {editBasedataPage} = require('./basedata/basedata')
const {editBasedataPageRankData, editBasedataPageTrainingData} = require('./basedata/basedata')
const {editBasedata} = require('./basedata/basedata')
const {deleteBasedata} = require('./basedata/basedata')
const {setUserAvatar} = require('./basedata/basedata')
const {getBasedataForOrganizationJSON} = require('./basedata/basedata');
// - Basedata - Import
const {importBasedataGetAssistant} = require('./basedata/basedata');

// - Ranks
const {addBasedataRankPage} = require('./basedata/basedata');
const {addBasedataRank} = require('./basedata/basedata');
const {deleteBasedataRank} = require('./basedata/basedata');

// - Users
const {getUsersList} = require('./basedata/users');
const {getUsersListData} = require('./basedata/users');
const {addUserPage} = require('./basedata/users');
const {addUser} = require('./basedata/users');
const {editUserPage} = require('./basedata/users');
const {editUser} = require('./basedata/users');
const {deleteUser} = require('./basedata/users');
const {activateUser} = require('./basedata/users');
const {deactivateUser} = require('./basedata/users');
const {createCredentialsPdf} = require('./basedata/users');

// - Groups
const {getGroupsList, getGroupsListData} = require('./basedata/groups');
const {addGroupPage} = require('./basedata/groups');
const {addGroup} = require('./basedata/groups');
const {editGroupPage} = require('./basedata/groups');
const {editGroup} = require('./basedata/groups');
const {deleteGroup} = require('./basedata/groups');
const {getGroupDetailsHTML} = require('./basedata/groups');

// - Qualifications
const {getQualificationsList, getQualificationsListData} = require('./basedata/qualifications');
const {addQualificationPage} = require('./basedata/qualifications');
const {addQualification} = require('./basedata/qualifications');
const {deleteQualification} = require('./basedata/qualifications');
const {editQualificationPage} = require('./basedata/qualifications');
const {editQualification}  = require('./basedata/qualifications');


// middleware

// define the routes
basedata.get('/dashboard', getBaseDataDashboard);
// - Basedataexplorer
basedata.get('/basedata/basedataexplorer', getBaseDataExplorerPage);
basedata.get('/basedata/basedataexplorer/json', getBaseDataExplorerJSON);

// - Organization
basedata.get('/organizations/list',  getOrganizationsPage);
basedata.get('/organizations/list/data',  getOrganizationsPageData);
basedata.get('/organizations/edit/:id',  editOrganizationPage);
basedata.post('/organizations/edit/:id',  editOrganization);
basedata.get('/organizations/add',  addOrganizationPage);
basedata.post('/organizations/add',  addOrganization);
basedata.get('/organizations/chart/:id', getOrganizationsChartPage);
basedata.post('/organizations/setOrganizationAvatar/:id', setOrganizationAvatar);
basedata.get('/organizations/delete/:id', removeOrganization);

// - Locations
basedata.get('/locations/list',  getLocationsPage);
basedata.get('/locations/list/data',  getLocationsPageData);
basedata.get('/locations/edit/:id',  editLocationsPage);
basedata.post('/locations/edit/:id',  editLocation);
basedata.get('/locations/add',  addLocationPage);
basedata.get('/locations/delete/:id',  deleteLocation);
basedata.post('/locations/add',  addLocation);
basedata.get('/locations/getLocationsForOrganizationJSON/:id', getLocationsForOrganizationJSON);
// - Roles
basedata.get('/roles/list',  getRolesList);
basedata.get('/roles/add',  addRolesPage);
basedata.post('/roles/add',  addRole);
basedata.get('/roles/edit/:id',  editRolePage);
basedata.post('/roles/edit/:id',  editRole);
basedata.get('/roles/delete/:id',  deleteRole);
// - Basedata
basedata.get('/basedata/list',  getBasedataList);
basedata.get('/basedata/list/data',  getBasedataListData);
basedata.get('/basedata/add',  addBasedataPage);
basedata.post('/basedata/add',  addBasedata);
basedata.get('/basedata/edit/:id',  editBasedataPage);
basedata.post('/basedata/edit/:id',  editBasedata);
basedata.get('/basedata/edit/:id/ranks/data', editBasedataPageRankData)
basedata.get('/basedata/edit/:id/trainings/data', editBasedataPageTrainingData)
basedata.get('/basedata/delete/:id',  deleteBasedata);
basedata.post('/basedata/setUserAvatar/:id', setUserAvatar);
basedata.get('/basedata/getBasedataForOrganizationJSON/:id', getBasedataForOrganizationJSON);
// - Basedata  Importer
basedata.get('/basedata/import/:step', importBasedataGetAssistant);
basedata.post('/basedata/import/:step', importBasedataGetAssistant);

// - Ranks
basedata.get('/ranks/add/:id', addBasedataRankPage);
basedata.post('/ranks/add/:id', addBasedataRank);
basedata.get('/ranks/delete/:id/:basedataid', deleteBasedataRank);
// - Users
basedata.get('/users/list',  getUsersList);
basedata.get('/users/list/data',  getUsersListData);
basedata.get('/users/add',  addUserPage);
basedata.post('/users/add',  addUser);
basedata.get('/users/edit/:id',  editUserPage);
basedata.post('/users/edit/:id',  editUser);
basedata.get('/users/delete/:id', deleteUser);
basedata.get('/users/activate/:id', activateUser);
basedata.get('/users/deactivate/:id', deactivateUser);
basedata.get('/users/createCredentialsPdf/:id', createCredentialsPdf);
// Groups
basedata.get('/groups/list',  getGroupsList);
basedata.get('/groups/list/data',  getGroupsListData);
basedata.get('/groups/add',  addGroupPage);
basedata.post('/groups/add',  addGroup);
basedata.get('/groups/edit/:id',  editGroupPage);
basedata.post('/groups/edit/:id',  editGroup);
basedata.get('/groups/delete/:id',  deleteGroup);
basedata.get('/groups/groupsusers/:id', getGroupDetailsHTML);
// Qualifications
basedata.get('/qualifications/list', getQualificationsList);
basedata.get('/qualifications/list/data', getQualificationsListData);
basedata.get('/qualifications/add', addQualificationPage);
basedata.post('/qualifications/add', addQualification);
basedata.get('/qualifications/delete/:id', deleteQualification);
basedata.get('/qualifications/edit/:id', editQualificationPage);
basedata.post('/qualifications/edit/:id', editQualification);






module.exports = basedata;