let organizations = require('../../models/organizations');
let Groups = require('../../models/groups');
const basedata = require('../../models/basedata');

module.exports = {
    getGroupsList: (req, res) => {
        req.app.logger.debug('ROUTES-GROUPS | loading groups page');
        res.render('basedata/groups.ejs', {
            title: 'ALARMiator | Gruppen',
            navarea: 'basedata',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });
    },
    getGroupsListData: (req, res) => {
        const groups = new Groups(req.app.logger);
        groups.getlistOfGroupsForUI((rows) => {
            res.setHeader('Content-Type', 'application/json');
            res.json({ data: rows });
        })
    },
    addGroupPage: (req, res) => {
        let orgs = new organizations(req.app.logger);
        orgs.getListOfOrganizations(function (resultOrgs) {
            res.render('basedata/groups_add.ejs', {
                title: 'ALARMiator',
                navarea: 'basedata',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                orgs: resultOrgs,
                message: ''
            });

        })
    },
    addGroup: (req, res) => {
        console.log('ROUTES-GROUPS | adding new Group')
        let message = '';
        let groupname = req.body.groupname;
        let organizationid = req.body.organizationid;
        let alarmable = req.body.alarmable;
        let gearStateAllowed = req.body.gearStateAllowed;
        let shortName = req.body.shortName;

        if (alarmable === 'on') {
            alarmable = 1;
        } else {
            alarmable = 0;
        }

        if (gearStateAllowed === 'on') {
            gearStateAllowed = 1;
        } else {
            gearStateAllowed = 0;
        }

        
        let groups = new Groups(req.app.logger);
        groups.addGroupforOrganization(groupname, organizationid, alarmable, gearStateAllowed, shortName, (success) => {
            res.redirect('/basedata/groups/list?add=group');
        });
    },
    editGroupPage: (req, res) => {
        let groupId = req.params.id;
        let group = new Groups(req.app.logger);

        group.getGroupForId(groupId, (row) => {
            if (row !== null) {
                let orgs = new organizations();
                orgs.getListOfOrganizations((resultOrgs) => {
                    res.render('basedata/groups_edit.ejs', {
                        title: 'Edit  group',
                        navarea: 'basedata',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        group: row[0],
                        orgs: resultOrgs,
                        message: ''
                    });
                })
            } else {
                // Group could not be loaded --> redirect to list
                res.redirect('/basedata/groups/list');
            }
        })
    },
    editGroup: (req, res) => {
        let groupId = req.params.id;
        let groupname = req.body.groupname;
        let organizationid = req.body.organizationid;
        let alarmable = req.body.alarmable;
        let gearStateAllowed = req.body.gearStateAllowed;
        let shortName = req.body.shortName;

        if (alarmable === 'on') {
            alarmable = 1;
        } else {
            alarmable = 0;
        }
       
        if (gearStateAllowed === 'on') {
            gearStateAllowed = 1;
        } else {
            gearStateAllowed = 0;
        }

        
        let group = new Groups(req.app.logger);
        group.updateGroup(groupId, groupname, organizationid, alarmable, gearStateAllowed, shortName, (success) => {
            if (success) {
                // Group updated in core database
                res.redirect('/basedata/groups/list?edit=group');
            } else {
                // Group could not be updated in database
                res.redirect('/basedata/groups/list');
            }
        });
    },
    deleteGroup: (req, res) => {
        let groupId = req.params.id;
        var group = new Groups(req.app.logger);
        group.deleteGroup(groupId, (success) => {
            res.redirect('/basedata/groups/list?delete=group');
        })
    },
    getGroupDetailsHTML: (req, res) => {
        var groupId = req.params.id;
        var group = new Groups(req.app.logger);
        group.getBasedataForGroupWithId(groupId, (rowsBasedata) => {
            var retHTML = '';
            if (rowsBasedata.length > 0) {
                rowsBasedata.forEach(basedata => {
                    retHTML = retHTML + basedata.firstname + ', ' + basedata.lastname + '</br>';
                });
            } else {
                retHTML = 'keine Mitglieder';
            }
            
            res.send(retHTML);
        })
    }
};