const organizations = require('../../models/organizations');
const Locations = require('../../models/locations');
const Configuration = require('../../models/configuration');

module.exports = {
    
    getLocationsPage: (req, res) => {
        req.app.logger.debug('ROUTES-LOCATIONS | loading Locations Page');
        var message = '';
        res.render('basedata/locations.ejs', {
            title: 'Locations',
            navarea: 'basedata',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
            message: message
        });
    },
    getLocationsPageData: (req, res) => {
        const locations = new Locations(req.app.logger);
        locations.getListOfLocations((rows) => {
            res.setHeader('Content-Type', 'application/json')
            const locations = req.session.superuser === 1 ? rows : rows.filter(row => req.session.accessibleOrganizations.includes(row.organizationId))
            res.json({ data: locations })
        })
    },
    getLocationsForOrganizationJSON: (req, res) => {
        let id = req.params.id;
        let locations = new Locations(req.app.logger);
        locations.getListOfLocationsForOrganizationWithId(id, (rowsLocations) => {
            res.json(rowsLocations);
        })
    },
    editLocationsPage: (req, res) => { 
        let id = req.params.id;
        let locations = new Locations(req.app.logger);
        let configuration = new Configuration(req.app.logger);
        let organization = new organizations(req.app.logger);
        console.log('editLocationsPage');
        locations.getLocationWithId(id, (row) => {
            coordinatesKnown = false;
            if (row !== null) {
                coordinatesKnown = true;
            } 
            organization.getListOfOrganizations((orgRows) => {
                configuration.getValueForKeyword('googlemapskey', (value) => {
                    res.render('basedata/locations_edit.ejs', {
                        title: 'Edit  Location',
                        navarea: 'basedata',
                        subarea: 'map',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        location: row[0],
                        googlemapskey: value,
                        coordinatesKnown: coordinatesKnown,
                        organizations: orgRows,
                        message: ''
                    });
                })
            })
        })
    },
    editLocation: (req, res) => {
        let id = req.params.id;
        let locations = new Locations(req.app.logger);

        locations.updateLocation(id, req.body, (success) => {
            if (success) {
                res.redirect('/basedata/locations/list?edit=location');
            } else {
                req.app.logger.error('ROUTES-LOCATIONS | Error updating location in database');
                res.redirect('/basedata/locations/list');
            }
            
        })
    },
    addLocationPage: (req, res) => {
        let orgs = new organizations(req.app.logger);
        orgs.getListOfOrganizations(function (resultOrgs) {
            let configuration = new Configuration(req.app.logger);
            configuration.getValueForKeyword('googlemapskey', (value) => {
                res.render('basedata/locations_add.ejs', {
                    title: 'Location',
                    navarea: 'basedata',
                    subarea: 'map',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    organizations: resultOrgs,
                    googlemapskey: value,
                    message: ''
                });
            })
        });
    },
    addLocation: (req, res) => {
        let locations = new Locations(req.app.logger);
        locations.addLocation(req.body, (success) => {
            if (success) {
                res.redirect('/basedata/locations/list?add=location');
            } else {
                req.app.logger.error('ROUTES-LOCATIONS | Error inserting new location to database');
                res.redirect('/basedata/locations/list');
            }
        });
    },
    deleteLocation: (req, res) => {
        let locationId = req.params.id;
        let locations = new Locations(req.app.logger);
        locations.deleteLocation(locationId, (success) => {
            if (success) {
                res.redirect('/basedata/locations/list?delete=location');
            } else {
                req.app.logger.error('ROUTES-LOCATIONS | Error deleting location with id ' + id + ' in database');
                res.redirect('/basedata/locations/list');
            }
        })
    }
};