const Qualifications = require('../../models/qualifications');

module.exports = {
    getQualificationsList: (req, res) => {
        req.app.logger.debug('ROUTES-QUALIFICATIONS | loading qualifications page');

        res.render('basedata/qualifications_list.ejs', {
            title: 'ALARMiator | Qualifikationen',
            navarea: 'basedata',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });
    },
    getQualificationsListData: (req, res) => {
        const qualifications = new Qualifications(req.app.logger);
        qualifications.getListOfQualifications((rowsQualifications) => {
            res.json({ data: rowsQualifications })
        })
    },
    addQualificationPage: (req, res) => {
        res.render('basedata/qualifications_add.ejs', {
            title: 'ALARMiator | Qualifikation hinzufügen',
            navarea: 'basedata',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
            message: ''
        });
    },
    addQualification: (req, res) => {
        var qualifications = new Qualifications(req.app.logger);
        qualifications.addQualification(req.body, (success) => {
            res.redirect('/basedata/qualifications/list?add=qualification');
        })
    },
    editQualificationPage: (req, res) => {
        var id = req.params.id;
        var qualifications = new Qualifications(req.app.logger);
        qualifications.getQualificationForId(id, (row) => {
            res.render('basedata/qualifications_edit.ejs', {
                title: 'ALARMiator | Qualifikationen',
                navarea: 'basedata',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                qualification: row[0]
            });
        })
    },
    editQualification: (req, res) => {
        var id = req.params.id;
        var qualifications = new Qualifications(req.app.logger);
        qualifications.updateQualification(id, req.body, (success) => {
            res.redirect('/basedata/qualifications/list?edit=qualification');
        })
    },
    deleteQualification: (req, res) => {
        let id = req.params.id;
        var qualifications = new Qualifications(req.app.logger);
        qualifications.deleteQualification(id, (success) => {
            res.redirect('/basedata/qualifications/list?delete=qualification');
        })
    }
};