const Roles = require('../../models/roles');
const AccessManagement = require('../../models/accessmanagement');

module.exports = {
    getRolesList: (req, res) => {
        req.app.logger.debug('ROUTES-ROLES | loading roles page');
        var roles = new Roles(req.app.logger);
        roles.getListOfRoles((rows) => {
            if (rows !== null) {
                res.render('basedata/roles.ejs', {
                    title: 'ALARMiator | Rollen',
                    navarea: 'basedata',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    roles: rows
                });
            }
        });
    },
    addRolesPage: (req, res) => {
        res.render('basedata/roles_add.ejs', {
            title: 'ALARMiator',
            navarea: 'basedata',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
            message: ''
        });
    },
    addRole: (req, res) => {

        let message = '';
        let rolename = req.body.name;

        var roles = new Roles(req.app.logger);
        roles.addRole(rolename, (success) => {
            res.redirect('/basedata/roles/list?add=role');
        })
    },
    editRolePage: (req, res) => {
        let roleId = req.params.id;
        var roles = new Roles(req.app.logger);
        roles.getRoleForId(roleId, (row) => {
            
            res.render('basedata/roles_edit.ejs', {
                title: 'Edit  role',
                navarea: 'admin',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                role: row[0],
                message: ''
            });
        })
    },
    editRole: (req, res) => {
        let roleId = req.params.id;
        let rolename = req.body.name;
        var roles = new Roles(req.app.logger);
        roles.updateRole(roleId, rolename, (success) => {
            res.redirect('/basedata/roles/list?edit=role');
        })
    },
    deleteRole: (req, res) => {
        let roleId = req.params.id;
        var roles = new Roles(req.app.logger);
        roles.deleteRole(roleId, (success) => {
            if (success) {
                let accessmanagement = new AccessManagement(req.app.logger);
                accessmanagement.deleteAccessEndpointsForRoleWithId(roleId, (successEndpoints) => {
                    res.redirect('/basedata/roles/list?delete=role');
                })
            } else {
                res.redirect('/basedata/roles/list');
            }
            
        })
    }
};