var express = require('express');
var operations = express.Router();

// ASSETS
// - Dashboard
const {getOperationsDashboard} = require('./operations/dashboard');
// Operations
const {getOperationsList, deleteOperation, getOperationsListData} = require('./operations/operations');
const {showOperationDetails} = require('./operations/operations');
const {getActiveOperationsList, getActiveOperationsListData} = require('./operations/operations');
const {archiveOperation} = require('./operations/operations');
const {closeOperation} = require('./operations/operations');
const {getOperationsOverviewMap} = require('./operations/operations');
const {closeAllOperations} = require('./operations/operations');
const {activateOperation} = require('./operations/operations');

// GearStates
const {getListOfGearStatesWithAssetInfos, getListOfGearStatesWithAssetInfosData } = require('./operations/gearstate');
const {getGearStateListJSON} = require('./operations/gearstate');




// define the routes
operations.get('/dashboard', getOperationsDashboard);
operations.get('/list', getOperationsList);
operations.get('/list/data', getOperationsListData);
operations.get('/active', getActiveOperationsList);
operations.get('/active/data', getActiveOperationsListData);
operations.get('/archive/:oId', archiveOperation);
operations.get('/close/:oId', closeOperation);
operations.get('/details/:oId', showOperationDetails);
operations.get('/delete/:oId', deleteOperation);
operations.get('/closeall', closeAllOperations);
operations.get('/activate/:id', activateOperation);
operations.get('/map', getOperationsOverviewMap);

// gearstates
operations.get('/states/list', getListOfGearStatesWithAssetInfos);
operations.get('/states/list/data', getListOfGearStatesWithAssetInfosData);  // JSON data for Statushistorie page
operations.get('/states/listJSON', getGearStateListJSON);

module.exports = operations;