const GearState = require('../../models/gearstate');
const Assets = require('../../models/assets');

module.exports = {
    getGearStateList: (req, res) => {
        let gearstate = new GearState(req.app.logger);
        gearstate.getListOfGearStates((result) => {
            res.render('operations/gearState', {
                title: 'ALARMiator | Statusübersicht',
                navarea: 'operations',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                gearStateList: result
            });
        })
    },
    getListOfGearStatesWithAssetInfos: (req, res) => {
        // Check if filters are defined
        var filterIssi = req.query.issi;
        var filterGear = req.query.gear;
        var filterFrom = req.query.from;
        var filterTill = req.query.till;

        let assets = new Assets(req.app.logger);
        assets.getAllAssetsWhichCanBeAlarmedWithIssi((rowsIssiAssets) => {            
            res.render('operations/gearState', {
                title: 'ALARMiator | Statusübersicht',
                navarea: 'operations',
                avatarpath: req.session.avatar,
                name: req.session.name,
                organizationname: req.session.organization,
                session: req.session,
                issiList: rowsIssiAssets
            });
        })
    },
    getListOfGearStatesWithAssetInfosData: (req, res) => {
        // Check if filters are defined
        var filterIssi = req.query.issi;
        var filterGear = req.query.gear;
        var filterFrom = req.query.from;
        var filterTill = req.query.till;

        let assets = new Assets(req.app.logger);
        assets.getAllAssetsWhichCanBeAlarmedWithIssi((rowsIssiAssets) => {
            let gearstate = new GearState(req.app.logger);
            gearstate.getListOfGearStatesWithAssetInfosFilteredBy(filterIssi, filterGear, filterFrom, filterTill, (result) => {
                res.json({ data: result })
            })
        })
    },
    getGearStateListJSON: (req, res) => {
        console.log('ROUTES | GEARSTATE | getGearStateListJSON');
        console.log(req.params);
        console.log(req.query);

        var issi = req.query.issi;
        var gear = req.query.gear;
        var state = req.query.state;
        var from = req.query.from;
        var fromTime = req.query.fromTime;
        var till = req.query.till;
        var tillTime = req.query.tillTime;

        var json = {
            state: 1,
            timestamp: '2020-07-27 15:22:08',
            issi: issi,
            stateName: 'Einsatzbereit Funk'
        }
        res.setHeader('Content-Type', 'application/json');
        res.json(json);
    }
};



