var express = require('express');
const { get } = require('request');
var respiratory = express.Router();

// ASSETS
// - Dashboard
const { getDashboard } = require('./respiratory/respiratory');
const { getRespiratoryList, getRespiratoryListData } = require('./respiratory/respiratory');
const { addRespiratoryPage } = require('./respiratory/respiratory');
const { addRespiratory } = require('./respiratory/respiratory');
const { addRespiratoryAttachment } = require('./respiratory/respiratory');
const { editRespiratoryPage } = require('./respiratory/respiratory');
const { editRespiratory } = require('./respiratory/respiratory');

// define the routes
respiratory.get('/dashboard', getDashboard);
respiratory.get('/respiratory/list', getRespiratoryList);
respiratory.get('/respiratory/list/data', getRespiratoryListData);
respiratory.get('/respiratory/add', addRespiratoryPage);
respiratory.post('/respiratory/add', addRespiratory);
respiratory.post('/attachments/add', addRespiratoryAttachment);
respiratory.get('/respiratory/edit/:id', editRespiratoryPage);
respiratory.post('/respiratory/edit/:id', editRespiratory);
module.exports = respiratory;