let Organizations = require('../../models/organizations');
let Locations = require('../../models/locations');
let Configuration = require('../../models/configuration');
let OrganizationsTypes = require('../../models/organizationstypes');
const locations = require('../../models/locations');


module.exports = {
    step1: (req, res) => {
        var configuration = new Configuration(req.app.logger);
        var organizations = new Organizations(req.app.logger);
        organizations.getListOfOrganizations((rowsOrganizations) => {
            configuration.getValueForKeyword('googlemapskey', (googlemapskey) => {
                var organizationstypes = new OrganizationsTypes(req.app.logger);
                organizationstypes.getListOfOrganizationsTypes((rowsOrganizationsTypes) => {
                    res.render('setupwizard/step1.ejs', {
                        title: 'ALARMiator | Setup',
                        navarea: 'setup',
                        session: req.session,
                        organizationsTypes: rowsOrganizationsTypes,
                        parentOrganizations: rowsOrganizations,
                        step: 1,
                        from: 10
                    });
                })
            })
        })        
    },
    step1Store: (req, res) => {
        const organizations = new Organizations();
        organizations.addOrganization(req.body, (success, id) => {
            if (success) {
                // successfully added organization
                res.redirect('/setup/step2/' + id);
            } else {
                // New organization could not be added
                res.redirect(req.headers.referer);
            }
        })
    },
    step2: (req, res) => {
        var orgId = req.params.id;
        var organizations = new Organizations();
        organizations.getOrganizationWithId(orgId, (rowsOrganizations) => {
            let orgname = rowsOrganizations[0].name;
            req.session.organizationId = orgId;
            res.render('setupwizard/step2.ejs', {
                title: 'ALARMiator | Setup | Schritt 2',
                navarea: 'setup',
                session: req.session,
                orgName: orgname,
                orgId: orgId,
                step: 2,
                from: 10
            });
        })
    },
    step2Store: (req, res) => {
        const locations = new Locations(req.app.logger);
        locations.addLocation(req.body, (success) => {
            if (success) {
                res.redirect('/setup/step3');
            } else {
                res.redirect(req.headers.referer);
            }
        })
    },
    step3: (req, res) => {
        var orgId = req.session.organizationId;
        var organizations = new Organizations();
        organizations.getOrganizationWithId(orgId, (rowsOrganizations) => {
            let orgname = rowsOrganizations[0].name;
            res.render('setupwizard/step2.ejs', {
                title: 'ALARMiator | Setup | Schritt 2',
                navarea: 'setup',
                session: req.session,
                orgName: orgname,
                orgId: orgId,
                step: 3,
                from: 10
            });
        })
    },
    
};