var express = require('express');
var training = express.Router();

// BASEDATA
// - Dashboard
const {getTrainingDashboard} = require('./training/dashboard');
const {getTrainingsList, getTrainingsListData} = require('./training/training');
const {editTrainingPage} = require('./training/training');
const {editTraining} = require('./training/training');
const {addTrainingPage} = require('./training/training');
const {addTraining} = require('./training/training');
const {deleteTraining} = require('./training/training');

// define the routes
training.get('/dashboard', getTrainingDashboard);
training.get('/dashboard/:calyear/:calmonth', getTrainingDashboard);
training.get('/trainings/list', getTrainingsList);
training.get('/trainings/list/data', getTrainingsListData);
training.get('/trainings/edit/:id', editTrainingPage);
training.post('/trainings/edit/:id', editTraining);
training.get('/trainings/add', addTrainingPage);
training.post('/trainings/add', addTraining);
training.get('/trainings/delete/:id', deleteTraining);

module.exports = training;