let trainingsObj = require('../../models/trainings');
const Calendar = require('../../models/calendar');

module.exports = {
    getTrainingDashboard: (req, res) => {

        let calMonth = req.params.calmonth;
        let calYear = req.params.calyear;
        
        let calendar = new Calendar();
        if ((typeof calMonth !== 'undefined') && (typeof calYear !== 'undefined')) {
            calendar.month = parseInt(calMonth);
            calendar.year = parseInt(calYear);
        } else {
            calMonth = new Date().getMonth()+1;
            calYear = new Date().getFullYear();
            calendar.month = calMonth;
            calendar.year = calYear;
        }

        var calHTML = calendar.getGridFor();
        
        let trainingshelper = new trainingsObj(req.app.logger);
        trainingshelper.getNextTraining((trainingResult) => {
            trainingshelper.getListOfTrainingsForCalendar(calMonth, calYear, (calendarRows) => {
                if (calendarRows.length > 0) {
                    var entryHTML = '';
                    calendarRows.forEach((trainRow) => {
                        var col = calendar.getColumnForDay(trainRow.day);
                        var row = calendar.getRowForDay(trainRow.day)+1;
                        entryHTML += calendar.addEntry(`${trainRow.title}</br>${trainRow.enddatetime}`, trainRow.state, col, row);
                    })
                }
                res.render('training/dashboard', {
                    title: 'ALARMiator | Training',
                    navarea: 'training',
                    subarea: 'calendar',
                    avatarpath: req.session.avatar,
                    name: req.session.name,
                    organizationname: req.session.organization,
                    session: req.session,
                    nextTraining: trainingResult,
                    calHTML: calHTML,
                    calEntrys: entryHTML,
                    actualMonth: calendar.monthName,
                    actualMonthInt: calMonth,
                    actualYear: calYear
                });
            })
        });
    }
};



