let organizations = require('../../models/organizations');
let basedata = require('../../models/basedata');
let trainingsObj = require('../../models/trainings');
let Trainings = require('../../models/trainings');

let trainingshelper = new trainingsObj();

let momentHelperObj = require('../../models/momenthelper');
let momenthelper = new momentHelperObj();

let moment = require('moment');


module.exports = {
    getTrainingsList: (req, res) => {
        res.render('training/trainings.ejs', {
            title: 'ALARMiator | Übungen',
            navarea: 'training',
            avatarpath: req.session.avatar,
            name: req.session.name,
            organizationname: req.session.organization,
            session: req.session,
        });
    },
    getTrainingsListData: (req, res) => {
        var trainings = new Trainings(req.app.logger);
        trainings.getListOfTrainingsForUI((rows) => {
            res.json({ data: rows })
        })
    },
    addTrainingPage: (req, res) => {
        let orgs = new organizations(req.app.logger);
        let bdata = new basedata(req.app.logger);
        let trainings = new Trainings(req.app.logger);
        orgs.getListOfOrganizations((resultOrgs) => {
            bdata.getListOfBasedata((resultBdata) => {
                trainings.getListOfTrainingsStatus((resutTrainingStatus) => {
                    res.render('training/trainings_add.ejs', {
                        title: 'ALARMiator',
                        navarea: 'training',
                        avatarpath: req.session.avatar,
                        name: req.session.name,
                        organizationname: req.session.organization,
                        session: req.session,
                        organizations: resultOrgs,
                        basedata: resultBdata,
                        trainingsstatus: resutTrainingStatus,
                        message: ''
                    });
                });
            });
        });
    },
    addTraining: (req, res) => {
        var trainings = new Trainings(req.app.logger);
        trainings.addTraining(req.body, (success) => {
            res.redirect('/training/trainings/list?add=training');
        })
    },
    editTrainingPage: (req, res) => {

        let orgs = new organizations(req.app.logger);
        let bdata = new basedata(req.app.logger);
        let trainings = new Trainings(req.app.logger);

        let trainingId = req.params.id;
        

        orgs.getListOfOrganizations(function (resultOrgs) {
            bdata.getListOfBasedataByOrganizations(function (resultBdata) {
                trainingshelper.getTrainingAttendeesforTrainingId(trainingId, (resultAttendees) => {
                    trainingshelper.getListOfTrainingsStatus((resultTrainingStatus) => {
                        trainings.getTraining(trainingId, (resultTraining) => {
                            res.render('training/trainings_edit.ejs', {
                                title: 'Edit  Training',
                                navarea: 'training',
                                avatarpath: req.session.avatar,
                                name: req.session.name,
                                organizationname: req.session.organization,
                                session: req.session,
                                training: resultTraining[0],
                                trainingsstatus: resultTrainingStatus,
                                organizations: resultOrgs,
                                basedata: resultBdata,
                                attendees: resultAttendees,
                                message: '',
                                moment: moment
                            });
                        });
                    });
                });
            });
        });
    },
    editTraining: (req, res) => {

        let trainingshelper = new trainingsObj(req.app.logger);
        let trainingId = req.params.id;
        let attendeesFromBody = req.body.attendees;

        let attendees = [];
        if (Array.isArray(attendeesFromBody)) {
            attendees = attendeesFromBody;
        } else {
            // Check if we find an integer value
            var attendeesInt = parseInt(attendeesFromBody);
            if (isNaN(attendeesInt)) {
                attendees = [];
            } else {
                attendees.push(attendeesInt);
            }
        }
        
        // Check if Attendees have been set. 
        // If so, write them to the database table
        trainingshelper.setTrainingAttendance(attendees, trainingId, req.session.basedataId, 1, (successAttendees) => {
            var trainings = new Trainings(req.app.logger);
            trainings.updateTraining(req.body, trainingId, (successUpdate) => {
                res.redirect('/training/trainings/list?edit=training');
            })
        });
    },
    deleteTraining: (req, res) => {
        let trainingId = req.params.id;
        var trainings = new Trainings(req.app.logger);
        trainings.removeTraining(trainingId, (success) => {
            res.redirect('/training/trainings/list?delete=training');
        })
    }
};