const Uploads = require('../../models/core/core_uploads');
const path = require('path');
const uuid = require('uuid').v1;

module.exports = {
    getUpload: (req, res) => {
        var uploadId = req.params.id;
        let uploads = new Uploads();
        uploads.getUpload(uploadId, (rowsUploads) => {
            if (rowsUploads != null) {
                if (rowsUploads.length > 0) {
                    var filepath = rowsUploads[0].filepath;
                    res.sendFile(path.join(__dirname, '../../' + filepath));
                }
            }
        })
    },
    /**
     * adds a new upload to a new object (with temporary uuid)
     * @param {object} req 
     * @param {object} res 
     */
    addUpload: (req, res) => {
        let uploads = new Uploads();
        var objectuuid = req.body.uuid;
        if (objectuuid === null) {
            objectuuid = null;
        }
        var objectId = req.body.objectId;
        if (objectId === null) {
            objectId = null;
        }
        var description = req.body.description;
        var type = req.body.type;


        var resJson = 
            { 
                success : 0,
                message : ''
            };
        

        console.log('ROUTE-UPLOADS | recieved attachment from client with type ' + type + ' for uuid ' + objectuuid + ' with description: ' + description);

        if ((typeof req.files !== 'undefined') && (req.files !== null)) {
            // We have files to be processed
            let uploadedFile = req.files.file;
            let filename = uploadedFile.name;
            let extension = path.extname(filename);
            let mimetype = uploadedFile.mimetype;

            // Generate uuid for having more or less unique filename for image
            var uuidFilename = uuid() + extension;
            var targetFileName = `uploads/${uuidFilename}`;
            uploadedFile.mv(targetFileName, (err) => {
                if (err) {
                    // error in moving uploaded file
                    resJson.success = 0;
                    resJson.message = 'error moving file on server';
                    res.json(resJson);
                } else {
                    // successfully moved file to target
                    uploads.addUpload(description, targetFileName, filename, mimetype, 'ASSETS', objectId, 'assets', 1, req.session.basedataId, objectuuid, (success) => {
                        if (success) {
                            resJson.success = 1;
                            resJson.message = 'ok';
                            resJson.filename = filename,
                            resJson.extension = extension
                            resJson.mimetype = mimetype
                            res.json(resJson);
                        } else {
                            resJson.success = 0;
                            resJson.message = 'error persisting new file upload at core database';
                            resJson.filename = filename,
                            resJson.extension = extension
                            resJson.mimetype = mimetype
                            res.json(resJson);
                        }
                    })
                   
                }
            });
        } else {
            // no file has been uploaded
            resJson.success = 0;
            resJson.message = 'no files sent to server';
            res.json(resJson);
        }
    },
    removeUpload: (req, res) => {
        var id = req.params.id;
        var referer = req.headers.referer;
        var uploads = new Uploads();
        uploads.removeUpload(id, (success) => {
            res.redirect(referer);
        })
    }

};



