module.exports = {
    getWallboard: (req, res) => {
        let queryGoogleMapsKey = "SELECT * FROM `configuration` WHERE keyword = 'googlemapskey'";
        global.coreDb.all(queryGoogleMapsKey, (err, resultConfig) => {
            if(err) {
                return res.status(500).send(err);
            }
            res.render('wallboard/wallboard', {
                title: 'ALARMiator | wallboard',
                googlemapskey: resultConfig[0]['value'],
                navarea: 'wallboard'
            });
        });
     },
     getOperationsList: (req, res) => {
        var resultOperations = [];
        
        let query = "SELECT operations.*,  operations_ressources.id AS ressoucreid, operations_ressources.nameraw AS ressourcenameraw, operations_ressources.namecustom AS ressourcenamecustom FROM `operations` LEFT JOIN operations_ressources ON operations.id = operations_ressources.operationid WHERE acknowledged = 0 ORDER BY timestampincome DESC";
        // execute query
        global.coreDb.all(query, (err, rows) => {
            if (err) {
                res.send(500);
            } else {
                if(rows.length > 0) {
                    // There is at least one not acknowledged operation
                    // Proceed with reading requsted ressources
                    
                    var result = [], index = {};

                    rows.forEach(function (row) {
                        if ( !(row.id in index) ) {
                            index[row.id] = {
                                id: row.id,
                                acknowledged: row.acknowledged,
                                operationguid: row.operationguid,
                                operationnumber: row.operationnumber,
                                timestampincome: row.timestampincome,
                                timestampalarm: row.timestampalarm,
                                messenger: row.messenger,
                                comment: row.comment,
                                plan: row.plan,
                                priority: row.priority,
                                einsatzortobject: row.einsatzortobject,
                                einsatzortzipcode: row.einsatzortzipcode,
                                einsatzortcity: row.einsatzortcity,
                                einsatzortstreet: row.einsatzortstreet,
                                einsatzortstreetnumber: row.einsatzortstreetnumber,
                                einsatzortintersection: row.einsatzortintersection,
                                einsatzortproperty: row.einsatzortproperty,
                                einsatzortGKcoordinates: row.einsatzortGKcoordinates,
                                einsatzortlat: row.einsatzortlat,
                                einsatzortlon: row.einsatzortlon,
                                zielortobject: row.zielortobject,
                                zielortzipcode: row.zielortzipcode,
                                zielortcity: row.zielortcity,
                                zielortstreet: row.zielortstreet,
                                zielortstreetnumber: row.zielortstreetnumber,
                                zielortintersection: row.zielortintersection,
                                zielortlat: row.zielortlat,
                                zielortlon: row.zielortlon,
                                keyword: row.keyword,
                                keywordmisc: row.keywordmisc,
                                rawjson: row.rawjson,
                                srcservice: row.srcservice,
                                ressources: []
                            };
                            result.push(index[row.id]);
                        }
                        index[row.id].ressources.push({
                            ressourceid: row.ressourceid,
                            ressourcenameraw: row.ressourcenameraw,
                            ressourcenamecustom: row.ressourcenamecustom
                        });
                    });
                    console.log(result);
                }                
                
                return res.send(Object.values(result));
                
            }
        });
     }
};



