const Parser = require('../../../plugins/inbound/katsys/parsers/parser_ILSLAU.js');

console.log('instanziating Parser...');
let parser = new Parser();
const moment = require('moment');


console.log('instanziared Parser!');

let sds_schleifen_delta = "24132 11:25, 24055 11:25";
          

function splitZVEIsDelta(sdsSchleifenDelta) {
    let datePart = moment().format('YYYY-MM-DD');
    let datePartYesterday = moment().subtract(1, 'days').format('YYYY-MM-DD');
    let zveiDeltaObj = [];
    if (sdsSchleifenDelta != null) {
        if (sdsSchleifenDelta.length > 0) {
            // split now and extract time
            
            // for cases where separator is "\n"
            // var sdsSchleifenDeltaArr = sdsSchleifenDelta.split('\n');
            // for cases where separator is ","
            var sdsSchleifenDeltaArr = sdsSchleifenDelta.split(',');
            if (Array.isArray(sdsSchleifenDeltaArr)) {
                // successfully separated zveis with time into array
                sdsSchleifenDeltaArr.forEach(zveiWithTime => {
                  zveiWithTime = zveiWithTime.trim();
                    let elementArr = zveiWithTime.split(' ');
                    if (elementArr.length == 2) {
                        // found 2 parts (zvei | time)
                        let timestamp = moment(datePart + ' ' + elementArr[1]).format('YYYY-MM-DDTHH:mm:ss');
                        let sameOrBefore = moment().add(1, 'minutes').isSameOrBefore(timestamp);
                        console.log('PARSING: zvei: ' + elementArr[0] + ' | time: ' + elementArr[1] + ' | timestamp: ' + timestamp + '| same or before now: ' + sameOrBefore);
                        if (sameOrBefore) timestamp = moment(datePartYesterday + ' ' + elementArr[1]).format('YYYY-MM-DDTHH:mm:ss');
                        let zveiDeltaElement = {
                            zvei: elementArr[0],
                            timestamp: timestamp
                        }
                        zveiDeltaObj.push(zveiDeltaElement);
                    } else if(elementArr.length == 1) {
                        console.log('WARNING: only zvei element found but no time: ' + zveiWithTime);
                        let zveiDeltaElement = {
                            zvei: elementArr[0],
                            timestamp: null
                        }
                        zveiDeltaObj.push(zveiDeltaElement);
                    } else {
                        console.log('ERROR: could not parse Delta-Zvei Information for Element: ' + zveiWithTime);
                    }
                });
            } else {
                // not an array, do nothing
                return [];
            }
        }
    }
    return zveiDeltaObj;
}

console.log(splitZVEIsDelta(sds_schleifen_delta));