const moment = require('moment');
let allElements = "24420 11:21,24423 11:21,24133 11:21,24401,24402 11:21,24440 14:21";
let deltaElements ="24420 11:21,24423 11:21,24133 11:21,24401";

let mode = "gear" // zvei or gear

let seperator;

switch(mode){
    case "zvei": 
        seperator = ',';
        break;
    case "gear":
        seperator = '\n';
        break;
    default:
        console.log("unknown mode!");

}

    let datePart = moment().format('YYYY-MM-DD');
    let datePartYesterday = moment().subtract(1, 'days').format('YYYY-MM-DD');
    let dataObj = [];
    let deltaArray = [];

    const timeRegex = /\d{2}:\d{2}[:\d{2}]*/gm;

    if (deltaElements != null) {
        if (deltaElements.length > 0) {
            deltaElements.split(seperator).forEach((element) => {
                deltaArray.push(element.replace(timeRegex,'').trim());
            })
        }
    }
    console.log("Deltaarray",deltaArray);

    if (allElements != null) {
        if (allElements.length > 0) {
            // split now and extract time
            // for cases where separator is ","
            var allElementsArr = allElements.split(seperator);
            if (Array.isArray(allElementsArr)) {
                // successfully separated zveis with time into array
                allElementsArr.forEach(elementWithTime => {
                    if (elementWithTime.match(timeRegex)) {
                        // has time
                        let elementString = elementWithTime.replace(timeRegex,'').trim();
                        let timeString = elementWithTime.match(timeRegex);

                        let timestamp = moment(datePart + ' ' + timeString).format('YYYY-MM-DDTHH:mm:ss');
                        let sameOrBefore = moment().add(1, 'minutes').isSameOrBefore(timestamp);
                        console.log('PARSING: element: ' + elementString + ' | time: ' + timeString + ' | timestamp: ' + timestamp + '| same or before now: ' + sameOrBefore);
                        if (sameOrBefore) timestamp = moment(datePartYesterday + ' ' + timeString).format('YYYY-MM-DDTHH:mm:ss');
                        
                        let newElement = true;

                        if (deltaArray.length > 0) {
                            newElement = deltaArray.includes(elementString);
                        } 
                        
                        let deltaElement = {
                            timestamp: timestamp,
                            new: newElement
                        }
                        deltaElement[mode] = elementString;

                        dataObj.push(deltaElement);

                    }
                    else {
                        // no time
                        let deltaElement = {
                            timestamp: null,
                            new: true
                        }
                        deltaElement[mode] = elementWithTime.replace(timeRegex,'').trim();
                        dataObj.push(deltaElement);
                        console.log('WARNING: only zvei / gear element found but no time: ' + elementWithTime);
                    }
                });
            } else {
                // not an array, do nothing
                return [];
            }
        }
    }
    console.log("Full Dataobject", dataObj);