const moment = require('moment');
let datePart = moment().format('YYYY-MM-DD');
let datePartYesterday = moment().subtract(1, 'days').format('YYYY-MM-DD');

let zveiDeltaObj = [];
let sdsSchleifenDelta = "24420 11:21\n24423 11:21\n24133 11:21\n24401\n24402 11:21\n24440 14:21";
console.log('------------------ SDS-CONTENT - SCHLEIFEN DELTA -------------');
console.log(sdsSchleifenDelta);
console.log('--------------------------------------------------------------');
if (sdsSchleifenDelta != null) {
    if (sdsSchleifenDelta.length > 0) {
        // split now and extract time
        sdsSchleifenDeltaArr = sdsSchleifenDelta.split('\n');
        if (Array.isArray(sdsSchleifenDeltaArr)) {
            // successfully separated zveis with time into array
            sdsSchleifenDeltaArr.forEach(zveiWithTime => {
                let elementArr = zveiWithTime.split(' ');
                if (elementArr.length == 2) {
                    // found 2 parts (zvei | time)
                    let timestamp = moment(datePart + ' ' + elementArr[1]).format('YYYY-MM-DDTHH:mm:ss');
                    let sameOrBefore = moment().add(1, 'minutes').isSameOrBefore(timestamp);
                    console.log('zvei: ' + elementArr[0] + ' | time: ' + elementArr[1] + ' | timestamp: ' + timestamp + '| same or before now: ' + sameOrBefore);
                    if (sameOrBefore) timestamp = moment(datePartYesterday + ' ' + elementArr[1]).format('YYYY-MM-DDTHH:mm:ss');
                    let zveiDeltaElement = {
                        zvei: elementArr[0],
                        timestamp: timestamp
                    }
                    zveiDeltaObj.push(zveiDeltaElement);
                } else if(elementArr.length == 1) {
                    console.log('WARNING: only zvei element found but no time: ' + zveiWithTime);
                    let zveiDeltaElement = {
                        zvei: elementArr[0],
                        timestamp: null
                    }
                    zveiDeltaObj.push(zveiDeltaElement);
                } else {
                    console.log('ERROR: could not parse Delta-Zvei Information for Element: ' + zveiWithTime);
                }
            });
        } else {
            // not an array, do nothing
        }
        
        console.log('------------------ RESULT --------------------');
        console.log(zveiDeltaObj);
    }
}